c
c        calcomp graphic subroutine library for PostScript printers
c
c
c        circle and ellipse are not included in calcomp
c        but are efficient to draw circles and ellipses
c        by apple laserwriter.  to fill a circle or ellipse
c        or poligon written by line with gray
c        call fillarea with ncol>0 before circle or
c        ellipse
c        line color and text color are set by setcol(ncol)
c        where ncol=hue*10+lightness
c      for ldev=1
c            hue=0 and ncol=lightness (0-10) (0:black, 10:white)
c      for ldev=2
c        define color map in HLS color indeces 
c        for tectronics 4510 seies rasterizer
c           ncol=0 means default or background color (white: ncol=10)
c              hue      lightness   satulation
c                        (lig)        (sat)
c           0 white        0              0
c           0 gray        1-10            0
c           1 blue        1-9            100
c           2 violet      1-9            100
c           3             1-9            100
c           4 magenta     1-9            100
c           5             1-9            100
c           6             1-9            100
c           7 red         1-9            100
c           8             1-9            100
c           9             1-9            100
c          10 yellow      1-9            100
c          11 lite greem  1-9            100
c          12             1-9            100
c          13 green       1-9            100
c          14             1-9            100
c          15             1-9            100
c          16 cyan        1-9            100
c          17             1-9            100
c          18             1-9            100
c
c*****************************************************************************
c     HLS color with lightness > 5 is simulated by sat=(1-sat)*2 in HBS color 
c*****************************************************************************
c
c                   lightness=0  a means black
c                   satulation=0 means gray
c                   background color =10  white
c                   black  = 1
c                   white  =10
c                   gray           ( 1- 9)
c                   blue   =15     (11-19)
c                   magenta=45     (41-29)
c                   red    =75     (71-39)
c                   yellow =105    (101-109)
c                   green  =135    (131-139)
c                   cyan   =165    (161-169)
c        increase of color index in each color increase darkness
c        for example 0 is white and 20 is black
      subroutine plots(x,y,dev)
      integer dev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      parameter (ibignum = 256)

      integer name, ldev
      common /calcmp/ name, ldev

      common /cplot/ xx(2),yy(2),idev
c     common /ccolor/ acol(20),bcol(10),ccol,dcol,kdsp,iplt
c     integer acol,bcol,ccol,dcol

      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      common /corien/ iorien
      integer gmode(4)
      integer apage, dpage
      common /cpage/ apage,dpage
c        apage: active page for nec pc98 color display
c        dpage: display page for nec pc98 color display
      common /cnopen/ nopen
      integer colmap(3,0:10,0:18)
      save itimes
      data iorien/1/
      data itimes/0/
      data gmode/3,2,0,1/
      data nopen/0/

      cr=char(13)
      nl=char(10)
      esc=char(27)
      write(trm,'(2a)') nl,' '
      if(itimes.eq.0) then
         apage=0
         dpage=17
      end if
      sigint = 2
c      junk = signal(sigint,psquit,-1)
      ldev = dev
      offsx=0
      offsy=0
      currx=0
      curry=0
      call sctbl
      if(ldev.eq.1.or.ldev.eq.2) then
         nopen=nopen+1
         call psopen(ldev,nopen,iorien)
         call fillarea(0)
c     
         call psout(ldev,'%*****begin program*****')
c     
         fact=1
         call psout(ldev,' 1 cm 1 cm scale ')
c     define world space
         if(iorien.eq.2) then
            call psout(ldev,'90 rotate')
            call psout(ldev,'0 -21.1 translate')
         end if
         call psout(ldev,'/cmtx matrix currentmatrix def')
         devx=21.1
         devy=29.7
         rdev=devx/devy
         if(iorien.eq.2) then
c     call cliparea(0.,0.,devy,devx)
c     call psout(ldev,'1 setgray fill')
            call window(0.,0.,devy,devx)
            call viewpt(0.,0.,1.,rdev)
         else
c     call cliparea(0.,0.,devx,devy)
c     call psout(ldev,'1 setgray fill')
            call window(0.,0.,devx,devy)
            call viewpt(0.,0.,rdev,1.)
         end if
         call psout(ldev,'clippath 1 setgray fill')
         call psout(ldev,' 0 setgray ')
         call setfont('/Courier-Bold')
         call newpen(0)
c     call fillcolor(10)  ==> setcol(0)  May 16, 1990
c     set default color (black)
         call setcol(0)
         call plot(x,y,-3)
         return
      else
         write(6,*) "ldev=",ldev," not allowd"
      end if
      return
      end

      subroutine plote(str)
      character*80 str
      integer name, ldev
      common /calcmp/ name, ldev
      common /corien/ iorien
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      integer apage, dpage
      common /cpage/ apage,dpage
      common /cnopen/ nopen
      if(ldev.eq.1.or.ldev.eq.2) then
          call psout(ldev,'showpage ')
          call psclose(ldev,nopen,iorien)
          return
      end if
      return
      end


      subroutine plot(x,y,ipen)
      integer name, ldev
      common /calcmp/ name, ldev
c     move the pen to (x,y)
c     abs(ipen)=2: pen down
c     abs(ipen)=3: pen up
c     ipen < 0: reset the origin at (x,y)
          if (ipen .eq. 2) then
              call thickl(x,y)
              call currps(x,y)
          else if(ipen .eq. 3) then
              call currps(x,y)
          else if(ipen .eq. -2) then
              call thickl(x,y)
              call offset(x,y)
              call currps(0.,0.)
          else if(ipen .eq. -3) then
              call offset(x,y)
              call currps(0.,0.)
          else if(ipen.gt.31) then
              call plote(' ')
              call plots(0.,0.,ldev)
          end if
      return
      end

      subroutine offset(x,y)
      real x,y
      common /cwndv/ x1v,y1v,x2v,y2v
      common /cwndw/ x1w,y1w,x2w,y2w
c        shift origin to x,y in the same viewport
      call window(x1w-x,y1w-y,x2w-x,y2w-y)
      call viewpt(x1v,y1v,x2v,y2v)
      return
      end

      subroutine currps(x,y)
      real x,y
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
          currx=x
          curry=y
      return
      end

      subroutine moveto(x,y)
      call plot(x,y,3)
      return
      end

      subroutine lineto(x,y)
      call plot(x,y,2)
      return
      end

      subroutine polfil(n,x,y)
      real x(*),y(*)
      call fillarea(1)
      inc=1
      ity=0
      mrk=0
      x(n+1)=0
      y(n+1)=0
      x(n+2)=1
      y(n+2)=1
      call plylin(x,y,n,inc,ity,mrk)
      return
      end

      subroutine rplprn(text,nchar)
      integer nchar
      character*(*) text
      character*256 ttxt
c     replace ( with \( and ) with \) if any
      if(nchar.gt.256) then
         call psquit('text is too long in rplprn')
      end if
      j=0
      do i=1,nchar
         if(text(i:i).ne.'('.and.text(i:i).ne.')') then
            j=j+1
            if(j.gt.256) then
               call psquit('text is too long in rplprn')
            end if
            ttxt(j:j)=text(i:i)
         else
            j=j+1
            ttxt(j:j)='\\'  ! for sun , Linux and DEC
c           ttxt(j:j)='\'   ! for hp 
            j=j+1         
            if(j.gt.256) then
               call psquit('text is too long in rplprn')
            end if
            ttxt(j:j)=text(i:i)
         end if
      end do

      nchar=j
      do i=1,nchar
         text(i:i)=ttxt(i:i)
      end do

c      write(6,*) text(1:nchar)
      return
      end

      subroutine symbol(x,y,h,text,angle,nchard)
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      integer hd
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 sx,sy,sh,sa
      character*80 str
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c

c      replace '(' with '\(' etc.
      nchar=nchard
      call rplprn(text,nchar)

      he=h/2
      xy(1)=x
      xy(2)=y
      if(ldev.eq.3) then
          call stmode(1)
          hd=h*fact
          write(1,'(2a,$)') esc,'MC'
          call intpar(hd*5/6)
          call intpar(hd)
          call intpar(hd/6)
          if(nchar.gt.0) then
              call plot(x,y,3)
              write(1,'(2a,$)') esc,'MR'
              iang=angle
              call intpar(iang)
              call intpar(0)
              write(1,'(2a,$)') esc,'LT'
              call intpar(nchar)
              write(1,'(a,$)') text(1:nchar)
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,text(1:1),he)
          end if
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          if(nchar.gt.0) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              if(nfnt.eq.0) then
                  call pack1(h*1.66,sh,nh)
                  nfnt=1
              else
                  call pack1(h/h0,sh,nh)
              end if
              call pack1(angle,sa,na)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)
     *        //' '//sa(1:na)//' ('//text(1:nchar)//') textout'
              call psout(ldev,str)
              h0=h
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,text(1:1),he)
          end if
      end if
      return
      end

      subroutine rsymbol(x,y,h,text,angle,nchard)
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      integer hd
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 sx,sy,sh,sa
      character*80 str
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c

c      replace '(' with '\(' etc.
      nchar=nchard
      call rplprn(text,nchar)

      he=h/2
      xy(1)=x
      xy(2)=y
      if(ldev.eq.3) then
          call stmode(1)
          hd=h*fact
          write(1,'(2a,$)') esc,'MC'
          call intpar(hd*5/6)
          call intpar(hd)
          call intpar(hd/6)
          if(nchar.gt.0) then
              call plot(x,y,3)
              write(1,'(2a,$)') esc,'MR'
              iang=angle
              call intpar(iang)
              call intpar(0)
              write(1,'(2a,$)') esc,'LT'
              call intpar(nchar)
              write(1,'(a,$)') text(1:nchar)
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,text(1:1),he)
          end if
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          if(nchar.gt.0) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              if(nfnt.eq.0) then
                  call pack1(h*1.66,sh,nh)
                  nfnt=1
              else
                  call pack1(h/h0,sh,nh)
              end if
              call pack1(angle,sa,na)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)
     *        //' '//sa(1:na)//' ('//text(1:nchar)//') rtextout'
              call psout(ldev,str)
              h0=h
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,text(1:1),he)
          end if
      end if
      return
      end

      subroutine supscr(h,text,nchard)
c       write superscript
      real h
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 str
      character*80 sh
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c

c      replace '(' with '\(' etc.
      nchar=nchard
      call rplprn(text,nchar)

      if(nfnt.eq.0) then
         call pack1(h*1.66,sh,nh)
         nfnt=1
      else
         call pack1(h/h0,sh,nh)
      end if
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              str=' '//sh(1:nh)//' ('//text(1:nchar)//') supshow'
              call psout(ldev,str)
          else
             call psquit('nchar < 0 in supscr')
          end if
      end if
      return
      end

      subroutine subscr(h,text,nchard)
c       write suberscript
      real h
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 str
      character*80 sh
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c

c      replace '(' with '\(' etc.
      nchar=nchard
      call rplprn(text,nchar)

      if(nfnt.eq.0) then
         call pack1(h*1.66,sh,nh)
         nfnt=1
      else
         call pack1(h/h0,sh,nh)
      end if
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              str=' '//sh(1:nh)//' ('//text(1:nchar)//') subshow'
              call psout(ldev,str)
          else
             call psquit('nchar < 0 in subscr')
          end if
      end if
      return
      end

      subroutine plntxt(h,text,nchard)
c       write plain text
      real h
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 str
      character*80 sh
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c

c      replace '(' with '\(' etc.
      nchar=nchard
      call rplprn(text,nchar)

      if(nfnt.eq.0) then
         call pack1(h*1.66,sh,nh)
         nfnt=1
      else
         call pack1(h/h0,sh,nh)
      end if
      if(ldev.eq.1.or.ldev.eq.2) then
          if(nchar.gt.0) then
              str=' '//sh(1:nh)//' ('//text(1:nchar)//') txtshow'
              call psout(ldev,str)
          else
             call psquit('nchar < 0 in subscr')
          end if
      end if
      return
      end

      subroutine csymbol(x,y,h,text,angle,nchard)
      character*(*) text
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      integer hd
      real he,xy(2)
      character trm*2,cr,nl,esc
      character*80 sx,sy,sh,sa
      character*80 str
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     text: text string to be printed
c     angle: angle in degree
c     nchar: number of characters in the string
c

c     replace '(' with '\(' etc.
      nchar=nchard
      call rplprn(text,nchar)

      he=h/2
      xy(1)=x
      xy(2)=y
      if(ldev.eq.3) then
          call stmode(1)
          hd=h*fact
          write(1,'(2a,$)') esc,'MC'
          call intpar(hd*5/6)
          call intpar(hd)
          call intpar(hd/6)
          if(nchar.gt.0) then
              call plot(x,y,3)
              write(1,'(2a,$)') esc,'MR'
              iang=angle
              call intpar(iang)
              call intpar(0)
              write(1,'(2a,$)') esc,'LT'
              call intpar(nchar)
              write(1,'(a,$)') text(1:nchar)
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,text(1:1),he)
          end if
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          if(nchar.gt.0) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              if(nfnt.eq.0) then
                  call pack1(h*1.66,sh,nh)
                  nfnt=1
              else
                  call pack1(h/h0,sh,nh)
              end if
              call pack1(angle,sa,na)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)
     *        //' '//sa(1:na)//' ('//text(1:nchar)//') ctextout'
              call psout(ldev,str)
              h0=h
              return
          else if(nchar.eq.-1.or.nchar.eq.-2) then
               if(nchar.le.-2) then
                   call plot(x,y,2)
               end if
               call cntsym(x,y,text(1:1),he)
          end if
      end if
      return
      end

      subroutine fraction(x,y,h,c1,c2)
      character*(*) c1,c2
      real x,y,h
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character*80 sx,sy,sh
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

      if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
c
c     x, y: coordinates of the starting point of the string in cm
c     h: hight in cm
c     c1: numerator
c     c2: denominator
c
          call pack1(x,sx,nx)
          call pack1(y,sy,ny)
          call pack1(h,sh,nh)
          call setfont('/Helvetica')
          call psout(ldev,sh(1:nh)//' scalefont setfont ')
          call psout(ldev,sx(1:nx)//' '//sy(1:ny)//' moveto ')
          call psout(ldev,'(')
          call psout(ldev,c1)
          call psout(ldev,')')
          call psout(ldev,' (')
          call psout(ldev,c2)
          call psout(ldev,') fractionshow ')
          return
      end if
      return
      end

      subroutine setfont(fkey)
      character*(*) fkey
      integer name, ldev
      common /calcmp/ name, ldev
      common /csymbl/ nfnt,h0
      character*80 str

      if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
c
c     fkey: font key (/Helvetica, /Times-Roman, /Times-Italic etc.)
c
c          call psout(ldev,fkey)
          lstr=len(fkey)
          str(1:lstr)=fkey
          call psout(ldev,str(1:lstr)//' findfont setfont')
          nfnt=0
      end if
      return
      end

      subroutine arrow(x,y,h1,h2,w,ang,kind)
      real x,y,h1,h2,w
      real tailx,taily,tipx,tipy,wlin,warrw,headl

      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 sx1,sx2,sy1,sy2,sh1,sw1,sw2
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

      if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
c     x,y:  coordinates of taile position
c     h1:   length of the arrow
c     h2:   length of the arrow head
c     w:    linewidth
c     ang:  angle in deg
c     kind: 1: arrow for two-fold axis, 2: screw axis
          ff=pi/180
          tailx=x
          taily=y
          tipx=(x+h1*cos(ang*ff))
          tipy=(y+h1*sin(ang*ff))
          wlin=w
          warrw=5*w
          headl=h2
          call pack1(tailx,sx1,nx1)
          call pack1(taily,sy1,ny1)
          call pack1(tipx,sx2,nx2)
          call pack1(tipy,sy2,ny2)
          call pack1(wlin,sw1,nw1)
          call pack1(warrw,sw2,nw2)
          call pack1(headl,sh1,nh1)
          if(kind.eq.1) then
               call psout(ldev,sx1(1:nx1)//' '//sy1(1:ny1)//' '//
     *         sx2(1:nx2)//' '//sy2(1:ny2)//' '//sw1(1:nw1)//' '//
     *         sw2(1:nw2)//' '//sh1(1:nh1)//
     *         ' arrow1 ')
          else if(kind.eq.2) then
               call psout(ldev,sx1(1:nx1)//' '//sy1(1:ny1)//' '//
     *         sx2(1:nx2)//' '//sy2(1:ny2)//' '//sw1(1:nw1)//' '//
     *         sw2(1:nw2)//' '//sh1(1:nh1)//
     *         ' arrow2 ')
          end if
          return
      end if
      return
      end

      subroutine cliparea(x1,y1,x2,y2)
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      character*80 sx1,sx2,sy1,sy2
      common /plot1/ trm,cr,nl,esc
      data pi/3.141592/

      if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
c     x,y:  coordinates
          call pack1(x1,sx1,nx1)
          call pack1(x2,sx2,nx2)
          call pack1(y1,sy1,ny1)
          call pack1(y2,sy2,ny2)
          call psout(ldev,sx1(1:nx1)//' '//sy1(1:ny1)//' '//
     *            sx2(1:nx2)//' '//sy2(1:ny2)//' '//' cliparea ')
      end if
      return
      end

      subroutine number(x,y,h,num,angle,ndec)
      real x,y,h,num,angle
      integer ndec

      character*80 text, otext
      integer name, ldev
      common /calcmp/ name, ldev

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      data pi/3.141592/

c     x,y : coordinates of the starting point of the number in cm
c     h   : hight of the font in cm
c     num : the value of the number to be printed
c     angle : angle in degree
c     ndec : the number of characters after '.'
c
      if(ndec.ge.0) then
            if(ndec.eq.0) write(unit = text,fmt= '(f12.0)') num
            if(ndec.eq.1) write(unit = text,fmt= '(f12.1)') num
            if(ndec.eq.2) write(unit = text,fmt= '(f12.2)') num
            if(ndec.eq.3) write(unit = text,fmt= '(f12.3)') num
            if(ndec.eq.4) write(unit = text,fmt= '(f12.4)') num
            if(ndec.eq.5) write(unit = text,fmt= '(f12.5)') num
            if(ndec.eq.6) write(unit = text,fmt= '(f12.6)') num
            if(ndec.eq.7) write(unit = text,fmt= '(f12.7)') num
            if(ndec.eq.8) write(unit = text,fmt= '(f12.8)') num
            if(ndec.eq.9) write(unit = text,fmt= '(f12.9)') num
      else
            inum = num*10**(ndec+1)
            write(unit = text,fmt= '(i12)') inum
      end if
c     compress space
      j = 0
      do 100 i=1,12
      if(text(i:i).ne.' ') then
           j = j + 1
           otext(j:j) = text(i:i)
      end if
 100  continue
      otext(j+1:j+1) = char(0)

      if(ldev.eq.3) then
           call stmode(1)
           call symbol(x,y,h,otext,angle,j)
           return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
           call symbol(x,y,h,otext,angle,j)
          return
      end if
      return
      end

      subroutine thickl(x,y)
      real x,y
      real dx,dy,dr,cost,sint,x1,x2,y1,y2,w
      character*8 scx,scy,sx,sy
      integer name, ldev
      common /calcmp/ name, ldev
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx, offsy, currx, curry, fact
      data eps/0.0001/
c       draw thick line
c     pcol: current pen color
c     pwdt: current pen width
      w=pwdt
      x1=currx
      y1=curry
      x2=x
      y2=y
      if(ldev.eq.5) then
          write(1,100) esc,x1,-y1,x2,-y2,pcol,cr
 100      format(a1,'>LINE (',f6.2,',',f6.2,')-(',f6.2,',',f6.2,'),',
     *                            i1,a1)
          return
      else if(ldev.eq.3) then
          call stmode(1)
          if(w.gt.0.01) then
               dx=x2-x1
               dy=y2-y1
               dr=sqrt(dx**2+dy**2)
               if(dr.lt.eps) return
               cost=dx/dr
               sint=dy/dr
               dx=-w*sint/2
               dy= w*cost/2
c              begin panel boundary
               write(1,'(2a,$)') esc,'LP'
               call encode(x1+dx,y1+dy)
               write(1,'(a,$)') '0'
               write(1,'(2a,$)') esc,'LG'
               call encode(x2+dx,y2+dy)
               write(1,'(2a,$)') esc,'LG'
               call encode(x2-dx,y2-dy)
               write(1,'(2a,$)') esc,'LG'
               call encode(x1-dx,y1-dy)
               write(1,'(2a,$)') esc,'LG'
               call encode(x1+dx,y1+dy)
c                    end panel boundary
               write(1,'(2a,$)') esc,'LE'
          else
               write(1,'(2a,$)') esc,'LF'
               call encode(x1,y1)
               write(1,'(2a,$)') esc,'LG'
               call encode(x2,y2)
          end if
          return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          call pack1(x1,scx,ncx)
          call pack1(y1,scy,ncy)
          call pack1(x2,sx,nx)
          call pack1(y2,sy,ny)
          call psout(ldev,scx(1:ncx)//' '//scy(1:ncy)//' '//
     *                  sx(1:nx)//' '//sy(1:ny)//' plt')
          return
      end if
      return
      end

      subroutine plylin(x,y,n,inc,ity,mrk)
      dimension x(*),y(*)
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 str,sxd,syd
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      integer ifill
      common /cfill/ ifill
      integer icol,jcol
      common /ccol/ icol,jcol
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      data eps/0.0001/, imax/500/

      x1=(x(1)-x(n+1))/x(n+2)
      y1=(y(1)-y(n+1))/y(n+2)
      if(ldev.eq.5) then
          if(n.le.1) return
          do 30 i=1,n-1
          if(i.eq.1) then
             write(1,100) esc,x(i),-y(i),x(i+1),-y(i+1),icol,cr
 100         format(a1,'>LINE(',f6.2,',',f6.2,')-(',f6.2,',',
     *                                       f6.2,'),',i1,a1)
          else
             write(1,110) esc,x(i+1),-y(i+1),icol,cr
 110         format(a1,'>LINE -(',f6.2,',',f6.2,'),',i1,a1)
          end if
 30       continue
          return
      else if(ldev.eq.3) then
           call stmode(1)
           if(ifill.eq.1) then
c                begin panel boundary
                 write(1,'(2a,$)') esc,'LP'
                 call encode(x1,y1)
           else
c                call plot(x1,y1,3)
                 write(1,'(2a,$)') esc,'LF'
                 call encode(x1,y1)
           end if
           if(inc.lt.0) then
              inc2=1
           else
              inc2=inc
           end if
           do 11 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
c             call plot(xd,yd,2)
              write(1,'(2a,$)') esc,'LG'
              call encode(xd,yd)
   11      continue
           if(ifill.eq.1) then
c             call plot(x1,y1,2)
              write(1,'(2a,$)') esc,'LG'
              call encode(x1,y1)
c             end panel boundary
              write(1,'(2a,$)') esc,'LE'
           end if
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
           call psout(ldev,'newpath ')
           if(inc.lt.0) then
              inc2=1
           else
              inc2=inc
           end if
           dst=sqrt((x(1)-x(n))**2+(y(1)-y(n))**2)
           do 20 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
              call pack1(xd,sxd,nx)
              call pack1(yd,syd,ny)
              if(i.eq.1) then
                  call psout(ldev,sxd(1:nx)//' '//syd(1:ny)//' mvt')
              else
                  call psout(ldev,sxd(1:nx)//' '//syd(1:ny)//' lnt')
              end if
              if(mod(i,1000*inc2).eq.0) then
                  call psout(ldev,'stroke ')
                  call psout(ldev,'newpath ')
                  j=i-inc2
                  xd=(x(j)-x(n+1))/x(n+2)
                  yd=(y(j)-y(n+1))/y(n+2)
                  call pack1(xd,sxd,nx)
                  call pack1(yd,syd,ny)
                  write(str,'(4a)') sxd(1:nx)//' '//syd(1:ny)//' mvt'
                  call psout(ldev,str)
              end if
 20        continue
c          call setcol(icol)
           if(ifill.eq.1) then
               call psout(ldev,'closepath ')
               call psout(ldev,'fill ')
           else if(dst.lt.eps) then
               call psout(ldev,'closepath ')
               call psout(ldev,'stroke ')
           else
               call psout(ldev,'stroke ')
           end if
           return
      end if

      return
      end

      subroutine gpl(n,x,y)
      integer n
      real x(*),y(*)
      x(n+1)=0.
      x(n+2)=1.
      y(n+1)=0.
      y(n+2)=1.
      call plylin(x,y,n,1,0,0)
      return
      end

      subroutine newpen(ipen)
      integer ipen
c     change pen or color
      integer name, ldev
      common /calcmp/ name, ldev
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      character trm*2,cr,nl,esc
      character*80 str
      common /plot1/ trm,cr,nl,esc
      save ipeno
      data ipeno/-1/
      if(ldev.eq.5) then
           if(ipen.eq.0) then
               pcol = 1
           else
               pcol = ipen
           end if
           return
      else if(ldev.eq.3) then
           if(ipen.eq.0) then
              pwdt=0.02
           else
              pwdt=ipen/100.0
           end if
           return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
c          ipen/100 cm linewidth is used
           if(ipen.eq.0) then
               call pack1(2/100.0,str,ns)
           else
               call pack1(ipen/100.0,str,ns)
           end if
           if(ipen.ne.ipeno) then
               call psout(ldev,str(1:ns)//' setlinewidth ')
               ipeno=ipen
           end if
           return
      end if
      return
      end

      subroutine factor(facfig)
c     change the scale of the figure around the origin
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character*80 str
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      if(ldev.eq.3) then
          fact=facfig*fact
          return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          write(str,'(2f9.3,a)') facfig,facfig,' scale '
          call psout(ldev,str)
          return
      end if
      return
      end

      subroutine fillarea(n)
      integer n
      integer ifill
      common /cfill/ ifill
      integer name, ldev
      common /calcmp/ name, ldev

      if(ldev.eq.5) then
           ifill = n
           return
      else if(ldev.eq.3) then
           ifill = n
           return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
           ifill = n
           return
      end if
      end

      subroutine fillcolor(n)
      integer n
      integer icol,jcol
      common /ccol/ icol,jcol
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 sx, sh, ss, sb
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      real hue, sat, brt
c           ncol=0 means default or background color (white: ncol=10)
c              hue      lightness   satulation
c           0 white        0              0
c           0 gray        1-10            0
c           1 blue        1-9            100
c           2 violet      1-9            100
c           3             1-9            100
c           4 magenta     1-9            100
c           5             1-9            100
c           6             1-9            100
c           7 red         1-9            100
c           8             1-9            100
c           9             1-9            100
c          10 yellow      1-9            100
c          11 lite greem  1-9            100
c          12             1-9            100
c          13 green       1-9            100
c          14             1-9            100
c          15             1-9            100
c          16 cyan        1-9            100
c          17             1-9            100
c          18             1-9            100
c                   lightness=0 or a means black or white
c                   satulation=0 means gray
c                   background color =10  white
c                   black  = 1
c                   white  =10
c                   gray           ( 1- 9)
c                   blue   =15     (11-19)
c                   magenta=45     (41-29)
c                   red    =75     (71-39)
c                   yellow =105    (101-109)
c                   green  =135    (131-139)
c                   cyan   =165    (161-169)
      if(ldev.eq.5) then
           icol = n
           return
      else if(ldev.eq.3) then
           if(n.ne.icol) then
               write(1,'(2a,$)') esc,'MP'
               call intpar(-n)
               icol = n
           end if
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
           if(n.ne.icol) then
               if(n.le.9) then
                 hue=0
                 sat=0
                 brt=float(n)/10
               else if(n.eq.10) then
                 hue=0
                 sat=0
                 brt=1
               else
                  hue=float(n/10)/18
c                 if(hue.le.6) then
c                    hue=hue+float(12)/18
c                 else
c                    hue=hue-float(6)/18
c                 end if
c                 sat=1
c                 brt=float(mod(n,10))/10
                 if(hue.le.6) then
                    hue=float(n/10)/18
c                   hue=1/18 means blue  => 12/18
                    hue=mod(hue+float(11)/18,1.)
                 else
                    hue=float(n/10)/18
c                   hue=7/18 means red
                    hue=hue-float(7)/18
                 end if
                 brt=float(mod(n,10))/10
                 if(brt.gt.0.5) then
                    sat=(1-brt)*2
                 else
                    sat=1
                 end if
                 brt=min(brt*2,1.)
               end if
               if(ldev.eq.1.or.ldev.eq.4) then
                   call pack1(brt,sx,nx)
                   call psout(ldev,sx(1:nx)//' setgray ')
               else if(ldev.eq.2) then
                   call pack1(hue,sh,nh)
                   call pack1(sat,ss,ns)
                   call pack1(brt,sb,nb)
                   sx=sh(1:nh)//' '//ss(1:ns)//' '//sb(1:nb)
                   nx=nh+ns+nb+2
                   call psout(ldev,sx(1:nx)//' sethsbcolor ')
               end if
               icol = n
               jcol = n
           end if
           return
      end if
      end


      subroutine linecolor(n)
      integer n
      integer icol,jcol
      common /ccol/ icol,jcol
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 sx, sh, ss, sb
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      real hue, sat, brt

      if(ldev.eq.5) then
           jcol = n
           return
      else if(ldev.eq.3) then
           if(n.ne.jcol) then
c             set text color
               write(1,'(2a,$)') esc,'MT'
               call intpar(n)
c             set line color
               write(1,'(2a,$)') esc,'ML'
               call intpar(n)
               jcol = n
           end if
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
           if(n.ne.jcol) then
               if(n.le.9) then
                 hue=0
                 sat=0
                 brt=float(n)/10
               else if(n.eq.10) then
                 hue=0
                 sat=0
                 brt=1
               else
                 hue=float(n/10)/18
                 if(hue.le.6) then
                    hue=hue+float(12)/18
                 else
                    hue=hue-float(6)/18
                 end if
                 sat=1
                 brt=float(mod(n,10))/10
               end if
               if(ldev.eq.1.or.ldev.eq.4) then
                   call pack1(brt,sx,nx)
                   call psout(ldev,sx(1:nx)//' setgray ')
               else if(ldev.eq.2) then
                   call pack1(hue,sh,nh)
                   call pack1(sat,ss,ns)
                   call pack1(brt,sb,nb)
                   sx=sh(1:nh)//' '//ss(1:ns)//' '//sb(1:nb)
                   nx=nh+ns+nb+2
                   call psout(ldev,sx(1:nx)//' sethsbcolor ')
               end if
               icol = n
               jcol = n
           end if
           return
      end if
      end

      subroutine setcol(n)
      integer name, ldev
      common /calcmp/ name, ldev
      if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          call fillcolor(n)
      else
          call fillcolor(n)
          call linecolor(n)
      end if
      return
      end
      
      subroutine paint(x,ncol,bcol)
      dimension x(3)

      integer name, ldev
      common /calcmp/ name, ldev
      common /cplot/ xx(2),yy(2),idev

      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      integer bcol

      if(ldev.eq.5) then
          write(1,110) esc,x(1),-x(2),ncol,bcol,cr
 110      format(a1,'>PAINT(',f6.2,',',f6.2,'),',i1,',',i1,a1)
          return
      end if
      return
      end

      subroutine circle(ang1,ang2,rc,xy,jmod)
      real ang1,ang2,rc,xy(3)
      character*80 sx,sy,sr,s1,s2
      integer name, ldev
      common /calcmp/ name, ldev

      integer ifill
      common /cfill/ ifill
      common /sct/ sint(0:100),cost(0:100)
      integer icol,jcol
      common /ccol/ icol,jcol

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev

      integer t1,t2,ti
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      real xd,yd,rd
      real pi2, eps
      save pi2, eps
      data pi2 /6.28318/, eps/0.0001/

c         ang1: start angle in degree(0<=ang1<=360)
c         ang2: end angle in degree    (0<=ang1<=ang2<=360)
c         rc: radius
c         xy: center of a circle (x, y, z  in the plotter system)
c         jmod: 0 connect beginning with end point when ifill=1
c               1 connect beginning and end point with the center
c                 for ifill=0,1
      fct=pi2/360
      xs=xy(1)+rc*cos(ang1*fct)
      ys=xy(2)+rc*sin(ang1*fct)
      xe=xy(1)+rc*cos(ang2*fct)
      ye=xy(2)+rc*sin(ang2*fct)
      if(ldev.eq.5) then
          if(ang1.le.eps.and.ang2.ge.1-eps) then
c             full circle
              write(1,110) esc,xy(1),-xy(2),rc,icol,cr
 110          format(a1,'>CIRCLE(',f6.2,',',f6.2,'),',f5.3,',',i1,a1)
          else
c             arc
              write(1,100) esc,xy(1),-xy(2),rc,icol,ang1*fct,ang2*fct,cr
 100          format(a1,'>CIRCLE(',f6.2,',',f6.2,'),',f5.3,',',i1,',',
     *        f5.3,',',f5.3,a1)
              if(jmod.eq.1) then
                   call plot(xy(1),xy(2),2)
                   call plot(xs,xs,2)
              end if
          end if
          if(ifill.ge.1) then
              call paint(xy(1),icol,icol)
          end if
          return
      else if(ldev.eq.3) then
          call stmode(1)
          call setcol(icol)
          if(rc.ge.1) then
              istp=1
          else
              istp=min(int(1/rc),20)
          end if
          r1=rc
          r2=rc
c           0-359 => 0-99
          t1=ang1/3.6
          t2=ang2/3.6
          if(t1.eq.t2) return
          if(t1.gt.t2) t2=t2+100
          x0=xy(1)
          y0=xy(2)
          ti=mod(t1,100)
          xd=x0+r1*cost(ti)
          yd=y0+r1*sint(ti)
          if(ifill.eq.1) then
c             begin panel boundary
              write(1,'(2a,$)') esc,'LP'
              call encode(xd,yd)
          else
c             call plot(xd,yd,3)
              write(1,'(2a,$)') esc,'LF'
              call encode(xd,yd)
          end if
          do 200 i=t1,t2+1,istp
              ti=mod(i,100)
              xp=x0+r1*cost(ti)
              yp=y0+r1*sint(ti)
c             call plot(xp,yp,2)
              write(1,'(2a,$)') esc,'LG'
              call encode(xp,yp)
 200      continue
          if(jmod.eq.1) then
c             call plot(xy(1),xy(2),2)
              write(1,'(2a,$)') esc,'LG'
              call encode(x0,y0)
c             call plot(xd,yd,2)
              write(1,'(2a,$)') esc,'LG'
              call encode(xd,yd)
          end if
          if(ifill.eq.1) then
c             call plot(xd,yd,2)
              if(jmod.eq.0) then
                  write(1,'(2a,$)') esc,'LG'
                  call encode(xd,yd)
              end if
c             end panel boundary
              write(1,'(2a,$)') esc,'LE'
          end if
          return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          xd=xy(1)
          yd=xy(2)
          rd=rc
c         call setcol(icol)
          call psout(ldev,'newpath ')
          call pack1(xd,sx,nx)
          call pack1(yd,sy,ny)
          call pack1(rd,sr,nr)
          call pack1(ang1,s1,n1)
          call pack1(ang2,s2,n2)
          call psout(ldev,sx(1:nx)//' '//sy(1:ny)//' '//
     *    sr(1:nr)//' '//s1(1:n1)//' '//s2(1:n2)//' arc ')
          if(jmod.eq.1) then
              call plot(xy(1),xy(2),2)
              call plot(xs,xs,2)
          end if
          if(ifill.ge.1) then
              call psout(ldev,'fill ')
          else
              call psout(ldev,'stroke ')
          end if
          return
      end if
      return
      end

      subroutine box(x1,y1,x2,y2)
      real x(7),y(7)
      integer ifill
      common /cfill/ ifill
      x(1)=x1
      y(1)=y1
      x(2)=x2
      y(2)=y1
      x(3)=x2
      y(3)=y2
      x(4)=x1
      y(4)=y2
      x(5)=x(1)
      y(5)=y(1)
      x(6)=0.
      y(6)=0.
      x(7)=1.
      y(7)=1.
      call plylin(x,y,5,1,0,0)
      end

      subroutine ellipse(ang1,ang2,ang3,rc1,rc2,xy,ncol)
      real ang1,ang2,ang3,rc1,rc2,xy(*)
      integer ncol

      integer name, ldev
      common /calcmp/ name, ldev

      integer ifill
      common /cfill/ ifill

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      character*80 str
      real xd,yd,rd1,rd2
      real pi2, eps
      save pi2, eps
      data pi2 /6.28318/, eps/0.0001/

c         ang1: start angle from first princial axis in degree
c         ang2: end angle in degree
c         ang3: rotation angle of ellipse  in degree
c            if ang3=0 first and second principal axes are
c            taken along x and y axes in the plinter
c         rc1: radius along the first principal axis
c         rc2: radius along the second principal axis
c         xy: center of an ellipse (x, y  in the plotter system)
c         ncol: fill color 0 black 10 white 1-9 gray
c
      if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          xd=xy(1)
          yd=xy(2)
          rd1=rc1
          rd2=rc2
          a1=ang1
          a2=ang2
          a3=ang3
          call setcol(ncol)
          call psout(ldev,'newpath ')
          write(str,'(7f9.3,a)') xd,yd,rd1,rd2,a1,a2,a3,' ellipse '
          call psout(ldev,str)
          if(ifill.ge.1) then
              call psout(ldev,'fill ')
          else
              call psout(ldev,'stroke ')
          end if
          return
      end if
      return
      end

      subroutine atom(x,y,r,col,xl,yl)
      integer col
c       x,y: x,y cordinates in cm
c       r  : radius of atom in cm
c       col: color
c       xl,yl: direction cosine of light direction
      character*80 str
      cl=mod(col/10.,1.0)
      write(str,'(7f9.3,a)') x,y,r,cl,0.02,xl,yl,' atom '
      call psout(ldev,str)
      return
      end

      subroutine tssput(n,buf)
      character*80 buf
      integer n
      write(6,'(a)') buf(1:n)
      return
      end

      subroutine gipcc1(x1,y1,r1,x2,y2,r2,xc,yc,n,ill)
      real x1,y1,r1,x2,y2,r2,xc(2),yc(2)
      integer n,ill

      real xd1,yd1,xd2,yd2
      real dist,cosd,sind,cosn,sinn,dn,eps
      data eps /0.001/

      dist = sqrt((x2-x1)**2+(y2-y1)**2)
      cosd = (x2-x1)/dist
      sind = (y2-y1)/dist
      cosn = -sind
      sinn = cosd

      if(dist.gt.r1+r2) then
           n=0
           ill = 0
           return
      else if(dist+min(r1,r2).lt.max(r1,r2)) then
           n=0
           ill = 0
           return
      else if(abs(dist-r1-r2).lt.eps) then
           n=1
           ill = 1
           d1=-(r2**2-r1**2-dist**2)/(2*dist)
           xc(1)=x1+cosd*d1
           yc(1)=y1+sind*d1
           return
      else if(abs(dist+min(r1,r2)-max(r1,r2)).lt.eps) then
           n=1
           ill = 1
           d1=-(r2**2-r1**2-dist**2)/(2*dist)
           xc(1)=x1+cosd*d1
           yc(1)=y1+sind*d1
           return
      else
           n=2
           ill = 1
           d1=-(r2**2-r1**2-dist**2)/(2*dist)
           dn=sqrt(r1**2-d1**2)
           xd1=x1+cosd*d1+cosn*dn
           yd1=y1+sind*d1+sinn*dn
           xd2=x1+cosd*d1-cosn*dn
           yd2=y1+sind*d1-sinn*dn

           if(xd1.lt.xd2) then
                xc(1)=xd1
                yc(1)=yd1
                xc(2)=xd2
                yc(2)=yd2
           else if(xd1.gt.xd2) then
                xc(1)=xd2
                yc(1)=yd2
                xc(2)=xd1
                yc(2)=yd1
           else
                if(yd1.lt.yd2) then
                      xc(1)=xd1
                      yc(1)=yd1
                      xc(2)=xd2
                      yc(2)=yd2
                else
                      xc(1)=xd2
                      yc(1)=yd2
                      xc(2)=xd1
                      yc(2)=yd1
                end if
           end if
           return
      end if
      return
      end

      subroutine sctbl
      common /sct/ sint(0:100),cost(0:100)
      do 10 i=0,100
      x=6.28318*i/100.0
      sint(i)=sin(x)
 10   cost(i)=cos(x)
      return
      end

      subroutine psquit(str)
      character*(*) str
      write(6,*) str
      call plote('end of plot')
      call exit()
      end

      subroutine lntyp(ity)
      integer name, ldev
      common /calcmp/ name, ldev 
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      save lty
      data lty/0/

      if(ity.ne.lty.and.ldev.eq.3) then
          lty=ity
          if(ity.eq.0) then
c          solid line
              write(1,'(2a,i1,$)') esc,'ML',0
          else if(ity.eq.10) then
c          dash line
              write(1,'(2a,i1,$)') esc,'ML',3
          else if(ity.eq.20) then
c          dot line
              write(1,'(2a,i1,$)') esc,'ML',1
          else if(ity.eq.30) then
c          dash and dot
              write(1,'(2a,i1,$)') esc,'ML',2
          end if
      end if
      if(ity.ne.lty.and.(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4)) then
          lty=ity
          if(ity.eq.0) then
c          solid line
              call psout(ldev,'[] 0 setdash ')
          else if(ity.eq.10) then
c          dashed line
              call psout(ldev,'[0.2 0.2] 0 setdash ')
          else if(ity.eq.20) then
c          doted line
              call psout(ldev,'[0.05 0.1] 0 setdash ')
          else if(ity.eq.30) then
c          dash and dot
              call psout(ldev,'[0.2 0.15 0.05 0.15 ] 0 setdash ')
          end if
      end if
      return
      end

      subroutine line(x,y,n,inc,ity,mrk)
      dimension x(*),y(*)
      integer name, ldev
      common /calcmp/ name, ldev

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx, offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      character*80 sxd,syd
      character*2000 buf
      character cinc*6,cmrk,ctyp*2,wjmod*2
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      write(cmrk,'(i1)') abs(mrk)
      write(cinc,'(i6)') inc
      write(ctyp,'(i2)') ity

      he=0.16
      if(ldev.eq.5.or.ldev.eq.3) then
          call plot(xd,yd,3)
          if(inc.lt.0) then
             inc2=1
          else
             inc2=inc
          end if
          do 10 i=1,n,inc2
             xd=(x(i)-x(n+1))/x(n+2)
             yd=(y(i)-y(n+1))/y(n+2)
             if(i.eq.1.or.ity.lt.0) then
                 call plot(xd,yd,3)
             else
                 call plot(xd,yd,2)
             end if
             if(ity.ne.0) then
                  call cntsym(xd,yd,cmrk,he)
             end if
 10       continue
          return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          call psout(ldev,'newpath ')
c          if(inc.lt.0) then
             inc2=1
c          else
c             inc2=inc
c          end if
          np=0
          do 20 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
              call pack1(xd,sxd,nx)
              call pack1(yd,syd,ny)
              buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
              np=np+nx+ny+2
              if(mod(i,50).eq.0) then
                  if(i.eq.50) then
                     write(wjmod,'(i2)') 50
                  else
                     write(wjmod,'(i2)') 50+1
                  end if
                  buf(np+1:np+13)=wjmod//' '//ctyp//' '//cmrk
     *                                   //' '//'line '
                  np=np+13
                  if(np.gt.2000) then
                     call psquit('buf full in subroutine line')
                  end if
                  call psout(ldev,buf(1:np))
                  call psout(ldev,'stroke ')
                  call psout(ldev,'newpath ')
                  np=0
                  buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
                  np=np+nx+ny+2
              end if
20         continue  
           jmod=mod(n,50)
           if(jmod.ne.0) then
               if(n.lt.50) then
                  write(wjmod,'(i2)') jmod
               else
                  write(wjmod,'(i2)') jmod+1
               end if
               buf(np+1:np+13)=wjmod//' '//ctyp//' '//cmrk
     *                                   //' '//'line '
               np=np+13
               if(np.gt.2000) then
                  call psquit('buf full in subroutine line')
               end if
               call psout(ldev,buf(1:np))
               call psout(ldev,'stroke ')
           end if
           return
      end if
      end

c     subroutine line(x,y,n,inc,ity,mrk)
c       he: size of the center symbol
      subroutine line1(x,y,n,inc,ity,mrk,he)
      dimension x(*),y(*)
      integer name, ldev
      common /calcmp/ name, ldev

      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx, offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      character*80 sxd,syd,che
      character*2000 buf
      character cinc*6,cmrk,ctyp*2,wjmod*2
      integer pcol
      common /cpcol/ pcol
      real pwdt
      common /cpwdt/ pwdt
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc

      write(cmrk,'(i1)') abs(mrk)
      call pack1(he,che,nh)
      write(cinc,'(i6)') inc
      write(ctyp,'(i2)') ity
      if(ldev.eq.5.or.ldev.eq.3) then
          call plot(xd,yd,3)
          if(inc.lt.0) then
             inc2=1
          else
             inc2=inc
          end if
          do 10 i=1,n,inc2
             xd=(x(i)-x(n+1))/x(n+2)
             yd=(y(i)-y(n+1))/y(n+2)
             if(i.eq.1.or.ity.lt.0) then
                 call plot(xd,yd,3)
             else
                 call plot(xd,yd,2)
             end if
             if(ity.ne.0) then
                  call cntsym(xd,yd,cmrk,he)
             end if
 10       continue
          return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
          call psout(ldev,'newpath ')
c          if(inc.lt.0) then
             inc2=1
c          else
c             inc2=inc
c          end if
          np=0
          do 20 i=1,n,inc2
              xd=(x(i)-x(n+1))/x(n+2)
              yd=(y(i)-y(n+1))/y(n+2)
              call pack1(xd,sxd,nx)
              call pack1(yd,syd,ny)
              buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
              np=np+nx+ny+2
              if(mod(i,50).eq.0) then
                  if(i.eq.50) then
                     write(wjmod,'(i2)') 50
                  else
                     write(wjmod,'(i2)') 50+1
                  end if
                  buf(np+1:np+15+nh)=wjmod//' '//ctyp//' '//cmrk
     *                      //' '//che(1:nh)//' '//'line1 '
                  np=np+15+nh
                  if(np.gt.2000) then
                     call psquit('buf full in subroutine line1')
                  end if
                  call psout(ldev,buf(1:np))
                  call psout(ldev,'stroke ')
                  call psout(ldev,'newpath ')
                  np=0
                  buf(np+1:np+nx+ny+2)=sxd(1:nx)//' '//syd(1:ny)//' '
                  np=np+nx+ny+2
              end if
20       continue  
           jmod=mod(n,50)
           if(jmod.ne.0) then
               if(n.lt.50) then
                  write(wjmod,'(i2)') jmod
               else
                  write(wjmod,'(i2)') jmod+1
               end if
               buf(np+1:np+15+nh)=wjmod//' '//ctyp//' '//cmrk
     *                      //' '//che(1:nh)//' '//'line1 '
               np=np+15+nh
               if(np.gt.2000) then
                  call psquit('buf full in subroutine line1')
               end if
               call psout(ldev,buf(1:np))
               call psout(ldev,'stroke ')
           end if
           return
      end if
      end

      subroutine cntsym(x,y,n,he)
      character n
      real x,y,he,xy(3)
      integer name, ldev
      common /calcmp/ name, ldev
      character*80 sx,sy,sh,str
      hh=he/2
      if(n.eq.'1') then
c         vertical bar "|"
          if(ldev.eq.3) then
              call plot(x,y-hh,3)
              call plot(x,y+hh,2)
              call plot(x,y,3)
          else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              call pack1(he,sh,nh)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)//' vvar '
              call psout(ldev,str)
          end if
      else if(n.eq.'3') then
c         plus sign "+"
          if(ldev.eq.3) then
              call plot(x,y-hh,3)
              call plot(x,y+hh,2)
              call plot(x-hh,y,3)
              call plot(x+hh,y,2)
              call plot(x,y,3)
          else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
              call pack1(x,sx,nx)
              call pack1(y,sy,ny)
              call pack1(he,sh,nh)
              str=sx(1:nx)//' '//sy(1:ny)//' '//sh(1:nh)//' pls '
              call psout(ldev,str)
          end if
      else
c         small circle "o"
          call fillarea(0)
          xy(1)=x
          xy(2)=y
          call circle(0.,360.,hh,xy,0)
          call plot(x,y,3)
      end if
      return
      end

      subroutine draw(x1,y1,x2,y2)
      real x(4), y(4)
      x(1)=x1
      x(2)=x2
      x(3)=0.
      x(4)=1.
      y(1)=y1
      y(2)=y2
      y(3)=0.
      y(4)=1.
      call line(x,y,2,1,0,0)
      return
      end

      subroutine axis(xmin,ymin,leng,delta,ang,iside,hght)
      real ax(4),ay(4),leng
      data pi2/6.28318/
c        write a scale for an axis
c        xmin, ymin: coordinates of the first scale
c        leng : length of the axis
c        ang: angle from hrizontal line (deg)
c        delta: increments of scale
      ax(3)=0.0
      ay(3)=0.0
      ax(4)=1.0
      ay(4)=1.0
      im=leng/delta+0.001
      do 60 i=0,im
           ax(1)=xmin+delta*float(i)*cos(pi2*ang/360)
           ay(1)=ymin+delta*float(i)*sin(pi2*ang/360)
c           ax(2)=ax(1)-0.1*sin(pi2*ang/360)*sign(1,iside)
c           ay(2)=ay(1)+0.1*cos(pi2*ang/360)*sign(1,iside)
           ax(2)=ax(1)-hght*sin(pi2*ang/360)*sign(1,iside)
           ay(2)=ay(1)+hght*cos(pi2*ang/360)*sign(1,iside)
 60        call line(ax,ay,2,1,0,0)
      return
      end

      subroutine encode(x,y)
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
*************************************************************
c      encode routine for tectronics 4510 seies rasterizer
*************************************************************
      ix=x*fact
      iy=y*fact
      call intpar(ix)
      call intpar(iy)
      return
      end

      subroutine intpar(ix)
      implicit integer (d,e)
      character lol,hil
      character*6 str,ostr
      integer ix
***********************************************************
c      encode routine for tectronics 4510 seies rasterizer
******************************************************
*  this routine is machine-dependent and applicable  *
*             only to the ascii code machine         *
******************************************************
      d1x=mod(abs(ix),16)
      if(ix.lt.0) then
          d1x=d1x+32
      else
          d1x=d1x+48
      end if
      lol=char(d1x)
      nchar=1
      str(nchar:nchar)=lol
      d2x=abs(ix)/16
 10   continue
      if(d2x.ne.0) then
          d3x=d2x/64
          d2x=mod(d2x,64)+64
          hil=char(d2x)
          nchar=nchar+1
          str(nchar:nchar)=hil
          d2x=d3x
          go to 10
      end if
      do 100 i=1,nchar
      ostr(i:i)=str(nchar-i+1:nchar-i+1)
 100  continue
      write(1,'(a,$)') ostr(1:nchar)
      return
      end

      subroutine realpr(x)
*************************************************************
c      encode routine for tectronics 4510 seies rasterizer
c     x should be -32767=-2**15 to 32767=2**15
*************************************************************
      ix=x*2**15
      call intpar(ix)
      call intpar(-15)
      return
      end
      
      subroutine stmode(ix)
c       set status of tektronix mode
      save itmode
      data itmode /0/
      if(ix.ne.itmode) then
         itmode=ix
         if(ix.eq.1) then
             write(1,'(a,$)') char(31)
         else if(ix.eq.2) then
             write(1,'(a,$)') char(29)
         else if(ix.eq.3) then
             write(1,'(a,$)') char(28)
         else
             write(1,'(a,$)') char(31)
         end if
      end if
      return
      end

      subroutine window(x1,y1,x2,y2)
      real x1,y1,x2,y2
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      common /cwndw/ x1w,y1w,x2w,y2w
      common /plot1/ trm,cr,nl,esc
      character trm*2,cr,nl,esc
c       save current window for viewpt() and offset()
          x1w=x1
          y1w=y1
          x2w=x2
          y2w=y2
      if(ldev.eq.1.or.ldev.eq.2) then
          call psout(ldev,'cmtx setmatrix initclip')
      else if(ldev.eq.5) then
          write(1,110) esc,'WINDOW',x1,y1,x2,y2,cr
 110      format(a1,a,'(',f6.2,',',f6.2,')-(',f6.2,',',
     *                         f6.2,')',a1)
          return
      else if(ldev.eq.3) then
          write(1,'(2a,$)') esc,'RW'
          call encode(x1,y1)
          call encode(x2,y2)
          return
      else if(ldev.eq.4) then
c         return to the world space
          call psout(ldev,'cmtx setmatrix initclip')
      end if
      return
      end

      subroutine viewpt(x1,y1,x2,y2)
      real x1,y1,x2,y2
      integer name, ldev
      common /calcmp/ name, ldev
      real offsx,offsy,currx,curry,fact
      common /plot2/ offsx,offsy, currx, curry, fact
      common /cplot/ xx(2),yy(2),idev
      character trm*2,cr,nl,esc
      common /plot1/ trm,cr,nl,esc
      common /cwndv/ x1v,y1v,x2v,y2v
      common /cwndw/ x1w,y1w,x2w,y2w
c      character*8 srx,sry,stx,sty,sx1,sx2,sy1,sy2
       character*8 sxw,syw,srx,sry,sx1,sy1,sx2,sy2
c       save current viewport for offset()
          x1v=x1
          y1v=y1
          x2v=x2
          y2v=y2
      if(ldev.eq.5) then
          fct=640
          write(1,110) esc,'VIEW',x1*fct,y1*fct,x2*fct,y2*fct,cr
 110      format(a1,a,'(',f6.2,',',f6.2,')-(',f6.2,',',
     *                         f6.2,')',a1)
          return
      else if(ldev.eq.3) then
          fct=29.7
          write(1,'(2a,$)') esc,'RV'
          call encode(x1*fct,y1*fct)
          call encode(x2*fct,y2*fct)
          return
      else if(ldev.eq.1.or.ldev.eq.2.or.ldev.eq.4) then
c         set viewing transformation matrix
c           fct fct scale
c           x1 y1 translate
c           rx ry scale
c           -x1w -y1w translate
          rx=(x2-x1)/(x2w-x1w)
          ry=(y2-y1)/(y2w-y1w)
          call pack1(-x1w,sxw,nxw)
          call pack1(-y1w,syw,nyw)
          call pack1(rx,srx,nrx)
          call pack1(ry,sry,nry)
          call pack1(x1,sx1,nx1)
          call pack1(y1,sy1,ny1)
          call pack1(x2,sx2,nx2)
          call pack1(y2,sy2,ny2)
          call psout(ldev,'29.7 29.7 scale '
     *            //sx1(1:nx1)//' '//sy1(1:ny1)//' translate '
     *            //srx(1:nrx)//' '//sry(1:nry)//' scale '
     *            //sxw(1:nxw)//' '//syw(1:nyw)//' translate ')
          call cliparea(x1w,y1w,x2w,y2w)
          call psout(ldev,'clip ')
          call psout(ldev,'% view '//sx1(1:nx1)//' '//sy1(1:ny1)//
     *               ' '//sx2(1:nx2)//' '//sy2(1:ny2))
      end if
      return
      end

      subroutine orient(n)
      common /corien/ iorien
c      n=1: portrait mode
c      n=2: landscape mode
      iorien=n
      return
      end

      subroutine pack1(x,sxy,n)
      real x
      character*(*) sxy
      character*8 value

      write(value,'(f8.3)') x
      call pack2(value,is,ie)
      write(sxy,'(a)') value(is:ie)
      n=ie-is+1
      end

      subroutine pack2(value,is,ie)
      character*8 value
      integer is,ie
      if (value .eq. '   0.000' .or. value .eq. '    .000') then
         is=4
         ie=4
         value(4:4)='0'
         return
      end if
      do 10 j=1,4
         if (value(j:j) .ne. ' ' .and. value(j:j) .ne. '0') then
            go to 1
         end if
   10 continue
    1 is=j
      if (value(6:8) .eq. '000') then
         ie=4
      else
         do 20 j=8,7,-1
            if (value(j:j) .ne. '0') then
               go to 2
            end if
   20    continue
    2    ie=j
      end if
      return
      end

      subroutine sviewa(isn,iwi,ibi)
      integer isn,iwi,ibi
c       isn: surface number 1 or -1
c       iwi: wipe index   -1, 0<iwi<256
c       ibi: border index  -1, 0<iwi<256
      write(1,'(2a,$)') esc,'RA'
      call intpar(isn)
      call intpar(iwi)
      call intpar(ibi)
      return
      end

      subroutine psout(ldev,str)
      character*(*) str
      integer ldev,bufl
      parameter (BUFLEN=256)
      character*256 out
      data IPSOUT /12/

      bufl=BUFLEN-1
      len0=len(str)
      do i=len0,1,-1
         if(str(i:i).ne.' ') go to 10
      end do
 10   continue
c     i: address of last character
      if(i.eq.len0) then
         leng=i
      else
         leng=i+1  ! the last blank is necessary
      end if
      is=leng/bufl       ! number of lines - 1
      len1=leng-bufl*is  ! number of character in the last line
c     write(6,*) 'leng,is,len1=',leng,is,len1
      do i=0,is-1
         call strcpy(out,str,1,bufl*i+1,bufl)
         write(IPSOUT,'(a,$)') out(1:bufl)
      end do
      if(len1.gt.0) then
         call strcpy(out,str,1,bufl*is+1,len1)
         write(IPSOUT,'(a)') out(1:len1)
      end if
      return
      end

      subroutine setnfil(nfd)
      integer nfd
      common /cnfil/ nfil
      nfil=nfd
      return
      end

      subroutine psopen(ldev,nopen,orien)
      integer ldev, nopen, orien
      character*3 nf
      common /cnfil/ nfil
      parameter (MAXPATH=50)
      character*50 pathnm
      common /cpathn/ pathnm
      character*7 PSFIL
      data IPSOUT /12/
      data PSFIL /'calcomp'/
      data nfil /1/

      nfd=mod(nopen-1,nfil)+1
      if(nfd.ge.1.and.nfd.lt.10) then
         lnf=1
         write(nf,'(i1)') nfd
      else if(nfd.ge.10.and.nfd.lt.100) then
         lnf=2
         write(nf,'(i2)') nfd
      else if(nfd.ge.100.and.nfd.lt.1000) then
         lnf=3
         write(nf,'(i3)') nfd
      end if         
      if(ldev.eq.1.or.ldev.eq.2) then
         call strcpy(pathnm,PSFIL,1,1,7)
         lpath=7+1
         call strcpy(pathnm,nf,lpath,1,lnf)
         lpath=lpath+lnf
         call strcpy(pathnm,".ps",lpath,1,3)
c        write(6,*) '*****pathnm=',pathnm
      end if
      open(unit=IPSOUT,file=pathnm,status='UNKNOWN')
      call gprimv(1)
      return
      end

      subroutine psclose(ldev,nopen,iorien)
      data IPSOUT /12/
      close(unit=IPSOUT)
      return
      end

      subroutine psflush(ldev)
      return
      end

      subroutine gprimv(ldev)
      parameter (MAXPATH=50)
      character*50 pathnm
      common /cpathn/ pathnm
      parameter (BUFLEN=256)
      character*256 bufd
      integer bufl
      character*50 GPRIM
c      include "gprimf.h"
      data IPSIN /11/
      data IPSOUT /12/

      bufl=BUFLEN-1
      len0=len(bufd)
      call getenv('CLCMPPATH', GPRIM)
      ilen=jstrln(GPRIM)
      GPRIM=GPRIM(1:ilen)//'/gprim.ps'
c      write(6,*) GPRIM, ilen
      open(unit=IPSIN,file=GPRIM,status='OLD',err=100)
 10   continue
      read(unit=IPSIN,fmt='(a)',end=20) bufd
      do i=len0,1,-1
         if(bufd(i:i).ne.' ') go to 30
      end do
 30   continue
c     i: address of last character
      if(i.eq.len0) then
         leng=i
      else
         leng=i+1  ! the last blank is necessary
      end if

      write(unit=IPSOUT,fmt='(a)') bufd(1:leng)
c      write(unit=6,fmt='(a)') bufd(1:leng)
      go to 10
 20   continue
      close(unit=IPSIN)
      return
 100  write(6,*) 'can not open ',GPRIM
      stop
      end

      subroutine strcpy(str1,str2,iadr1,iadr2,ilen)
      character*(*) str1,str2
      do i=1,ilen
         j=iadr1+i-1
         k=iadr2+i-1
         str1(j:j)=str2(k:k)
      end do
      return
      end

      subroutine getzap()
      return
      end

      function jstrln(c)
      character*(*) c
      l=len(c)
      do 10 i=l,1,-1
      if(c(i:i).ne.' ') then
          jstrln=i
          return
      end if
 10   continue
      jstrln=0
      return
      end
