c     
c                    plot modulation function
c                         input data
c     (00) jcont
c          jcont: equivalent to icont in REMOS input file
c     (01) flmn0
c          flmn0: filename of the input file for REMOS
c     (02) ngm, noc, ldev
c          ngm: number of graphs
c          noc: number of copys
c          ldev: 1 sun3 bitmap display
c                2 NEC PC-98
c                3 graphtechk plotter
c                4 apple laser printer
c                default ngm=1,noc=1,ldev=1
c     (03) jx,jy : x and y axes 
c       jx: (1 td, 2 ud, 3 vd) for jy=4  otherwise (1 t, 2 u, 3 v)
c       jy: (1:x,2:y,3:z,4:d,5:b,6:p,7:b11,8:b22,9:b33,10:b23,11:b31,12:b12)
c            r: the interatomic distance of a specified pair (see (07))
c     (04) a,b,cosc,amagn,irl
c          a,b:length of x and y axes
c          cos(angle)
c          amagn: magnification for x,y axes and shift (see (06))
c          if left-hand system  irl=1
c     (05) amin,amax,bmin,bmax,diva,divb 
c         default 0., 1., 0., 1., 0.1, 0.1
c     (06) ipm,ns,ne,shiftb,shifta
c         ipm: number of plots in a figure   (1<=ipm<=100)
c         ns: xs=amin+(ns-1)/200 starting point of the plot (1<=ns<=601)
c         ne: xe=amin+(ne-1)/200 ending point of the plot (1<=ns<=601)
c         shiftb: shift before the plot
c         shifta: shift after the plot
c   
c             default ns=1, and ne=201
c             shifta=(0, (bmax-bmin)*b+2)
c     (07)   natm,iso,ict,ictr,atr,kln  (*)
c            natm    : atom number
c            iso     : symmetry operator number
c            ict     : inversion after symmetry operation
c            ictr    : additional ictr-th centering translation 
c            atr(1)-atr(3)  : additional translation added to the symmetry op.
c            kln     : kind of line  1: solid 2: dashed 3: dotted
c                          operation or inversion
c            if(jy=4) natm-atr follows for second atom of the pair
c            repeat (07) ipm times
c       (03)-(07) repeat by ngm times (nog number of graphs)
c
c     limitting condition
c      ilm.le.100
c
c
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
c     common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3),hj(601,3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3,3),hj(601,3,3)
      common /cwflag/ iwflag(6)
      common /cdim/ idm,nde
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      dimension ax(50000)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      integer dspmdl,tmpmdl,sctmdl
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *,ix13
      common /cpm/ pm(6,6),wpm(6,6,3)
      character*80 flnm0, flnm1, flnm2, flnm3, flnm4
      integer defiwf(6)
      data zmtrx /1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6/
c    memory design  (the large array, ax, are devided into 25 parts
c    and each part is used as a different array in several subroutines)
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p, ax(ix1):x1
c  ax(ix1):xx, ax(ix2):mx, ax(ix3):ea, ax(ix4):xjl, ax(ix5):bjl,
c  ax(ix6):fjl, ax(ix7):csb, ax(ix8):ja, ax(ix9):ifrt1, ax(ix10):ifrt2
c  ax(ix11):coeff, ax(ix12):x1
      mmax=50000
      pai2=6.28318

      call setinp(5)
      call freadi('jcont=',1,jcont,1)
c      call freadi('job=',1,job,0)
c      call freadi('inpu=',1,inpu,0)
      inpu=0
c      write(6,'(1h ,3(a,i3))') 'jcont=',jcont,' job=',job,
      write(6,'(1h ,3(a,i3))') 'jcont=',jcont
c     *                           ' inpu=',inpu
      if(inpu.eq.0) then
          read(5,'(a)') flnm0
          lfn0=istrln(flnm0)
          write(6,'(1h ,a)') flnm0(1:lfn0)
          inpu=2
          open(unit=inpu,file=flnm0)
      else
          inpu=5
      end if
      call setinp(inpu)
      call setout(6)
      call setskp(1)
      call getinp(inpu)
      call getout(iout)
c (0) read output control flags
c     read(inpu,'(6i1)') (iwflag(i),i=1,6)
      call freadi('iwflag=',6,iwflag,1)
      if(iwflag(1).eq.0) then
           do 9 i=1,6
 9         iwflag(i)=defiwf(i)
      end if
      write(iout,'(1h ,a,6i3)') 'output control flags  ', iwflag
      read(inpu,'(a)') flnm1
      read(inpu,'(a)') flnm2
      read(inpu,'(a)') flnm3
      read(inpu,'(a)') flnm4
      lfn1=istrln(flnm1)
      lfn2=istrln(flnm2)
      lfn3=istrln(flnm3)
      lfn4=istrln(flnm4)
      write(iout,'(1h ,a)') flnm1(1:lfn1)
      write(iout,'(1h ,a)') flnm2(1:lfn2)
      write(iout,'(1h ,a)') flnm3(1:lfn3)
      write(iout,'(1h ,a)') flnm4(1:lfn4)
      open(unit=3,file=flnm1)
      open(unit=4,file=flnm2)
      open(unit=91,file=flnm3,access='direct',recl=1200)
      open(unit=92,file=flnm4,access='direct',recl=800)
      call rdlc
c      read(inpu,'(i3)') na
      call freadi('na=',1,na,1)
      call freadi('nsub=',1,nsub,0)
      if(nsub.le.0.or.nsub.gt.3) call quit('*** nsub invalid***')
      if(nsub.ge.2) then
          call freadi('zmtrx=',6,zmtrx(1,2),0)
      end if
      if(nsub.eq.3) then
          call freadi('zmtrx=',6,zmtrx(1,3),0)
      end if
      if(iwflag(3).eq.1) then
           write(6,*) 'na=',na,' nsub=',nsub,
     *        (' zmtrx=',(zmtrx(i,n),i=1,6),n=2,nsub)
      end if
      na1=1
      na2=na+na1
      na3=na+na2
      na4=6*na+na3
      na5=49*na+na4
      na6=49*na+na5
      na7=na+na6
      na8=na+na7
      na9=na+na8
c     call rdap(na,isft,x,b,p,isub)
      call rdap(na,ax(na1),ax(na3),ax(na6),ax(na7),ax(na8))
c     call rdsymo(na,isk)
      call rdsymo(na,ax(na4))
      call getgij(zmtrx,nsub)
      call gettrm(zmtrx,nsub)
      call btobij(na,ax(na6),ax(na8))
c     call sitesy(na,mpl,x,isk,irs,isub)
      call sitesy(na,ax(na2),ax(na3),ax(na4),ax(na5),ax(na8))
c     call getpm(pm)
      call setpm
*************************
      ilm(1)=1
      ilm(2)=1
      ilm(3)=1
c     ilc(1)=1
c     ilc(2)=1
c     ilc(3)=1
c     nl=200
      if(icorc(1).eq.1) then     
          ilm(1)=200
      else if(icorc(2).eq.1) then
          ilm(2)=200
      else if(icorc(3).eq.1) then
          ilm(3)=200
      end if
*************************
       call freadi('ix=',1,ix,1)
       call freadi('ib=',1,ib,0)
       call freadi('if=',1,if,0)
       call freadi('nds=',1,nds,0)
       call freadi('nzc=',1,nzc,0)
       call freadi('nw=',1,nw,0)
       call freadi('nt=',1,nt,0)
       call freadi('ipol=',1,ipol,0)
       call freadi('ipnf1=',1,ipnf1,0)
       call freadi('ipnf2=',1,ipnf2,0)
       call freadi('itvr=',1,itvr,0)
       call freadi('itst=',1,itst,0)
       call freadi('nxmax=',1,nxmax,0)
*************
       nds=0
*************
      if(nxmax.eq.0) nxmax=250
      write(6,207) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,
     *        itst,nxmax
c      read(inpu,'(4i3)') dspmdl,tmpmdl,sctmdl,itempf
      call freadi('dspmdl=',1,dspmdl,1)
      call freadi('tmpmdl=',1,tmpmdl,0)
      call freadi('sctmdl=',1,sctmdl,0)
      call freadi('itempf=',1,itempf,0)
      call freadi('itwin=',1,itwin,0)
      call freadi('iphfl=',1,iphfl,0)
      call freadi('isext=',1,isext,0)
      write(6,206) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
      call cnstnt(mmax,iax)
      if(iax.gt.0) go to 20

      call dmmdpl(ax(na3),ax(na6),ax(na7),ax(na8),ax(ix1),ax(ix2),
     *   ax(ix3),ax(ix4),ax(ix5),ax(ix6),ax(ix7),ax(ix8),ax(ix9),
     *   ax(ix10),ax(ix11),ax(ix12),nx,na,nl,nw,nt,nzc,it,jcont)
      close(unit=4)
      stop
 20   write(6,200) iax
      stop
 200  format(1h ,'lack of dimension',10x,'ax=',i6)
 206  format(1h ,'dspmdl=',i3,3x,'tmpmdl=',i3,3x,'sctmdl=',i3,3x,
     *      'itempf=',i3,3x,'itwin=',i3,3x,'iphfl=',i3,3x,'isext=',i3)
 207  format(1h ,'ix=',i3,2x,'ib=',i3,2x,'if=',i3,2x,'nds=',i3,2x,
     *      'nzc=',i3,2x,'nw=',i3,2x,'nt=',i3,2x,'ipol=',i3,2x,'ipnf1=',
     *    i3,2x,'ipnf2=',i3,2x,'itvr=',i3,2x,'itst=',i3,2x,'nxmax=',i3)
      end

      subroutine setpm
c     get inverse of the projection matrix and wpm
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      common /cpm/ pm(6,6),wpm(6,6,3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      dimension bb(6),ipv(6),ind(6,2),piv(6),unm(6,6),pmd(6,6)
      do i=1,6
         do k=1,6
            if(i.eq.k) then
               pm(i,k)=1
            else
               pm(i,k)=0
            end if
         end do
      end do
      do j=1,nde
         do k=1,3
            pm(3+j,k)=-y(k,j,1)
         end do
      end do
      do i=1,6
         do j=1,6
            pmd(i,j)=pm(i,j)
         end do
      end do
      write(6,*) 'pmd'
      do i=1,6
         write(6,'(6f8.4,2x,6f8.4)') (pm(i,j),j=1,6)
      end do
      call matinv(pm,6,idm,bb,0,det,ipv,ind,piv)
      do ns=1,nsub
         do i=1,6
            call getzx(zmtrx(1,ns),pm(1,i),wpm(1,i,ns))
         end do
      end do
      if(nsub.eq.1) then
         k=1
      else
         k=2
      end if
      write(6,*) 'pm and wpm'
      do i=1,6
         write(6,'(6f8.4,2x,6f8.4)') (pm(i,j),j=1,6),(wpm(i,j,k),j=1,6)
      end do
      write(6,*) 'pm*pmd'
      call mplmtr(pm,pmd,unm,6)
      do i=1,6
         write(6,'(6f8.4,2x,6f8.4)') (unm(i,j),j=1,6)
      end do
      return
      end

      subroutine cnstnt(mmax,iax)
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *,ix13
c      common /bgn/ ilm(3),icorc(3),ilc(3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3,3),hj(601,3,3)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /cdim/ idm,nde
c      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(24)
c     *     ,dt(24,6)
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
c    memory design  (the large array, ax, are devided into 25 parts
c    and each part is used as a different array in several subroutines)
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p, ax(ix1):x1
c  ax(ix1):xx, ax(ix2):mx, ax(ix3):ea, ax(ix4):xjl, ax(ix5):bjl,
c  ax(ix6):fjl, ax(ix7):csb, ax(ix8):ja, ax(ix9):ifrt1, ax(ix10):ifrt2
c  ax(ix11):coeff, ax(ix12):x1
c*********************************************************
c    calculation of constants for memory design
c*********************************************************
      pai2=6.28318
      nl=1
      do 10 i=1,nde
 10   nl=nl*ilm(i)
      do 11 i=1,3
 11   nl=nl*ilc(i)
      nx=ix+ib+if+itvr+itst+nds
      if(isext.eq.1) nx=nx+2
      if(itempf.ge.1) it=6
      if(itempf.lt.1) it=1
      if(iphfl.eq.1) it=it+nde*(nde+1)/2
c     ix1=na8
      ix1=na9
      ix2=na*(it+4)*nw+ix1
      ix3=na*(it+4)*nw+ix2
      ix4=nzc+ix3
      ix5=3*na*nl+ix4
      ix6 =it*na*nl+ix5
      ix7 =na*nl+ix6
      ix8 =nw*na*nl+ix7
      ix9 =4*nzc+ix8
      ix10=nw*2*nt+ix9
      ix11=nw*3*nt+ix10
      ix12=nw*nt+ix11
      ix13=nx+ix12
      iax=ix13-mmax-1
      return
      end

      subroutine dmmdpl(x,b,p,isub,xx,mx,ea,xjl,bjl,fjl,csb,ja,ifrt1,
     *          ifrt2,coeff,x1,nx,na,nl,nw,nt,nzc,it,jcont)
      dimension x(6,*),b(*),p(*),isub(*),xx(*),mx(*),ea(*),xjl(*),
     *   bjl(*),fjl(*),csb(*),ja(*),ifrt1(*),ifrt2(*),coeff(*),x1(*)
      character*4 ifrt1,mx
      parameter (npltmx=601)
      real shfta(2),shftb(2)
      common /cshift/ shftx,shfty
      common /ctoxy/ jkm(100),nsm(100),icnt(100),ictr(100),atr(6,100),
     *               kln(100)
      common /cabxy/ ax,bx,cosc,sinc,amagn,irl
      common /caxis/ amin,amax,bmin,bmax,diva,divb
      common /cjxjy/ jx,jy
c     common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3),hj(601,3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3,3),hj(601,3,3)
      common /cdim/ idm,nde
      common /clcmp/ ldev
      common /cnsne/ ns,ne
      data shftx/0/, shfty/0/
c     call gauss
      call rdfour(nw,nt,ifrt1,ifrt2,coeff)
      nc=4+it
      call rdintl(xx,mx,ja,ea,x1,isub,na,nc,nu)
      if(jcont.eq.1) read(4,'(8e14.6)') (x1(j),j=1,nu)
      write(6,*) ' '
      write(6,'(2a)') ' Fourier amplitudes ',
     *     '(u,v,w,bi:10**5, beq,b,p:10**3)'
c      call prmtbl(x1,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,it,nl,1)
      call prmtbl(x1,df,isub,ips,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,it,nl,1)
c     
      call setinp(5)
      call setskp(0)
      call getinp(inpu)
c      read(inpu,'(3i3)') ngm,noc,ldev
      call freadi('ngm=',1,ngm,1)
      call freadi('noc=',1,noc,0)
      call freadi('ldev=',1,ldev,0)
      if(ngm.eq.0) ngm=1
      if(ngm.eq.0) noc=1
      if(ldev.eq.0) ldev=1
      write(6,'(1h ,3(a,i3))') 'ngm=',ngm,' noc=',noc,' ldev=',ldev
      call plots(0.,0.,ldev)
      call orient(1)
      call newpen(3)
      do 100 ng=1,ngm
c           read(inpu,'(2i3)') jx,jy
           call freadi('jx=',1,jx,1)
           call freadi('jy=',1,jy,0)
           write(6,'(1h ,2(a,i3))') 'x-axis=',jx,' y-axis=',jy
c           read(inpu,101) ax,bx,cosc,amagn,irl
           call freadr('a=',1,ax,1)
           call freadr('b=',1,bx,0)
           call freadr('cosc=',1,cosc,0)
           call freadr('amagn=',1,amagn,0)
           call freadi('irl=',1,irl,0)
           write(6,205) ax,bx,cosc,amagn,irl
           sinc=sqrt(1.0-cosc**2)
c           read(inpu,103) amin,amax,bmin,bmax,diva,divb
           call freadr('amin=',1,amin,1)
           call freadr('amax=',1,amax,0)
           call freadr('bmin=',1,bmin,0)
           call freadr('bmax=',1,bmax,0)
           call freadr('diva=',1,diva,0)
           call freadr('divb=',1,divb,0)
           if(amin.eq.0.and.amax.eq.0) then
                amin=0
                amax=1
           end if
           if(bmin.eq.0.and.bmax.eq.0) then
                bmin=0
                bmax=1
           end if
           if(diva.eq.0) diva=0.1
           if(divb.eq.0) divb=0.1
           write(6,204) amin,amax,bmin,bmax,diva,divb
c           read(inpu,104) ipm,ns,ne,shftb,shfta
           call freadi('ipm=',1,ipm,1)
           call freadi('ns=',1,ns,0)
           call freadi('ne=',1,ne,0)
           call freadr('shiftb=',2,shftb,0)
           call freadr('shifta=',2,shfta,0)
           if(ns.eq.0) ns=1
           if(ne.eq.0) ne=nl+1
           if(shfta(1).eq.0.and.shfta(2).eq.0) then
              shfta(1)=0
              shfta(2)=(bmax-bmin)*bx+4
           end if
           write(6,'(1h ,3(a,i3),2(a,2f12.6))') 'ipm=',ipm,
     *     ' ns=',ns,' ne=',ne,' shiftb=',shftb,' shifta=',shfta
           if(ne.gt.npltmx) then
              call quit('ne > npltmx=601')
           end if
           if(jy.eq.4) then
               write(6,*) ' natm, iso, ict, ictr, atr, kln'
               do 105 i=1,2*ipm,2
               read(inpu,*) jkm(i),nsm(i),icnt(i),ictr(i),
     *                                     (atr(l,i),l=1,3),
     *         jkm(i+1),nsm(i+1),icnt(i+1),ictr(i+1),
     *                           (atr(l,i+1),l=1,3),kln(i+1)
               write(6,*) jkm(i),nsm(i),icnt(i),ictr(i),
     *                                     (atr(l,i),l=1,3),
     *         jkm(i+1),nsm(i+1),icnt(i+1),ictr(i+1),
     *                           (atr(l,i+1),l=1,3),kln(i+1)
 105           continue
           else
               do 110 i=1,ipm
               read(inpu,*) jkm(i),nsm(i),icnt(i),ictr(i),
     *                             (atr(l,i),l=1,3),kln(i)
               write(6,*) jkm(i),nsm(i),icnt(i),ictr(i),
     *                             (atr(l,i),l=1,3),kln(i)
 110           continue
           end if
           do 115 i=1,2
           shftb(i)=shftb(i)*amagn
           shfta(i)=shfta(i)*amagn
 115       continue
c          call plot(shftb(1),shftb(2),-3)
           shftx=shftx+shftb(1)
           shfty=shfty+shftb(2)
           if(ldev.eq.1.or.ldev.eq.4) then
               iend=1
           else
               iend=noc
           end if
           do 120 i=1,iend
               call xy(x1,ja,ea,nu,nzc,xjl,bjl,fjl,csb,coeff,it,nw,
     *           na,nl,x,b,p,isub,jx,jy,ipm,ifrt1,ifrt2,ns,ne,nt)
               call axs(jx,jy)
c              call plot(shfta(1),shfta(2),-3)
           shftx=shftx+shfta(1)
           shfty=shfty+shfta(2)
 120       continue 
 100  continue
      call plote(' end of plot ')
      if(ldev.eq.1) call getzap()
      return
 101  format(4f12.6,i3)
 102  format(20a4)
 103  format(6f12.6)
 104  format(4i3,4f10.5)
 203  format(1h ,20a4)
 204  format(1h ,5hamin=,f6.2,3x,5hamax=,f6.2,3x,5hbmin=,f6.2,3x,
     15hbmax=,f6.2,3x,5hdiva=,f6.2,3x,5hdivb=,f6.2)
 205  format(1h ,3x,2ha=,f12.6,3x,2hb=,f12.6,3x,5hcosc=,f12.6,3x,
     1'amagn=',f5.3,3x,'irl=',i3)
      end

      subroutine xy(x1,ja,ea,nu,nzc,xjl,bjl,fjl,csb,coeff,it,nw,
     *      na,nl,x,b,p,isub,jx,jy,ipm,ifrt1,ifrt2,ids,ide,nt)
      dimension x1(*),ja(4,*),ea(*),xjl(3,na,*),bjl(it,na,*),
     *               fjl(1,na,*),isub(*)
      dimension csb(nw,*),x(6,*),b(*),p(*),ifrt1(*),ifrt2(*),coeff(nw,*)
      common /ctoxy/ jkm(100),nsm(100),icnt(100),ictr(100),atr(6,100),
     *               kln(100)
      common /clcmp/ ldev
      character*4 ifrt1
c      dimension xd(203),yd(203)
      parameter (npltmx=601)
      dimension xd(npltmx+2),yd(npltmx+2)
c     common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3),hj(601,3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3,3),hj(601,3,3)
      common /cabxy/ ax,bx,cosc,sinc,amagn,irl
      common /cshift/ shftx,shfty
      common /caxis/ amin,amax,bmin,bmax,diva,divb
c      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3)
c      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
c      common /atomp2/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /cctr/ ctr(6,0:48),nctr
      common /cdim/ idm,nde
c      common /ceat/ eat(6)
      common /ceat/ eat(6,3)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /cnsne/ ns,ne
      equivalence (mm(1),m1),(mm(2),m2),(mm(3),m3)
      integer w
      real u2(6),u3(6),x0(6),x4(3)
      integer isubd(100)
      integer isgn(2)
      dimension mm(3),r(6),rd(6),yyd(3,npltmx),trd(6)
      dimension ctrd(6), ttd(6), re(6), zt(3)
      integer nj(npltmx),st(npltmx,2)
      real td(npltmx),xdw(npltmx+2),ydw(npltmx+2)
      data trd/6*0./, ttd/6*0./
      data x0/6*0./
      data isgn/1,-1/
      data eps /0.0025/
      call gauss(jx,jy)
c
      ilc(1)=1
      ilc(2)=1
      ilc(3)=1
      if(jx.eq.1) then
c        ilm(1)=200
         ilm(1)=ne
         ilm(2)=1
         ilm(3)=1
      else if (jx.eq.2) then
         ilm(1)=1
c        ilm(2)=200
         ilm(2)=ne
         ilm(3)=1
      else if(jx.eq.3) then
         ilm(1)=1
         ilm(2)=1
c        ilm(3)=200
         ilm(3)=ne
      end if
      if(jy.le.4) then
         is=i1
         ie=i2
      else if(jy.eq.5) then
         is=i3
         ie=i4
      else if(jy.eq.6) then
         is=i5
         ie=i6
      else if(jy.ge.7) then
         is=i3
         ie=i4
      end if
      if(jy.eq.4) then
         ijm=2
      else
         ijm=1
      end if
      iii=0
      do 70 ip=1,ipm
         do 83 m=1,ide
            yd(m)=0.0
            do 831 i=1,3
               yyd(i,m)=0.0
 831        continue
 83      continue
         do 71 ij=1,ijm
            iii=iii+1
            jk=jkm(iii)
            js=isub(jk)
            if(ij.eq.1) then
               js0=js
            end if
            ns=nsm(iii)
            ic=icnt(iii)
            jt=ictr(iii)
            call getzx(zmtrx(1,js),ctr(1,jt),ctrd)
            call getrx(x(1,jk),rd,rr(1,1,ns,js),tt(1,ns,js),1,ic)
            call getrx(rd,re,rr(1,1,1,js),ctrd,1,0)
            call getrx(re,r,rr(1,1,1,js),atr(1,iii),1,0)
c           atr: final additional translation
            if(ic.eq.0) then
               sig=1
            else
               sig=-1
            end if
            do 233 i=1,idm
               trd(i)=tt(i,ns,js)*sig+ctrd(i)+atr(i,iii)
 233        continue
            do 232 j=4,idm
               r(j)=0
 232        continue
            isubd(1)=js
            call begin(csb,nw,nt,1,ne,r,isubd,ifrt1,ifrt2,
     *               coeff,ns,ic,trd)
            do 116 l=1,ide
               jn=0
               do 73 i=1,6
                  u2(i)=0
 73            continue
               if(jy.eq.4) then
                  ld=l
               else
                  ld=l
               end if
               iend=max(i2,i4,i6)
c               if(jy.le.4) then
               do 75 i=1,iend
                  nz=ja(4,i)
                  if(i.ge.is.and.i.le.ie) then
                     do 751 nn=1,nz
                        in=jn+nn
                        jj=ja(1,in)
                        j=ja(2,in)
                        w=ja(3,in)
                        if(jj.eq.jk) u2(j)=u2(j)+x1(i)*ea(in)*
     *                          csb(w,ld)
 751                 continue
                  end if
                  jn=jn+nz
 75            continue
               if(jy.le.4) then
                  call getrx(u2,u3,rr(1,1,ns,js),ttd,1,ic)
               end if
               if(jy.le.3) then
c                 yd(l)=u3(jy)+r(jy)
                  call sumvec(u3,r,rd,1)

                  yd(l)=rd(jy)
               else if(jy.eq.4) then
                  t1=amin+float(l)/200
                  call getzt(zt,t1,rr(1,1,ns,js),jx,js)
                  call sumvec(r,zt,rd,1)
                  call sumvec(u3,rd,x4,1)
                  call gttrmx(x4,js) ! coordinate transformation
                  call sumvec(yyd(1,l),x4,yyd(1,l),isgn(ij))
                  yd(l)=absx(yyd(1,l),1)
               else if(jy.eq.5) then
                  yd(l)=u2(1)+b(jk)
               else if(jy.eq.6) then
                  yd(l)=u2(1)+p(jk)
               else if(jy.ge.7) then
                  do 771 j=1,6
                     u2(j)=u2(j)+b(jk)*eat(j,1)
 771              continue
                  call getrbr(u2,u3,rr(1,1,ns,js))
                  yd(l)=u3(jy-6)
               end if
               dpxj=pxj(ld,jx,js)
               if(js.eq.js0) then
                  xd(l)=dpxj
               end if
 116        continue
 71      continue
         call cpyvn(xd,td,ide)
         call qsort(td,st,nj,ide)
         avrd=0
         do 81 m=1,ide-ids+1
            md=nj(m+ids-1)
            xdw(m)=xd(md)
            ydw(m)=yd(md)
            avrd=avrd+yd(md)
 81      continue
c         write(6,*) 'xd=',xdw(1),xdw(2),' yd=',ydw(1),ydw(2)
         if(jy.eq.4) then
            write(6,*) 'ip=', ip, ' average d=', avrd/(ide-ids+1)
         end if
c        note: window viewpt reset the origin defined by plot(x,y,-3)
         xmin=amin
         ymin=bmin
         xmax=amax
         ymax=bmax
         call abtoxy(xmin,ymin,1)
         call abtoxy(xmax,ymax,1)      
         call window(xmin,ymin,xmax,ymax)
         fct=1/29.7
         call viewpt(shftx*fct,shfty*fct,
     *        (shftx+xmax-xmin)*fct,(shfty+ymax-ymin)*fct)
         nl1=ide-ids+1
         nl2=nl1+1
         nl3=nl1+2
         xdw(nl2)=0.0
         ydw(nl2)=0.0
         xdw(nl3)=1.0
         ydw(nl3)=1.0
         call abtoxy(xdw,ydw,nl1)
         call lntyp(kln(iii)*10)
         call line(xdw,ydw,nl1,1,0,0)
 70   continue
      call lntyp(0)
      return
 100  format(2i3)
 200  format(1h ,10f12.6)
 201  format(1h )
 202  format(1h ,'atom',i2,3x,'symmetry operator',i2,3x,2hx=,i2,3x,
     *     2hy=,i2)
 203  format(1h ,'atom',i2,3x,'symmetry operator',i2,1x,1h-,1x,
     *   'atom',i2,3x,'symmetry operator',i2,3x,2hx=,i2,3x,2hy=,i2)
      end

      subroutine getrbr(u2,u3,rr)
      real u2(*),u3(*)
      integer rr(6,6)
      dimension j1(6),j2(6)
      data j1/1,2,3,2,3,1/
      data j2/1,2,3,3,1,2/
      do j=1,6
         k1=j1(j)
         k2=j2(j)
         u3(j)=rr(k1,1)*u2(1)*rr(1,k2)+rr(k1,2)*u2(2)*rr(2,k2)+
     *        rr(k1,3)*u2(3)*rr(3,k2)+2*rr(k1,2)*u2(4)*rr(3,k2)+
     *        2*rr(k1,3)*u2(5)*rr(1,k2)+2*rr(k1,1)*u2(6)*rr(2,k2)
      end do
      return
      end

      subroutine gauss(jx,jy)
      implicit real*8 (a-h,o-z)
      real*4  pxj,hj,y,vc,amin,amax,bmin,bmax,diva,divb,td
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3,3),hj(601,3,3)
c     common /atomp2/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      common /cnsne/ ns,ne
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /caxis/ amin,amax,bmin,bmax,diva,divb
c     dimension p(3)
c     calculation of interval and weight of gauss integral
c      write(6,*) '********* nsub=',nsub
      icom=0
      do n=1,nsub
         do l=1,3
            do m=1,ne
               pxj(m,l,n)=0.0
               hj(m,l,n)=1.0
            end do
         end do
      end do
c
      do l=1,nsub
         if(icorc(jx).eq.1) then
c           incommansurate case
            do k=1,ne
               pxj(k,jx,l)=amin+float(k-1)/ilm(jx)
            end do
         else
c           commensurate case
            k=0
            icom=icom+1
            do  k3=1,ilc(3)
               do  k2=1,ilc(2)
                  do  k1=1,ilc(1)
                     k=k+1
                     pxj(k,jx,l)=y(1,jx,1)*(k1-1)+y(2,jx,1)*(k2-1)+
     *                    y(3,jx,1)*(k3-1)
                     pxj(k,jx,l)=mod(pxj(k,jx,l),1.)
                     if(pxj(k,jx,l).lt.0) pxj(k,jx,l)=pxj(k,jx,l)+1
                     if(icom.eq.1) then
                        hj(k,jx,l)=1.0/(ilc(1)*ilc(2)*ilc(3))
                     else
                        hj(k,jx,l)=1.0
                     end if
                  end do
               end do
            end do
         end if
c        write(6,*) 'jx,l,pxj=',jx,l,(pxj(k,jx,l),k=1,4)
      end do
      return
      end


      subroutine wx(x,nu,iw)
      dimension x(1),j(12),k(12),iw(1)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      equivalence (i1,j(1))
      do 10 i=1,12
 10   k(i)=j(i)
      do 20 i=1,12,2
      if(j(i).le.j(i+1)) go to 20
      k(i)=0
      k(i+1)=0
 20   continue
      write(6,204) (k(i),i=1,12)
      write(6,205) (i,x(i),iw(i),i=i1,i12)
      write(6,203)
 203  format(1h )
 204  format(1h ,'dspl. (',i3,'-',i3,')',2x,'temp. (',i3,'-',i3,')',
     x2x,'occup. (',i3,'-',i3,')',2x,'domain (',i3,'-',i3,')',
     x2x,'out of step (',i3,'-',i3,')',2x,'scale (',i3,'-',i3,')')
 205  format((1h ,10(i3,1x,f7.4,a1,1x)))
      return
      end

      subroutine prmtbl(x,df,isub,ips,na,nw,nx,nzc,ja,ea,xx,bx,px,
     *                it,nl,iw)
      dimension x(*),df(*),isub(*),ips(*),ja(4,*),ea(*),xx(6,*),
     *          bx(it,*),px(*)
      common /cdim/ idm,nde
      character*6 atom
      common /cltc/ atom(100)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension comp1(3),comp2(0:12),comp3(1),comp4(7),comp5(3),
     *          comp6(0:12),zx(20)
      integer wx(20),wy(20),ifrt(20)
      integer dspmdl,tmpmdl,sctmdl
      common /ceat/ eat(6,3),ebt(6,3)
      common /citfs/ itfs(100)
      character*4 comp1,comp2,comp3,comp4,comp5,comp6,aa,wc(20)
      data comp1 /'u','v','w'/,
     *     comp2 /'Beq','B1','B2','B3','B4','B5','B6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp3 /'p'/,
     *     comp4 /'B','B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp5 /'x','y','z'/,
     *     comp6 /'Beq','U1','U2','U3','U4','U5','U6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/
c****************************************************************
c    write atomic parameter table
c    iw=1: parameter table, iw=2: standard dev. table
c    iw=3: atomic parameters for a superstructure
c****************************************************************
      pi8=8*(3.141592)**2


      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      ncl=6
      kde=(nw-1)/ncl+1
      if(iw.eq.1.or.iw.eq.2) then
          do 12 kd=1,kde
              if(kd.eq.kde) ne=mod(nw-1,ncl)+1
              if(kd.ne.kde) ne=ncl
              do 13 k=1,ne
              ifrt(k)=k+ncl*(kd-1)
 13           continue
              if(kd.eq.1) write(6,202) (ifrt(k),k=1,ne)
              if(kd.ne.1) write(6,204) (ifrt(k),k=1,ne)
 12       continue
      end if
      write(6,201)
      do 10 i=1,na
      jk=isub(i)
      do 22 iy=1,3
      if(dspmdl.eq.0.and.iy.eq.1) go to 22
      if(tmpmdl.eq.0.and.iy.eq.2) go to 22
      if(sctmdl.eq.0.and.iy.eq.3) go to 22
      if(iy.eq.1) then   ! x,y,z
          is=i1
          ie=i2
          js=1
          je=3
          fact=100000
      else if(iy.eq.2) then  ! B or Bi, Ui
          is=i3
          ie=i4
          if(itempf.eq.0) then   ! isotropic
              js=1
              je=1
              fact=1000
          else if(itempf.gt.0) then ! anisotropic
             js=0               ! for Beq
             je=it
             fact=100000
          else if(itempf.lt.0) then
             js=0               ! for Beq
             je=it
             if(itfs(i).eq.0) then
                fact=100000
             else
                fact=100000
             end if
          end if
       else if(iy.eq.3) then  ! p
          is=i5
          ie=i6
          js=1
          je=1
          fact=1000
      end if
      do 11 j=js,je
      if(iw.eq.1.or.iw.eq.2) then
          do 111 kd=1,kde
          if(kd.ne.kde) ne=ncl
          if(kd.eq.kde) ne=mod(nw-1,ncl)+1
          do 210 k=1,ne
          if(j.ne.0) then    ! x,y,z, Bi/Ui ,p
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 31 l=2,is
 31               in=in+ja(4,l-1)
              end if
              do 220 ix=is,ie
              nz=ja(4,ix)
              do 21 n=1,nz
              in=in+1
              if(ja(1,in).eq.i.and.ja(2,in).eq.j.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                  ad=x(ix)*ea(in)
                  bd=df(ix)*ea(in)
                  if(iw.eq.1) then
c                    parameters and their differences
                       wx(k)=wx(k)+ad*fact
                       wy(k)=wy(k)+bd*fact
                       if(ips(ix).eq.1) then
 20                       write(wc(k),'(i4)') wy(k)
                       end if
                  else if(iw.eq.2) then
c                    parameters and their std.
                       wx(k)=wx(k)+ad*fact
                       zx(k)=zx(k)+bd**2
                       wy(k)=sqrt(zx(k))*fact
                       if(ips(ix).eq.1) then
                           write(wc(k),'(i4)') wy(k)
                       end if
                  end if
              end if
 21           continue
 220          continue
          else if(j.eq.0) then  ! Beq
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 32 l=2,is
 32               in=in+ja(4,l-1)
              end if
              do 230 ix=is,ie
              nz=ja(4,ix)
c             calculation of Beq
              do 23 n=1,nz
              in=in+1
              if(abs(itempf).gt.0) then ! calculate Beq
                  if(ja(1,in).eq.i.and.ja(2,in).le.6.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                     if(iw.eq.1) then
c                    parameters and their differences
                        if(itfs(i).eq.0) then
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                           wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact/100
                        else
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact
                           wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact
                        end if
                     else if(iw.eq.2) then
c                     parameters and their std.
                        if(itfs(i).eq.0) then
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                           zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        else
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact
                           zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        end if
                     end if
                  end if
              end if
              if(ips(ix).eq.1) then
                 if(itfs(i).eq.1) then
                    wy(k)=sqrt(zx(k))*fact/100
                    write(wc(k),'(i4)') wy(k)/100
                 else
                    wy(k)=sqrt(zx(k))*fact
                    write(wc(k),'(i4)') wy(k)
                 end if
              end if
 23           continue
 230          continue
          end if
 210      continue
          if(dspmdl.eq.1.and.iy.eq.1) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),comp1(j),
     *                     (wx(k),wc(k),k=1,ne)
          else if(tmpmdl.eq.1.and.iy.eq.2) then
             if(itempf.eq.1.or.(itempf.eq.-1.and.j.gt.0)) then  ! Bij
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp2(j),(wx(k),wc(k),k=1,ne)
             else if(itempf.eq.2.or.(itempf.eq.-2.and.j.gt.0))  then  ! Uij
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp6(j),(wx(k),wc(k),k=1,ne)
             else if(itempf.lt.0.and.j.eq.0) then    ! Beq
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp6(j),(wx(k)/100,wc(k),k=1,ne)
             else if(itempf.eq.0) then    ! B
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp4(j),(wx(k),wc(k),k=1,ne)
             end if
          else if(sctmdl.ne.0.and.iy.eq.3) then
             if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
             if(kd.eq.1) write(6,200) atom(i),
     *            comp3(j),(wx(k),wc(k),k=1,ne)
          end if
 111      continue
      end if
 11   continue
 22   continue
      write(6,201)
 10   continue
      if(itwin.ne.0) then
           ntwin=abs(itwin)
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(j,i)=0.
 802       continue
 801       continue
        if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+x(i)*ea(in)
 80        continue
           write(6,'('' twin domain volume ratio: '',8f12.6)')
     *       (volr(itw),itw=1,ntwin)
        write(6,201)
        end if
c       if(i10.gt.i8) then
c          phase shift
c           do 81 i=i9,i10
c           nz=ja(4,i)
c           do 81 n=1,nz
c           in=in+1
c           itw=ja(1,in)
c           j=ja(2,in)
c           dt(j,itw)=dt(j,itw)+x(i)*ea(in)
c 81        continue
c           write(6,'('' additional shift for twinoperators:'',6f12.6)')
c     *       ((dt(j,itw),j=1,6),itw=1,ntwin)
c           write(6,201)
c       end if
      end if
      write(6,'('' scale factors: '',6f12.6)') (x(i),i=i11,i12)
      if(isext.ne.0) then
         write(6,'('' extinction parameters: '',2f12.6)')
     *        (x(i),i=i13,i14)
      end if
      write(6,201)
 40   continue
      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      return
 200  format(1h ,a,1x,a4,6(i6,'(',a,')'))
 203  format(1h ,11x,    6(i6,'(',a,')'))
 201  format(1h )
 202  format(1h ,'fourier trm',6(i6,6x))
 204  format(1h ,'           ',6(i6,6x))
      end

      subroutine prmtbl0(x,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,it,nl,iw)
      dimension x(*),ja(4,*),ea(*),xjl(3,na,*),bjl(it,na,*),fjl(1,na,*)
      common /cdim/ idm,nde
      character*6 atom
      common /cltc/ atom(100)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
c      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(24)
c     *        ,dt(24,6)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      dimension comp1(3),comp2(12),comp3(1),comp4(7),comp5(3),xx(20)
      integer wx(20),ifrt(20)
      integer dspmdl,tmpmdl,sctmdl
      character*4 comp1,comp2,comp3,comp4,comp5,aa
      data comp1/'u','v','w'/,comp2/'b11','b22','b33','b23','b31','b12'
     *       ,'b44d','b55d','b66d','b56d','b64d','b45d'/,comp3/'p'/
     *       ,comp4/'b','b44d','b55d','b66d','b56d','b64d','b45d'/
     *       ,comp5/'x','y','z'/
c****************************************************************
c    write atomic parameter table
c    iw=1: parameter table, iw=2: standard dev. table
c    iw=3: atomic parameters for a superstructure
c****************************************************************
      if(nde.eq.2) then
         aa=comp2(9)
         comp2(9)=comp2(12)
         comp2(12)=aa
         aa=comp4(4)
         comp4(4)=comp4(7)
         comp4(7)=aa
      end if
 60   continue
      kde=(nw-1)/20+1
      if(iw.eq.1.or.iw.eq.2) then
         do 12 kd=1,kde
            if(kd.eq.kde) ne=mod(nw-1,20)+1
            if(kd.ne.kde) ne=20
            do 13 k=1,ne
               ifrt(k)=k+20*(kd-1)
 13         continue
            if(kd.eq.1) write(6,202) (ifrt(k),k=1,ne)
            if(kd.ne.1) write(6,203) (ifrt(k),k=1,ne)
 12      continue
      else if(iw.eq.2) then
         write(6,204)
      end if
      write(6,201)
      do 10 i=1,na
         do 22 iy=1,3
            if(dspmdl.eq.0.and.iy.eq.1) go to 22
            if(tmpmdl.eq.0.and.iy.eq.2) go to 22
            if(sctmdl.eq.0.and.iy.eq.3) go to 22
            if(iy.eq.1) je=3
            if(iy.eq.2) je=it
            if(iy.eq.3) je=1
            do 11 j=1,je
               if(iw.eq.1.or.iw.eq.2) then
                  do 111 kd=1,kde
                     if(kd.ne.kde) ne=20
                     if(kd.eq.kde) ne=mod(nw-1,20)+1
                     do 20 k=1,ne
                        wx(k)=0.0
                        xx(k)=0.0
                        if(iy.eq.1) then
                           is=i1
                           ie=i2
                           fact=100000
                        else if(iy.eq.2) then
                           is=i3
                           ie=i4
                           if(itempf.ne.0) then
                              if(itempf.eq.1.or.itempf.eq.-1) then
                                 fact=100000
                              else if(itempf.eq.2.or.itempf.eq.-2) then
                                 fact=1000
                              end if
                           else
                              fact=1000
                           end if
                        else if(iy.eq.3) then
                           is=i5
                           ie=i6
                        end if
                        in=0
                        if(is.ne.1) then
                           do 21 l=2,is
                              in=in+ja(4,l-1)
 21                        continue
                        end if
                        do 23 ix=is,ie
                           nz=ja(4,ix)
                           do 24 n=1,nz
                              in=in+1
                              if(ja(1,in).ne.i) go to 24
                              if(ja(2,in).ne.j) go to 24
                              if(ja(3,in).ne.k+(kd-1)*20) go to 24
                              ad=x(ix)*ea(in)*fact
                              if(iw.eq.1) then
c                                wx(k)=wx(k)+sign(abs(ad)+0.5,ad)
                                 wx(k)=wx(k)+ad
                              else if(iw.eq.2) then
                                 xx(k)=xx(k)+ad**2
                              end if
 24                        continue
 23                     continue
 20                  continue
                     if(iw.eq.2) then
                        do 71 k=1,ne
                           wx(k)=sqrt(xx(k))
 71                     continue
                     end if
 70                  if(dspmdl.eq.1.and.iy.eq.1) then
                        if(kd.ne.1) write(6,203) (wx(k),k=1,ne)
                        if(kd.eq.1) write(6,200) atom(i),comp1(j),
     *                       (wx(k),k=1,ne)
                     else if(tmpmdl.eq.1.and.iy.eq.2) then
                        if(itempf.ne.0) then
                           if(kd.ne.1) write(6,203) (wx(k),k=1,ne)
                           if(kd.eq.1) write(6,200) atom(i),comp2(j),
     *                          (wx(k),k=1,ne)
                        else
                           if(kd.ne.1) write(6,203) (wx(k),k=1,ne)
                           if(kd.eq.1) write(6,200) atom(i),comp4(j),
     *                          (wx(k),k=1,ne)
                        end if
                     else if(sctmdl.ne.0.and.iy.eq.3) then
                        if(kd.ne.1) write(6,203) (wx(k),k=1,ne)
                        if(kd.eq.1) write(6,200) atom(i),comp3(j),
     *                       (wx(k),k=1,ne)
                     end if
 111              continue
               else if(iw.eq.3) then
                  if(dspmdl.eq.1.and.iy.eq.1) then
                     write(6,205) atom(i),comp5(j),(xjl(j,i,m),m=1,nl)
                  else if(tmpmdl.eq.1.and.iy.eq.2) then
                     if(itempf.ne.0) then
                        write(6,205) atom(i),comp2(j),
     *                       (bjl(j,i,m),m=1,nl)
                     else if(itempf.le.0) then
                        write(6,205) atom(i),comp4(j),
     *                       (bjl(j,i,m),m=1,nl)
                     end if
                  else if(sctmdl.ne.0.and.iy.eq.3) then
                     write(6,205) atom(i),comp3(j),
     *                    (fjl(j,i,m),m=1,nl)
                  end if
               end if
 11         continue
 22      continue
         write(6,201)
 10   continue
      if(itwin.ne.0) then
           ntwin=abs(itwin)
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
c           dt(i,j)=0.
           dt(j,i)=0.
 802       continue
 801       continue
      if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+x(i)*ea(in)
 80        continue
           write(6,'('' twin domain volume ratio: '',8f12.6)')
     *       (volr(itw),itw=1,ntwin)
      write(6,201)
      end if
      if(i10.gt.i8) then
c          phase shift
           do 81 i=i9,i10
           nz=ja(4,i)
           do 81 n=1,nz
           in=in+1
           itw=ja(1,in)
           j=ja(2,in)
c           dt(itw,j)=dt(itw,j)+x(i)*ea(in)
           dt(j,itw)=dt(j,itw)+x(i)*ea(in)
 81        continue
           write(6,'('' additional shift for twinoperators:'',6f12.6)')
c     *       ((dt(itw,j),j=1,6),itw=1,ntwin)
     *       ((dt(j,itw),j=1,6),itw=1,ntwin)
           write(6,201)
      end if
      end if
      write(6,'('' scale factors: '',6f12.6)') (x(i),i=i11,i12)
      write(6,201)
 40   continue
      if(nde.ne.2) return
      aa=comp2(9)
      comp2(9)=comp2(12)
      comp2(12)=aa
      aa=comp4(4)
      comp4(4)=comp4(7)
      comp4(7)=aa
      return
 200  format(1h ,a,1x,a,20i6)
 201  format(1h )
 202  format(1h ,'fourier trm' ,20i6)
 203  format(1h ,11x,20i6)
 204  format(1h ,'superstructure')
 205  format(1h ,a,1x,a,10(f8.4,4x)/(1h ,11x,10(f8.4,4x)))
 206  format(1h1)
      end

      subroutine abtoxy(x,y,n)
      common /cabxy/ ax,bx,cosc,sinc,amagn,irl
      dimension x(n),y(n)
      do 10 i=1,n
      x(i)=x(i)*ax+y(i)*bx*cosc
      y(i)=y(i)*bx*sinc
 10   if(irl.eq.1) y(i)=-y(i)
      do 20 i=1,n
      x(i)=x(i)*amagn
      y(i)=y(i)*amagn
 20   continue
      return
      end

 
      subroutine axs(jx,jy)
      common /caxis/ amin,amax,bmin,bmax,diva,divb
      common /cabxy/ ax,bx,cosc,sinc,amagn,irl
      common /cshift/ shftx,shfty
      dimension xx(4),yy(4),cx(4),cy(4)
      character*10 scale
      character*16 jyw(12),ty
      character*2  jxw(6),tx
c       jx: (1 td, 2 ud, 3 vd) for jy=4  otherwise (1 t, 2 u, 3 v)
c       jy: (1:x,2:y,3:z,4:d,5:b,6:p,7:b1,8:b2,9:b3,10:b4,11:b5,12:b6)
c            r: the interatomic distance of a specified pair (see (23))
      data jxw /'t','u','v','t''','u''','v'''/
      data jyw /'x coordinate'
     *         ,'y coordinate'
     *         ,'z coordinate'
     *         ,'distance (\\305)'  ! for sun, dec and Linux
c    *         ,'distance (\305) '  ! for hp 
     *         ,'B'
     *         ,'p'
     *         ,'B1'
     *         ,'B2'
     *         ,'B3'
     *         ,'B4'
     *         ,'B5'
     *         ,'B6'/
      if(jy.ne.4) then
          tx=jxw(jx)
      else
          tx=jxw(jx+3)
      end if
      ty=jyw(jy)
      if(jy.le.3) then
         nty=12
      else if(jy.eq.4) then
         nty=16
      else if(jy.le.6) then
         nty=1
      else
         nty=2
      end if
      xx(1)=amin
      xx(2)=amax
      xx(3)=amax
      xx(4)=amin
      yy(1)=bmin
      yy(2)=bmin
      yy(3)=bmax
      yy(4)=bmax
      call abtoxy(xx,yy,4)
      xmin=amin
      ymin=bmin
      xmax=amax
      ymax=bmax
c      call setfont('/Helvetica-Bold')
      call setfont('/Helvetica-Bold-Scand')
      call abtoxy(xmin,ymin,1)
      call abtoxy(xmax,ymax,1)      
      call window(xmin-3,ymin-3,xmax+3,ymax+3)
      fct=1/29.7
      call viewpt((shftx-3)*fct,(shfty-3)*fct,
     *      (shftx+xmax-xmin+3)*fct,(shfty+ymax-ymin+3)*fct)
c      write box
      call draw(xx(1),yy(1),xx(2),yy(2))
      call draw(xx(2),yy(2),xx(3),yy(3))
      call draw(xx(3),yy(3),xx(4),yy(4))
      call draw(xx(4),yy(4),xx(1),yy(1))
      cx(3)=0.0
      cy(3)=0.0
      cx(4)=1.0
      cy(4)=1.0
      im=(amax-amin)/diva+0.001
      jm=(bmax-bmin)/divb+0.001
      ang=0
      do 60 i=0,im,2
           cx(1)=amin+diva*float(i)
           cy(1)=bmin
           cx(2)=cx(1)
           write(scale,'(f4.1)') cx(1)
           if(irl.ne.1) cy(2)=cy(1)+0.2/bx
           if(irl.eq.1) cy(2)=cy(1)-0.2/bx
           call abtoxy(cx,cy,2)
c          call symbol(cx(1)-0.8,cy(1)-0.5,0.3,scale,ang,4)
           y0=cy(1)-0.9
           hh=0.4
           nc=4
           call csymbol(cx(1),y0,hh,scale,ang,nc)
           call line(cx,cy,2,1,0,0)
 60   continue
      dx=(amax-amin)/2+amin
      dy=bmin
      call abtoxy(dx,dy,1)
c     call symbol(dx-0.1,dy-1.3,0.3,tx,ang,2)
      y0=dy-1.6
      hh=0.4
      nc=2
      call csymbol(dx,y0,hh,tx,ang,nc)
      ang=90
      do 61 j=0,jm,2
           cx(1)=amin
           cy(1)=bmin+divb*float(j)
           cx(2)=cx(1)+0.2/ax
           cy(2)=cy(1)
           write(scale,'(f4.1)') cy(1)
           call abtoxy(cx,cy,2)
c          call symbol(cx(1)-1.3,cy(1)-0.1,0.3,scale,ang,4)
           y0=cx(1)-0.4
           hh=0.4
           nc=4
           call csymbol(y0,cy(1),hh,scale,ang,nc)
           call line(cx,cy,2,1,0,0)
 61   continue
      dx=amin
      dy=(bmax-bmin)/2+bmin
      call abtoxy(dx,dy,1)
c     call symbol(dx-1.5,dy-0.1,0.3,ty,ang,2)
      y0=dx-1.4
      hh=0.4
      call csymbol(y0,dy,hh,ty,ang,nty)
c      if(jy.eq.4) then
c         call symbol(cx(1)-1.7,cy(1)/2-0.5,0.3,'(A)',ang,3)
c      end if
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
      do 105 j=1,n
      if(ipivot(j).eq.1) go to 105
      do 100 k=1,n
      if(ipivot(k)-1) 80,100,740
  80  if(abs(amax).ge.abs(a(j,k))) go to 100
      irow=j
      icolum=k
      amax=a(j,k)
 100  continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
      swap=b(irow)
      b(irow)=b(icolum)
      b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
      b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
      do 450 l=1,n
 450  a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
      do 700  k=1,n
      swap=a(k,jrow)
      a(k,jrow)=a(k,jcolum)
 700  a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end

      subroutine begin(csb,nw,nt,na,nl,x,isub,ifrt1,ifrt2,coeff,
     *                ns,icnt,trd)
      character*4 ifrt1
      dimension csb(nw,na,*),x(6,*),isub(*),ifrt1(nw,2,*),
     *                              ifrt2(nw,3,*),coeff(nw,*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
c     common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3),hj(601,3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(601,3,3),hj(601,3,3)
      common /cdim/ idm,nde
c     common /kwave/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /caxis/ amin,amax,bmin,bmax,diva,divb
      common /cjxjy/ jx,jy
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      dimension arg(6),agd(6),rs(6,6,3),bb(6),ipv(6),ind(6,2),piv(6)
      dimension trd(6),nm(6)
      real t(3),td(3)
      character sgn1,sgn2,chr1,chr2
      character*2 cs1,cs2
      data sgn1/'+'/,sgn2/'-'/,cs1/'cC'/,cs2/'sS'/
c*******************************************************************
c      calculation of fourier terms for each independent atom
c*******************************************************************
      do 21 j=1,nw
      do 21 jk=1,na
      do 21 m=1,nl
 21   csb(j,jk,m)=0.0
      do 241 nd=1,nsub
         do 24 i=1,idm
         do 24 j=1,idm
 24      rs(i,j,nd)=rr(i,j,ns,nd)
         call matinv(rs(1,1,nd),6,idm,bb,0,det,ipv,ind,piv)
 241  continue

      do 10 i=1,nw
         do 12 j=1,nt
            chr1=ifrt1(i,1,j)(1:1)
            if(chr1.eq.sgn1) then
               sgn=1
            else if(chr1.eq.sgn2) then
               sgn=-1
            else
               go to 13
            end if
            if(coeff(i,j).eq.0.0) coeff(i,j)=1.0
            do 11 jk=1,na
               js=isub(jk)
               do 22 k=1,6
                  arg(k)=0.0
 22            continue
               do 20 k=1,idm
                  arg(k)=x(k,jk)
                  if(jy.eq.4.and.k.ge.4) then
                     ni=k-3
                     yx=y(1,ni,js)*x(1,jk)+y(2,ni,js)*x(2,jk)+
     *                    y(3,ni,js)*x(3,jk)
                  else
                     yx=0
                  end if
                  if(k.ge.4) then
                     arg(k)=arg(k)+yx
c                    arg(k)==x4. etc corresponding to t' etc.
                  end if
 20            continue
               do m=1,nl
                  do 23 nd=1,nde
                     agd(nd)=0
c                     do 231 k=1,3
c                        agd(nd)=agd(nd)+
c     *                       rs(nd+3,k,js)*(arg(k)-trd(k))
c 231                 continue
                     do k=1,3
                        t(k)=pxj(m,k,js)
                        td(k)=pxj(m,k,js)
                     end do
                     if(jy.eq.4) then
                        call gettd(t,td,js)
                     end if
                     do 232 k=4,idm
                        agd(nd)=agd(nd)+rs(nd+3,k,js)*
     *                       (arg(k)+td(k-3)-trd(k))
c     *                       (arg(k)+pxj(m,k-3,js)-trd(k))
 232                 continue
                     if(icnt.eq.1) agd(nd)=-agd(nd)
 23               continue
                  a=0
                  do 233 nd=1,nde
                     a=a+agd(nd)*ifrt2(i,nd,j)
 233              continue
                  chr2=ifrt1(i,2,j)(1:1)
                  if(index(cs1,chr2).gt.0) then
                     cs=cos(a*pai2)*sgn
                  else if(index(cs2,chr2).gt.0) then
                     cs=sin(a*pai2)*sgn
                  else
                     cs=0.0
                  end if
                  csb(i,jk,m)=csb(i,jk,m)+cs*coeff(i,j)
               end do
 11         continue
 12      continue
 13      je=j-1
 10   continue
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      stop
      end

      subroutine btobij(na,b,isub)
      dimension b(*),isub(*),bij(6)
      common /ceat/ eat(6,3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension j1(6),j2(6)
      data j1/1,2,3,2,3,1/, j2/1,2,3,3,1,2/
c     eat is used in rdintl(),rdsymw(),egvctr()
      do 100 n=1,nsub
          do 200 j=1,6
          k=j1(j)
          l=j2(j)
          eat(j,n)=gabn(k,l,n)/4
 200      continue
 100  continue
      write(6,*) ' equivalent b11,b22,b33,b23,b31,b12'
      do 10 i=1,na
          js=isub(i)
          do 11 j=1,6
          bij(j)=eat(j,js)*b(i)
 11       continue
          write(6,'(1h ,a,i3,6f9.5)') 'atom',i,(bij(j),j=1,6)
 10   continue
      return 
      end

      subroutine gettrm(zmtrx,nsub)
      integer zmtrx(6,*)
      common /kwave/ y(3,3,3),vc(3)
      integer zd,vd
      common /ctrm/ trm(3,3,3),sv(3,3,3),zd(3,3,3),vd(3,3,3)
      integer wm,z3,v3
      common /cwm/ wm(6,6,3),z3(3,3,3),v3(3,3,3)
      common /cdim/ idm,nde
      dimension b(3),ipvt(3),indx(3,2),pvt(3)
      do ns=1,nsub
         do i=1,3
            do j=1,3
               k=zmtrx(i,ns)
               if(k.ge.4) then
                  trm(i,j,ns)=y(j,k-3,1)
               else if(j.eq.k) then
                  trm(i,j,ns)=1
               else
                  trm(i,j,ns)=0
               end if
            end do
         end do
         call matinv(trm(1,1,ns),3,3,b,0,det,ipvt,indx,pvt)
         write(6,*) 'transformation matrix for substructure ',ns
         do i=1,3
            write(6,'(3f12.6)') (trm(i,j,ns),j=1,3)
         end do
         do i=1,6
            do k=1,6
               wm(i,k,ns)=0
            end do
            wm(i,zmtrx(i,ns),ns)=1
         end do
         do k=1,3
            do i=1,3
               z3(k,i,ns)=wm(k,i,ns)
               zd(k,i,ns)=wm(k,i+3,ns)
               v3(k,i,ns)=wm(k+3,i,ns)
               vd(k,i,ns)=wm(k+3,i+3,ns)
            end do
         end do
         do k=1,3
            do i=1,3
               sv(k,i,ns)=y(i,k,ns)
            end do
         end do
         write(6,*) 'W matrix for substructure ',ns
         do i=1,6
            write(6,'(6i3)') (wm(i,j,ns),j=1,6)
         end do
         write(6,*) 'sv matrix for substructure ',ns
         do i=1,nde
            write(6,'(6f8.4)') (sv(i,j,ns),j=1,3)
         end do
         write(6,*) 'zd matrix for substructure ',ns
         do i=1,3
            write(6,'(6i3)') (zd(i,j,ns),j=1,nde)
         end do
         write(6,*) 'vd matrix for substructure ',ns
         do i=1,nde
            write(6,'(6i3)') (vd(i,j,ns),j=1,nde)
         end do
      end do
      return
      end

      subroutine gttrmx(xx,isub)
      dimension xx(*)
      dimension xd(3)
      integer zd,vd
      common /ctrm/ trm(3,3,3),sv(3,3,3),zd(3,3,3),vd(3,3,3)
      common /cdim/ idm,nde
      call cpyvec(xx,xd)
      do i=1,3
         xx(i)=0
         do j=1,3
            xx(i)=xx(i)+trm(i,j,isub)*xd(j)
         end do
      end do
      return
      end

      subroutine gettd(t,td,isub)
      dimension t(*),td(*)
      integer zd,vd
      common /ctrm/ trm(3,3,3),sv(3,3,3),zd(3,3,3),vd(3,3,3)
      common /cdim/ idm,nde
      real svzd(3,3)
      do i=1,nde
         do j=1,nde
            svzd(i,j)=0
            do k=1,3
               svzd(i,j)=svzd(i,j)+sv(i,k,isub)*zd(k,j,isub)
            end do
         end do
      end do
      do i=1,nde
         td(i)=0
         do j=1,nde
            td(i)=td(i)+(vd(i,j,isub)-svzd(i,j))*t(j)
         end do
      end do
c         write(6,*) 't,td=',t,td
c         write(6,*) 'sv matrix for substructure ',isub
c         do i=1,nde
c            write(6,'(6f8.4)') (sv(i,j,isub),j=1,3)
c         end do
c         write(6,*) 'zd matrix for substructure ',isub
c         do i=1,3
c            write(6,'(6i3)') (zd(i,j,isub),j=1,nde)
c         end do
c         write(6,*) 'vd matrix for substructure ',isub
c         do i=1,nde
c            write(6,'(6i3)') (vd(i,j,isub),j=1,nde)
c         end do
      return
      end

c           call getzt(zt,t1,rr(1,1,ns,js),jx,js)
      subroutine getzt(x,t,rr,ix,isub)
      dimension x(*)
      integer rr(6,6)
      integer zd,vd
      common /ctrm/ trm(3,3,3),sv(3,3,3),zd(3,3,3),vd(3,3,3)
      common /cdim/ idm,nde
      real rz(3)
c      do i=1,3
c         rz(i)=0
c         do j=1,3
c            rz(i)=rz(i)+rr(i,j)*zd(j,ix,isub)
c         end do
c      end do
      do i=1,3
c         x(i)=rz(i)*t
         x(i)=0
         do j=1,nde
            x(i)=x(i)-zd(i,ix,isub)*t
         end do
      end do
      return
      end

      subroutine cpyvec(v1,v2)
      real v1(*),v2(*)
      do 100 i=1,3
          v2(i)=v1(i)
 100  continue
      return
      end

      subroutine cpyvn(v1,v2,n)
      real v1(*),v2(*)
      do 100 i=1,n
          v2(i)=v1(i)
 100  continue
      return
      end

      subroutine mplmtr(a,b,c,n)
      dimension a(6,6),b(6,6),c(6,6)
      do i=1,n
         do j=1,n
            c(i,j)=0
            do k=1,n
               c(i,j)=c(i,j)+a(i,k)*b(k,j)
            end do
         end do
      end do
      return
      end

      subroutine sumvec(v1,v2,v3,isg)
      real v1(*),v2(*),v3(*)
      if(isg.gt.0) then
         do 100 i=1,3
            v3(i)=v1(i)+v2(i)
 100     continue
      else if(isg.lt.0) then
         do 200 i=1,3
            v3(i)=v1(i)-v2(i)
 200     continue
      else
         call quit('invalid isg in sumvec')
      end if
      return
      end

      function absx(x,js)
      real x(*)
c      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      absx=0
      do 100 i=1,3
      do 100 j=1,3
           absx=absx+x(i)*gab(i,j,js)*x(j)
 100  continue
      absx=sqrt(absx)
      return
      end

      function absy(x,js)
      real x(*)
c      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      absy=0
      do 100 i=1,3
      do 100 j=1,3
           absy=absy+x(i)*gabn(i,j,js)*x(j)
 100  continue
      absy=sqrt(absy)
      return
      end

      function absvec(x)
      real x(*)
      absvec=0.
      do 100 i=1,3
      absvec=absvec+x(i)**2
 100  continue
      absvec=sqrt(absvec)
      return
      end
           
      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(*)
      integer r,s,st(nx,0:1),ip(nx)
      do 10 i=1,nx
 10   ip(i)=i
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(x(i).lt.xt) then
        i=i+1
        go to 3
      endif
    4 if(xt.lt.x(j)) then
        j=j-1
        go to 4
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        i=i+1
        j=j-1
        go to 3
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      end if
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end
    
