c
c    **************************************************************
c       parallel and perspective projection of modulated structures
c    **************************************************************
c
c             copyright (c) apr. 1989  by Akiji Yamamoto
c
c
c     (00) jcont
c ********  if inpu=0 then *******
c     (01) flmn0
c          flmn0: filename of the input file for REMOS
c ********  else **********
c     (01) iwflag
c          iwflag(1): 0 output default lists
c             default iwflag  see below
c             iwflag(2)=1, iwflag(3)=1, iwflag(4)=4, iwflag(5)=2,
c             iwflag(6)=3
c                   : 1 output selected list according to the
c                       following
c          iwflag(2): 1 output title
c          iwflag(3): 1 output other input data
c          iwflag(4): 1 output fourier amplitudes in each cycle
c                   : 2 output their difference in each cycle
c                   : 3 output both in each cycle
c                   : 4 output fourier amplitudes in first and
c                       last cycles
c          iwflag(5): 1 output independent parameters in each cycle
c                   : 2 output their difference in each cycle
c                   : 3 output both in each cycle
c          iwflag(6): 1 output standard dev. of independent param.
c                   : 2 output standard dev. of fourier amplitudes
c                   : 3 output both
c
c     (02)    input fo data file name   (a) (see (34))
c     (03)    independent parameter file name (a)
c     (04)    fo data output file name (a)
c     (05)    output fc data file name (a)
c   ****** end if******
c     (1) title 
c     (2) a,b,c,cosa,cosb,cosc
c     (3) na, nbuv, zmtrx
c         na:number of atoms      ******na<=100*****
c     (4) 'basic structure'
c           no. symbol, sft, x1-x6,b,p,isub (*)
c         no: atom number
c         symbol: symbol of the atomic site
c         stf: scattering-factor-table number
c         x1-x6: atomic coordinates
c         (for composite crystals, give coordinates for the substructure)
c         b: isotropic temperature factor
c         p: occupation probability
c         isub: subsystem  (1-3 for first to third subsystem)
c          =========== repeat (4) na times ===========
c     (5) ndm,nsymo,icent,ige,nctr
c         ndm: dimension of modulation     (1<=ndm<=3)
c         nsymo: number of symmetry operators in modulated structure
c                 (1<=nsymo<=48)
c         icent=0: noncentrosymmetric, =1: centrosymmetric
c           if centrosymmetric take the origin at center of symmetry
c           and give symmetry operators in the factor group, g/i
c           ige=0: give all symmetry opeators, ige=1: give generators,
c           then all elements are created in the program
c         nctr: number of centering translations  (0<=nctr<=48)
c               nctr=0 means primitive lattice
c
c     (6)  a*,b*,c* components of the wave vector icorc, ilm (*)
c         if incommensurate icorc=1, commensurate icorc=0
c         ilm  number of divisions of gauss integrals in structure
c         factor formula in incommensurate cases     3<=ilm<=100
c          ******caution:  satellite with order greater than****
c          *******ilm/5 is not calculated.  This means that ****
c          *******if second order satellite intensity must be***
c          *******necessary ilm >= 10 is necessary *************
c           =========== repeat (6) ndm times ============
c
c           if all the wave vectors are incommensurate
c                          skip (7)
c **************data for the commensurate structure*********************
c *       if anyone of wave vectors is commensurate,                   *
c *   (7)  ilc   :give period along a,b,c axes
c **********************************************************************
c
c           if(nctr=0) skip (8)
c     (8) 'centering translation'
c           in the format of I.T.
c           1/2,1/2,0,1/2  etc.
c           =========repeat (8) nctr times ========
c     (9) 'symmetry operatore'
c           in the format of I.T.
c            for example x,y,z,t,u,v
c         if ige=1 then give the order of the symmetry operator for ior
c           ======== repeat (9) nsymo times ==========
c         ****the first operator must be the identity operator****
c         ****the symmetry operator is used to classify the
c                     if nextnc=0 skip (10)
c     (10) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,itst,nxmax
c         ix: no. of independent parm. for displacement
c         ib: no. of independent parm. for temperature factor
c         if: no. of independent parm. for scattering factor
c         nds: no. of data sets ( no. of scale factprs )  (1<=nds<=20)
c         nzc: upper limit of the number of coefficients which relate
c          constrained atomic parameters and independent parameters
c         nw: no. of fourier terms
c         nt: upper limit of the number of sin and cos functions
c             included in a fourier term
c         ipol=1, differenciation is made in the poler coordinate
c            then give each complex amplitude of modulation waves
c            in order of re and im parts.
c         ipnf1>0,the penalty function is used for the
c            occupation probability (see (35))
c         ipnf1=1 limits upper and lower sides while
c         ipnf1=2 limits lower side of occupation probability
c         ipnf2=1,penalty function is used for the interatomic distance
c                         (see (35))
c         itvr: no. of parameters for domain size
c         itst:  no. of parameters for out of step
c         nxmax: upper limit of no. of variable parameter in each block
c                                                   (see (33))
c
c     (11) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
c          dspmdl=1 displasive modulation exists otherwise =0
c          tmpmdl=1 temp.fact. modulation exists otherwise =0 then b=0
c          sctmdl=1 density modulation exists otherwise =0 then p=1
c          sctmdl=-1 means substitutional modulation
c            then give the occupation probability of the first atom
c            the occupation probability of the second atom is given
c            by 1-p  (see 16)
c          itempf=0 isotropic temperature factor for all atoms
c          itempf=1 anisotropic temperatire factor for all atoms Bij
c          itempf=-1 some atoms anisotropic and others isotropic Bij
c          itempf=2 anisotropic temperatire factor for all atoms Uij
c          itempf=-2 some atoms anisotropic and others isotropic Uij
c               Beq=(4/3)(B11*a*a+...+2*B12*a*b*+...)
c               Beq=(4/3)(U11+U22+U33+2*U12+2*U23+2*U31)*8*pi*pi
c          abs(itwin) nomber of twin domains
c             itwin.gt.0 macroscopic twin
c             itwin.lt.0 microscopic twin
c          iphfl=1 phase fluctuations between microscopic domains
c          iphfl=0 no such phase fluctuations
c          isext=1 secondary extinction correction =0 no ext. corr.
c      
c     (12) 'fourier term'
c          sig,cs,n1,n2,n3,coef,icont          (4(2a1,3i2,f10.6,1x,a1))
c          give the fourier terms
c          sig: + or -
c          cs: c for cosine and s for sine function
c          n1,n2,n3: the factors for x4,x4,x6
c                  +c 1-2 3 means +cos(x4-2x5+3x6)
c          coef: the factor for the above term
c          icont: give any character except for a blank if the
c              fourier term is followed by the other sine or cosine
c              functions
c     (13) 'initial parameter'
c                and ps  ((12x,6(f9.4,a1)))
c          if dspmdl, tmpmdl and/or sctmdl are zero, the corresponding
c          parameter is not necessary
c
c
c     (14) jx,jb,jp   numbers of independent parameters which are
c          related with constrained amplitudes of the displacement,
c          temperature factor and occupation probability.
c          if jx,jb,jp are all zero skip (14)
c     (15) j,a,k,ea(j,k,a)        (4(3i3,f10.5,a1))
c          j atom number
c          a component of vector or tensor (x=1,y=2,,b11=1,b22=2,,etc.)
c          k fourier term
c          ea(j,a,k) nonzero component of correlation matrix
c           end of nonzero element in a row is specified by blank of
c           sig .  other sig means continuation of the row
c           1  1  1 1.0        + 1  2  1 1.0  etc
c     (16) initial parameters corresponding to (14) and scale
c                                        (8f10.7)
c *********  end if **********
c     (17) ne,np,nb,ng
c         ne  number of elements (1<=ne<=20)
c         np  number of element pairs to be joined by bonds(<=20)
c         nb  number of boundary planes  (4<=nb<=20)
c            nb=0 means default scissoring boundary
c            then atoms in a unit cell are written
c            nb=1 means default scirroring boundary
c            normal to a*, b*, c*    (see (11))
c         ng  number of drawings (default: 1)
c     (18) ldev,iww,iwb,iwc,iwa,ips,ccol,jmod,jvw
c         ldev : 1: sun3 bitmap 2: NEC-PC98 3: plotter 4: laser prn.
c         iww  : 1  print out x y z coordinates and bonded pairs
c         iwb 0: write bonds                  1: no bond
c         iwc 0: write unit cell              1: no unit cell
c         iwa 0: write atoms joined by bond   1: all atoms
c         ips 0: parallel projection          1: perspective projection
c         ccol : unit cell color (color display) or pen number (plotter)
c            for display
c            1:blue,2:red,3:purple,4:green,5:sky blue,6:yellow,7:white
c                  (default: white)
c         jmod : 0 non-shaded atoms 1: shaded atoms
c         jvw : 0: maximum viewport 1: given viewport
c     (19) pmin ias(1)-ias(nsymo) or if icent=1
c                           ias(1)-ias(nsymo*2) 
c                           and pmin for each atom
c         pmin  :  if p>= pmin selected else neglected
c         ias(i):1 selected, :0 neglected
c *************** repeat (19) na times *************
c     (20) rad,acol
c         rad:  atom radii (in angstrome)
c         acol: atom color
c           for display
c           1:blue,2:red,3:purple,4:green,5:sky blue,6:yellow
c                    (default: blue)
c           repeat (20) ne times
c  **************if iwb=1 skip (21)************
c     (*21) ie1,ie2,dmin,dmax,bwdt,bcol
c         ie1,ie2  element pair to be joined by bonds
c         dmin     min. distance to be joined
c         dmax     max. distance to be joined
c         bwdt     bond width (1,2,3 etc. means 0.1,0.2,0.3 mm)
c         bcol     bond color (color display) or pen number (plotter)
c           for display
c           1:blue,2:red,3:purple,4:green,5:sky blue,6:yellow,7:white
c                  (default: white)
c                 repeat (24) np times
c     (22) (Sij,j=1,3),Ti)    (*)
c            S :transformation matrix of the coordinate (integer)
c            T :translation vector
c             repeat (10) three times (i=1,2,3)
c  ******* repeat (23)-(26) ng times ***********
c     (23) hp,yp,amgn,xvp,pshft
c         hp(1)-hp(3) direction of projection  (default: -0.4,-0.2,-0.05)
c             hp = hp(1)a + hp(2)b + hp(3)c
c         yp(1)-yp(3)  crystal axis parallel to the y axis on the display
c                (default: z axis (0.0,0.0,1.0)
c             yp = yp(1)a + yp(2)b + yp(3)c
c           x axis rightword, y axis upword  origin lower left corner
c         amgn  magnification of x,y,radius  (cm/angstrome)
c               (default: 1.0)
c          xvp  distance from visual point to origin (in angstrom)
c               (default: 20.0)
c          pshft(1)-pshft(3)  shift of origin along a4, a5, a6  (phase shift)
c   ******if nb=0 skip (24)******
c     if nb>=4
c     (*24) hb,xb
c          hb(1)-hb(3): normal to boundary plane  (scissoring boundary)
c              hb = hb(1)a* + hb(2)b* + hb(3)c*
c          xb(1)-xb(3): vecotr on the boundary plane
c              xb = xb(1)a  + xb(2)b  + xb(3)c
c          for the atom at x,y,z in a crystal, if
c               hb(1)(x-xb(1))+hb(2)(y-xb(2))+hb(3)(z-xb(3))<0
c          then the atom is included, else excluded
c          if nb<=-4 hb,xb1(1),..,xb2(1),..  (6f8.5/(24x,3f8.5))
c     if nb=1
c     (*24) xr,yr,zr
c           xr(1)-xr(2),yr(1)-yr(2),zr(1)-zr(2):ranges for x, y, z coordinates
c           if nb<0,  repeat (*24) ne times
c     (25) lxmin,lxmax,lymin,lymax,lzmin,lzmax
c          ranges of the lattice vector along x y and z axes
c     (26) xo,yo,x1,y1,x2,y2
c          xo,yo: sift of origin (in cm) before plot
c          x1,y1: lower left corner of the viewport
c          x2,y2: upper right corner of the viewport
c             x1,y1,x2,y2 are necessary only for jvw=1
c     (27) fxyz
c          fxyz(1)-fxyz(3): fixed point (a,b,c coordinate)
c
c******************limiting conditions******************************
c      maximum number of atoms in a unit cell <= namax (100)
c      maximum number of atoms in each elements <= nbmax/ne (4000/ne)
c
c*******************************************************************
c
      include 'prjms.inc'
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /kwave/ y(3,3,3),vc(3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /cwflag/ iwflag(6)
      common /cdim/ idm,nde
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
c     parameter (mmax=50000)
      parameter (mmax=800000)
      dimension ax(mmax)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      integer dspmdl,tmpmdl,sctmdl
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4,na8,na9
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *,ix13
      character*80 flnm0, flnm1, flnm2, flnm3, flnm4
      integer defiwf(6)
      data zmtrx /1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6/
c    memory design  (the large array, ax, are devided into 25 parts
c    and each part is used as a different array in several subroutines)
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p, ax(na8):isub, ax(ix1):x1
c  ax(ix1):xx, ax(ix2):mx, ax(ix3):ea, ax(ix4):xjl, ax(ix5):bjl,
c  ax(ix6):fjl, ax(ix7):csb, ax(ix8):ja, ax(ix9):ifrt1, ax(ix10):ifrt2
c  ax(ix11):coeff, ax(ix12):x1

      pai2=6.28318

      call setinp(5)
      call freadi('jcont=',1,jcont,1)
      call freadi('inpu=',1,inpu,0)
      write(6,'(1h ,3(a,i3))') 'jcont=',jcont,
     *                           ' inpu=',inpu
      if(inpu.eq.0) then
          read(5,'(a)') flnm0
          lfn0=istrln(flnm0)
          write(6,'(1h ,a)') flnm0(1:lfn0)
          inpu=2
          open(unit=inpu,file=flnm0)
      else
          inpu=5
      end if
      call setinp(inpu)
      call setout(6)
c     skip to the beginning of the remos file
      call setskp(1)
      call getinp(inpu)
      call getout(iout)
c (0) read output control flags
c     read(inpu,'(6i1)') (iwflag(i),i=1,6)
      call freadi('iwflag=',6,iwflag,1)
      if(iwflag(1).eq.0) then
           do 9 i=1,6
 9         iwflag(i)=defiwf(i)
      end if
      write(iout,'(1h ,a,6i3)') 'output control flags  ', iwflag
      read(inpu,'(a)') flnm1
      read(inpu,'(a)') flnm2
      read(inpu,'(a)') flnm3
      read(inpu,'(a)') flnm4
      lfn1=istrln(flnm1)
      lfn2=istrln(flnm2)
      lfn3=istrln(flnm3)
      lfn4=istrln(flnm4)
      write(iout,'(1h ,a)') flnm1(1:lfn1)
      write(iout,'(1h ,a)') flnm2(1:lfn2)
      write(iout,'(1h ,a)') flnm3(1:lfn3)
      write(iout,'(1h ,a)') flnm4(1:lfn4)
      open(unit=3,file=flnm1)
      open(unit=4,file=flnm2)
      open(unit=91,file=flnm3,access='direct',recl=1200)
      open(unit=92,file=flnm4,access='direct',recl=800)
      call rdlc
c      read(inpu,'(i3)') na
      call freadi('na=',1,na,1)
      call freadi('nsub=',1,nsub,0)
      if(nsub.le.0.or.nsub.gt.3) call quit('*** nsub invalid***')
      if(nsub.ge.2) then
          call freadi('zmtrx=',6,zmtrx(1,2),0)
      end if
      if(nsub.eq.3) then
          call freadi('zmtrx=',6,zmtrx(1,3),0)
      end if
      if(iwflag(3).eq.1) then
           write(6,*) 'na=',na,'nsub=',nsub,
     *        ('zmtrx=',(zmtrx(i,n),i=1,6),n=2,nsub)
      end if
      na1=1
      na2=na+na1
      na3=na+na2
      na4=6*na+na3
      na5=49*na+na4
      na6=49*na+na5
      na7=na+na6
      na8=na+na7
      na9=na+na8
c      call rdap(na,isft,x,b,p,isub)
      call rdap(na,ax(na1),ax(na3),ax(na6),ax(na7),ax(na8))
c     call rdsymo(na,isk)
      call rdsymo(na,ax(na4))
      call getgij(zmtrx,nsub)
      call gettrm(zmtrx,nsub)
c     call btobij(na,ax(na6),ax(na8))
c     call btobij(na,ax(na6),ax(na8))
c     call sitesy(na,mpl,x,isk,irs,isub)
      call sitesy(na,ax(na2),ax(na3),ax(na4),ax(na5),ax(na8))
c      read(inpu,'(13i3)') ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,
c     *      itvr,itst,nxmax
       call freadi('ix=',1,ix,1)
       call freadi('ib=',1,ib,0)
       call freadi('if=',1,if,0)
       call freadi('nds=',1,nds,0)
       call freadi('nzc=',1,nzc,0)
       call freadi('nw=',1,nw,0)
       call freadi('nt=',1,nt,0)
       call freadi('ipol=',1,ipol,0)
       call freadi('ipnf1=',1,ipnf1,0)
       call freadi('ipnf2=',1,ipnf2,0)
       call freadi('itvr=',1,itvr,0)
       call freadi('itst=',1,itst,0)
       call freadi('nxmax=',1,nxmax,0)
***************
      nds=0
***************
      if(nxmax.eq.0) nxmax=250
      write(6,207) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,
     *        itst,nxmax
c      read(inpu,'(4i3)') dspmdl,tmpmdl,sctmdl,itempf
      call freadi('dspmdl=',1,dspmdl,1)
      call freadi('tmpmdl=',1,tmpmdl,0)
      call freadi('sctmdl=',1,sctmdl,0)
      call freadi('itempf=',1,itempf,0)
      call freadi('itwin=',1,itwin,0)
      call freadi('iphfl=',1,iphfl,0)
      call freadi('isext=',1,isext,0)
      if(iwflag(3).eq.1) then
         write(6,206) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
      end if
      if(itwin.eq.0) volr(1)=1.0

      call cnstnt(mmax,iax)
      if(iax.gt.0) go to 20
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p, ax(ix1):x1
c  ax(ix1):xx, ax(ix2):mx, ax(ix3):ea, ax(ix4):xjl, ax(ix5):bjl,
c  ax(ix6):fjl, ax(ix7):csb, ax(ix8):ja, ax(ix9):ifrt1, ax(ix10):ifrt2
c  ax(ix11):coeff, ax(ix12):x1

c     call dmmdpl(isft,x,b,p,isub,isk,mpl,xx,mx,ea,xjl,bjl,fjl,
c         csb,ja,ifrt1,ifrt2,coeff,x1,nx,na,nl,nw,nt,nzc,it,jcont)

      call dmmdpl(ax(na1),ax(na3),ax(na6),ax(na7),ax(na8),ax(na4),
     *   ax(na2),ax(ix1),ax(ix2),ax(ix3),ax(ix4),ax(ix5),ax(ix6),
     *   ax(ix7),ax(ix8),ax(ix9),ax(ix10),ax(ix11),ax(ix12),nx,na,
     *   nl,nw,nt,nzc,it,jcont)
      close(unit=4)

      stop
 20   write(6,200) iax
      stop
 200  format(1h ,'lack of dimension',10x,'ax=',i6)
 206  format(1h ,'dspmdl=',i3,3x,'tmpmdl=',i3,3x,'sctmdl=',i3,3x,
     *      'itempf=',i3,3x,'itwin=',i3,3x,'iphfl=',i3,3x,'isext=',i3)
 207  format(1h ,'ix=',i3,2x,'ib=',i3,2x,'if=',i3,2x,'nds=',i3,2x,
     *      'nzc=',i3,2x,'nw=',i3,2x,'nt=',i3,2x,'ipol=',i3,2x,'ipnf1=',
     *    i3,2x,'ipnf2=',i3,2x,'itvr=',i3,2x,'itst=',i3,2x,'nxmax=',i3)
      end

      subroutine cnstnt(mmax,iax)
c     calculation of constants
c      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /cnsti/ ix,ib,if,itvr,itst,nds,na4,na8,na9
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *,ix13
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /cdim/ idm,nde
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
c    memory design  (the large array, ax, are devided into 25 parts
c    and each part is used as a different array in several subroutines)
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p, ax(na8):isub, ax(ix1):x1
c  ax(ix1):xx, ax(ix2):mx, ax(ix3):ea, ax(ix4):xjl, ax(ix5):bjl,
c  ax(ix6):fjl, ax(ix7):csb, ax(ix8):ja, ax(ix9):ifrt1, ax(ix10):ifrt2
c  ax(ix11):coeff, ax(ix12):x1
c*********************************************************
c    calculation of constants for memory design
c*********************************************************
      pai2=6.28318
      nl=1
      do 10 i=1,nde
 10   nl=nl*ilm(i)
      do 11 i=1,3
 11   nl=nl*ilc(i)
      nx=ix+ib+if+itvr+itst+nds
      if(isext.eq.1) nx=nx+2
      if(itempf.ne.0) it=6
      if(itempf.eq.0) it=1
      if(iphfl.eq.1) it=it+nde*(nde+1)/2
c     ix1=na8
      ix1=na9
      ix2=na*(it+4)*nw+ix1
      ix3=na*(it+4)*nw+ix2
      ix4=nzc+ix3
      ix5=3*na*nl+ix4
      ix6 =it*na*nl+ix5
      ix7 =na*nl+ix6
      ix8 =nw*na*nl+ix7
      ix9 =4*nzc+ix8
      ix10=nw*2*nt+ix9
      ix11=nw*3*nt+ix10
      ix12=nw*nt+ix11
      ix13=nx+ix12
      iax=ix13-mmax-1
      return
      end

      subroutine dmmdpl(isft,x,b,p,isub,isk,mpl,xx,mx,ea,xjl,bjl,fjl,
     *   csb,ja,ifrt1,ifrt2,coeff,x1,nx,na,nl,nw,nt,nzc,it,jcont)
      dimension isft(*),x(*),b(*),p(*),xx(*),mx(*),ea(*),xjl(*),bjl(*),
     *        fjl(*),csb(*),ja(4,*),ifrt1(*),ifrt2(*),coeff(*),x1(*),
     *           isk(*),isub(*)
      real mpl(*)
      character*4 ifrt1,mx
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      common /citfs/ itfs(100)
      common /cwflag/ iwflag(6)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      character*4 watom
      data watom/'atom'/

      call getinp(inpu)
      if(itempf.lt.0) read(inpu,'(80i1)') (itfs(i),i=1,na)
      if(iwflag(3).eq.1) then
         if(itempf.lt.0) write(6,201) (watom,i,itfs(i),i=1,na)
 201     format('selection of temperature factors, 0: isotropic',
     *       ' 1: anisotropic'/(1h ,10(a4,i2,':',i1,2x)))
      end if
      call btobij(na,b,isub)
c     call btobij(na,ax(na6),ax(na8))
c (14) read symmetry operators for twin
c      if(itwin.ne.0) call rdtsym(itwin)
c (15)-(19) read atomic scattering factors
c      call rdasf(sctmdl)
c (20)-(21) read data for the second penalty function
c      if(ipnf2.eq.1) call rdpnf2
c (22)-(26) read data for extinction correction
c      if(isext.ne.0) call rdextc(isext)

      call rdfour(nw,nt,ifrt1,ifrt2,coeff)
      nc=4+it
      call rdintl(xx,mx,ja,ea,x1,isub,na,nc,nu)
      if(jcont.eq.1) read(4,'(8e14.6)') (x1(j),j=1,nu)
      call prmtbl(x1,df,isub,ips,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,it,nl,1)
      call setinp(5)
      call setskp(0)
      call rdprjp(x1,ja,ea,nx,nzc,xjl,bjl,fjl,csb,it,nw,nt,
     *         na,nl,isft,x,b,p,isub,ifrt1,ifrt2,coeff,isk,mpl)
      return
 101  format(4f12.6,i3)
 102  format(20a4)
 103  format(6f12.6)
 104  format(4i3,4f10.5)
 203  format(1h ,20a4)
 204  format(1h ,5hamin=,f6.2,3x,5hamax=,f6.2,3x,5hbmin=,f6.2,3x,
     15hbmax=,f6.2,3x,5hdiva=,f6.2,3x,5hdivb=,f6.2)
 205  format(1h ,3x,2ha=,f12.6,3x,2hb=,f12.6,3x,5hcosc=,f12.6,3x,
     1'amagn=',f5.3,3x,'irl=',i3)
      end

      subroutine rdprjp(xx,ja,ea,nx,nzc,xjl,bjl,fjl,csb,it,nw,nt,
     *          na,nl,isft,x,b,p,isub,ifrt1,ifrt2,coeff,isk,mpl)
      character*4 ifrt1
      real mpl(*)
      dimension isft(*),x(6,*),b(*),p(*),isub(*),xx(*),ea(*),xjl(*),
     *    bjl(*),fjl(*),csb(*),ja(4,*),ifrt1(*),ifrt2(*),coeff(*),
     *    isk(0:48,*)
      include 'prjms.inc'
      dimension hp(3),yp(3),rad(20),h(3)
      dimension ias(48,namax),pmin(namax)
      dimension sarc(2,nbmax),nnarc(nbmax)
      dimension ie1(20),ie2(20),dmin(20),dmax(20)
      dimension elmx(3,nbmax),iflag(nbmax),r(nbmax),xt(3,nbmax)
      dimension ir(3,nbmax),iu(3,nbmax),csbd(nbmax)
      common /cips/ ips
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(20),bwdt(20),bcol(20),ccol,dcol,jmod,ldev
      common /ctocss/ hb(3,20),d(20,20),nb
      integer pcol
      common /cpcol/ pcol
      common /cdim/ idm,nde
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      common /kwave/ y(3,3,3),vc(3)
      common /cctr/ ctr(6,0:48),nctr
      common /ctwait/ iwt1,iwt2,iwt3
      common /cwflg1/ iwb,iwc,iwa,iww
      common /clrang/ lxmin,lxmax,lymin,lymax,lzmin,lzmax
      dimension xd(3),xb(3,20),icd(8),jcd(4),iscl(7)
      dimension xr(2),yr(2),zr(2)
      character*6 atom
      common /cltc/ atom(namax)
      integer sij
      common /ctrns/ sij(3,3),tj(3)
      real op(3,3),ori(3,3),opi(3,3)
      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      real x0(6,namax),pshft(3),td(6,48,3),atr(3,48)
      data nbd/6/,xb/0.,0.,0.,1.,0.,0.,0.,0.,0.,
     *   0.,1.,0.,0.,0.,0.,0.,0.,1.,42*0./,icd/7,1,2,3,4,5,6,7/,
     *   jcd/3,2,0,1/,hb/-1.,0.,0.,1.,0.,0.,0.,-1.,0.,0.,1.,0.,
     *   0.,0.,-1.,0.,0.,1.,42*0./
c*****initial pen color
      pcol=1
c      read(5,100) ne,np,nb1,ng
      call freadi('ne=',1,ne,1)
      call freadi('np=',1,np,0)
      call freadi('nb=',1,nb1,0)
      call freadi('ng=',1,ng,0)
      if(ng.eq.0) ng=1
      write(6,200) ne,np,nb1,ng
      if(ne.gt.20) call quit('ne > 20')
      if(np.gt.20) call quit('np > 20')
      if(abs(nb1).gt.20) call quit('|np| > 20')
c      read(5,'(8i1)') ldev,iww,iwb,iwc,iwa,ips,ccol,jmod,jvw
      call freadi('ldev=',1,ldev,1)
      call freadi('iww=',1,iww,0)
      call freadi('iwb=',1,iwb,0)
      call freadi('iwc=',1,iwc,0)
      call freadi('iwa=',1,iwa,0)
      call freadi('ips=',1,ips,0)
      call freadi('ccol=',1,ccol,0)
      call freadi('jmod=',1,jmod,0)
      call freadi('jvw=',1,jvw,0)
      if(ldev.eq.0) ldev=1
      if(ldev.eq.2) then
          ccol=icd(ccol+1)
      end if
      write(6,201) ldev,iww,iwb,iwc,iwa,ips,ccol,jmod
********
      if(icent.eq.0) then
          iend=nsymo
      else
          iend=nsymo*2
      end if
c     read(5,103) (pmin(j),(ias(i,j),i=1,iend),j=1,na)
      do 12 j=1,na
         call freadr('pmin=',1,pmin(j),1)
         call freadi('ias=',iend,ias(1,j),0)
         write(6,208) j,pmin(j),(ias(i,j),i=1,iend)
 12   continue
c*****read radii and color of atoms**********
c      read(5,106) (rad(i),acol(i),i=1,ne)
      do 10 i=1,ne
          call freadr('rad=',1,rad(i),1)
          call freadi('acol=',1,acol(i),0)
 10   continue
      if(ldev.eq.2) then
          do 52 i=1,ne
          if(acol(i).eq.0) acol(i)=1
 52       continue
      end if
      write(6,207) (rad(i),acol(i),i=1,ne)
c****   find unused color
      if(ldev.eq.2) then
          do 54 i=1,7
 54       iscl(i)=0
          iscl(7)=1
          do 55 i=1,ne
          iscl(acol(i))=1
 55       continue
          do 56 i=1,7
          if(iscl(i).eq.0) then
               dcol=i
               go to 57
          end if
 56       continue
 57       continue
      end if
c*****read element pairs joined by bonds**********************
      if(iwb.eq.0) then
c           read(5,104) (ie1(i),ie2(i),dmin(i),dmax(i),bwdt(i),
c     *                              bcol(i),i=1,np)
            do 11 i=1,np
            call freadi('ie1=',1,ie1(i),1)
            call freadi('ie2=',1,ie2(i),0)
            call freadr('dmin=',1,dmin(i),0)
            call freadr('dmax=',1,dmax(i),0)
            call freadi('bwdt=',1,bwdt(i),0)
            call freadi('bcol=',1,bcol(i),0)
            if(ie1(i).gt.ne.or.ie1(i).lt.0) call quit('ie1>ne or <0')
            if(ie2(i).gt.ne.or.ie2(i).lt.0) call quit('ie2>ne or <0')
 11         continue
            if(ldev.eq.2) then
               do 53 i=1,np
c               default bond color ==> black
               if(bcol(i).eq.0) bcol(i)=0
 53            continue
            end if
            write(6,209) (ie1(i),ie2(i),dmin(i),dmax(i),bwdt(i),
     *                                          bcol(i),i=1,np)
      end if
c      if(ldev.eq.2) then
c           if(kdsp.eq.1.or.kdsp.eq.2) then
c                do 20 i=1,np
c 20             bcol(i)=7
c                ccol=7
c           end if
c      end if

      do 320 i=1,3
          read(5,*) (sij(i,j),j=1,3),tj(i)
 320  continue
c     setting transformation
      write(6,*) 'setting transformation'
      do 321 i=1,3
          write(6,*) (sij(i,j),j=1,3),tj(i)
 321  continue

********************************
      do n=1,na
         call vcpy(x(1,n),x0(1,n),6)
      end do
      do i=1,nsub
         do n=1,nsymo
            call vcpy(tt(1,n,i),td(1,n,i),6)
         end do
      end do
********************************

      call plots(0.,0.,ldev)
      do 300 jg=1,ng
c*****read projection axis,y axis and magnification**********
c      read(5,102) h,x,amgn,xvp(3)
       call freadr('hp=',3,hp,1)
       call freadr('yp=',3,yp,0)
       call freadr('amgn=',1,amgn,0)
       call freadr('xvp=',1,xvp(3),0)
       call freadr('pshft=',3,pshft,0)
      if(hp(1).eq.0.and.hp(2).eq.0.and.hp(3).eq.0) then
           hp(1)=-0.4
           hp(2)=-0.2
           hp(3)=-0.05
      end if
      if(yp(1).eq.0.and.yp(2).eq.0.and.yp(3).eq.0) then
           yp(1)=0.0
           yp(2)=0.0
           yp(3)=1.0
      end if
      if(amgn.eq.0) amgn=1.
      write(6,2040) h,yp,amgn
      if(ips.eq.0) then
           do 15 ix=1,3
 15        xvp(ix)=0
      else
          if(xvp(3).eq.0) then
               xvp(3)=20.
          end if
          write(6,2041) xvp
      end if
      write(6,*) 'pshft=',pshft
      do n=1,na
         do j=4,6
            x(j,n)=-pshft(j-3)
         end do
      end do
c     additional translations due to the origin shift along a4, a5, a6
      do n=1,nsymo
         do j=1,3
            atr(j,n)=pshft(j)
            do k=1,3
               atr(j,n)=atr(j,n)-rr(j+3,k+3,n,1)*pshft(k)
            end do
         end do
      end do

      do n=1,nsymo
         do j=4,6
            tt(j,n,1)=td(j,n,1)+atr(j-3,n)
         end do
      end do
c*****transformation matrix to the plotter system
      call xxx(hp)
      call xxx(yp)
      call ormtrx(hp,yp,on)

c        transformation to the plotter system
c      call mxv(on,xvp) 

c*****read boundary onditions*********

      if(abs(nb1).lt.4) ie=1
      if(abs(nb1).ge.4) ie=abs(nb1)
      if(abs(nb1).ge.4) write(6,213)
      do 30 i=1,ie
      if(nb1.ge.0) ke=1
      if(nb1.lt.0) ke=ne
      do 37 k=1,ke
      if(abs(nb1).eq.1) then
c           read(5,102) xb(1,1),xb(1,2),xb(2,3),xb(2,4),xb(3,5),xb(3,6)
           call freadr('xr=',2,xr,1)
           call freadr('yr=',2,yr,0)
           call freadr('zr=',2,zr,0)
           write(6,211) xr(1),xr(2),yr(1),yr(2),zr(1),zr(2)
           do 371 j=1,2
             xb(1,j)  =xr(j)
             xb(2,j+2)=yr(j)
             xb(3,j+4)=zr(j)
 371       continue
      else if(abs(nb1).ge.4) then
           if(k.eq.1) then
c              read(5,102) (hb(j,i),j=1,3),(xb(j,i),j=1,3)
              call freadr('hb=',3,hb(1,i),1)
              call freadr('xb=',3,xb(1,i),0)
              write(6,206) (hb(j,i),j=1,3),(xb(j,i),j=1,3)
           else
c              read(5,107) (xb(j,i),j=1,3)
              call freadr('xb=',3,xb(1,i),1)
              write(6,212) (xb(j,i),j=1,3)
           end if
      end if
      if(abs(nb1).ge.4) then
           ids=i
           ide=i
      else
           ids=1
           ide=nbd
      end if

      do 35 id=ids,ide
      if(k.eq.1) then
           do 31 j=1,3
 31        h(j)=hb(j,id)
           call yyy(h)
           absh=sqrt(h(1)**2+h(2)**2+h(3)**2)
           do 32  j=1,3
           h(j)=h(j)/absh
 32        hb(j,id)=h(j)
      end if
      do 33 j=1,3
 33   xd(j)=xb(j,id)
      call xxx(xd)
      d(id,k)=0.
      do 34 j=1,3
 34   d(id,k)=d(id,k)+hb(j,id)*xd(j)
      d(id,k)=d(id,k)+0.001
      if(nb1.ge.0) then
           do 36 kd=2,ne
 36        d(id,kd)=d(id,1)
      end if
 35   continue
 37   continue
 30   continue

      if(abs(nb1).lt.4) nb=nbd
      if(abs(nb1).ge.4) nb=abs(nb1)
c********** read ranges of lattice vectors******
      call freadi('lxmin=',1,lxmin,1)
      call freadi('lxmax=',1,lxmax,0)
      call freadi('lymin=',1,lymin,0)
      call freadi('lymax=',1,lymax,0)
      call freadi('lzmin=',1,lzmin,0)
      call freadi('lzmax=',1,lzmax,0)
      write(6,*) 'lxmin=',lxmin,' lxmax=',lxmax,
     *          ' lymin=',lymin,' lymax=',lymax,
     *          ' lzmin=',lzmin,' lzmax=',lzmax
c********** read sift of origin **********
       nl=(lxmax-lxmin+1)*(lymax-lymin+1)*(lzmax-lzmin+1)
       if(nw*nl.gt.nbmax) call quit('nw*nl > nbmax in csbd')
c      read(5,105) xo,yo
      call freadr('xo=',1,xo,1)
      call freadr('yo=',1,yo,0)
      if(jvw.eq.1) then
          call freadr('x1=',1,x1,0)
          call freadr('y1=',1,y1,0)
          call freadr('x2=',1,x2,0)
          call freadr('y2=',1,y2,0)
      end if
      write(6,210) xo,yo
c      read(5,'(3f8.5)') fxyz(1),fxyz(2),fxyz(3)
      call freadr('fxyz=',3,fxyz,1)
      write(6,'(1h ,3f8.5)') fxyz(1),fxyz(2),fxyz(3)
      call xxxs(fxyz,1)
      call mxv(on,fxyz)
c      call gauss
      if(jvw.eq.1) then
          fct=29.7
c         call window(x1*fct,y1*fct,x2*fct,y2*fct)
          call window(x1,y1,x2,y2)
          call viewpt(x1/fct,y1/fct,x2/fct,y2/fct)
      end if
      call plot(xo,yo,-3)
      call patom(na,nw,nt,nl,ne,np,x,b,p,isub,isk,mpl,
     *      isft,ias,pmin,rad,csbd,ifrt1,ifrt2,coeff,ja,ea,xx,
     *      ie1,ie2,dmin,dmax,elmx,sarc,nnarc,
     *      or,op,ori,opi,iflag,r,xt,ir,iu)
 300  continue
      call plote('end of plot')
      if(ldev.eq.1.or.ldev.eq.2) then
          call getzap()
      end if
      stop
 100  format(16i3)
 101  format(9f5.1,3f9.6)
 102  format(10f8.5)
 103  format(72i1)
 104  format(2i3,2f8.5,i3)
 105  format(2f8.5,3i5)
 106  format(8(f8.5,i2))
 107  format(24x,3f8.5)
 200  format(1h ,'ne=',i3,1x,'np=',i3,1x,'nb=',i3,1x,'ng='i3)
 201  format(1h ,'ldev=',i1,2x,'iww=',i1,2x,'iwb=',i1,2x,'iwc=',i1,
     *      2x,'iwa=',i1,2x,'ips=',i1,2x,'ccol=',i1,2x,'jmod=',i1)
 202  format(1h ,'centering translations'/(1h ,3f8.5))
 203  format(1h ,'lattice translations  '/(1h ,3f8.5))
 2040 format(1h ,'plane normal',3f8.5/1h ,'y-axis',6x,3f8.5/1h ,
     *       'magnif.',5x,f8.5)
 2041 format(1h ,'visual point',5x,3f10.5)
 205  format(1h ,'boundary cond.')
 206  format(1h ,3f8.5,2x,3f8.5)
 207  format(1h ,'atom radius and color'/(1h ,8(f8.5,i2)))
 208  format(1h ,'atom ',i3,':','pmin=',f7.4,' ias=',48i1)
 209  format(1h ,'element pair',6x,'dmin',6x,'dmax',6x,'lwidth',6x,
     *    'color'/(1h ,4x,2i3,4x,2f10.6,4x,i3,4x,i3))
 210  format(1h ,'origin',2x,2f9.5)
 211  format(1h ,'range   ',3(' (',f8.5,'-',f8.5,') '))
 212  format(1h ,26x,3f8.5)
 213  format(1h ,'hb',26x,'xb')
      end

      subroutine patom(na,nw,nt,nl,ne,np,x,b,p,isub,isk,mpl,
     *     isft,ias,pmin,rad,csb,ifrt1,ifrt2,coeff,ja,ea,xx,
     *     ie1,ie2,dmin,dmax,elmx,sarc,nnarc,
     *     or,op,ori,opi,iflag,r,xt,ir,iu)
      real mpl
      dimension x(6,*),b(*),p(*),isub(*),isk(0:48,*),mpl(*)
      dimension isft(*),ias(48,*),pmin(*),rad(*),csb(nw,*)
      character*4 ifrt1
      dimension ifrt1(nw,2,*),ifrt2(nw,3,*),coeff(nw,*),ja(4,*),ea(*)
      dimension xx(*),ie1(*),ie2(*),dmin(*),dmax(*),elmx(3,ne,*)
      dimension sarc(2,ne,*),nnarc(ne,*),or(3,*)
      dimension op(3,*),ori(3,*),opi(3,*),iflag(ne,*),r(ne,*)
      dimension xt(3,ne,*),ir(3,ne,*),iu(3,ne,*)
      dimension icell(3,8),xcl(3,8),x1(3),x2(3),xc(3),ipc(2,12)
      dimension x3(3),x4(3)
      dimension ip(20),nelmx(20),iarc(20),sd(3),rd(6),xd(6)
      real sx(3),u2(3),u3(3)
      common /cips/ ips
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /cwflg1/ iwb,iwc,iwa,iww
      common /cdim/ idm,nde
      integer rr
c      common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /cctr/ ctr(6,0:48),nctr
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(20),bwdt(20),bcol(20),ccol,dcol,jmod,ldev
      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      common /clrang/ lxmin,lxmax,lymin,lymax,lzmin,lzmax
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      integer sij
      common /ctrns/ sij(3,3),tj(3)
      include 'prjms.inc'
      real xtemp(nbmax),ctrd(6),trd(6)
      integer itemp(nbmax*2),nold(nbmax)
      save nad

      data icell/0,0,0,1,0,0,1,1,0,0,1,0,0,0,1,1,0,1,1,1,1,0,1,1/
      data ipc/1,2,2,3,3,4,4,1,5,6,6,7,7,8,8,5,1,5,2,6,3,7,4,8/
      data eps/0.001/, rd/6*0./

c ********************************************************************
c *   projection of crystal structures surrounded by the scissoring  *
c *             boundary planes  ( max. 10 planes )                  *
c ********************************************************************
c     na: number of independent atoms <=100
c     ns: number of symmetry operators 1<=ns<=60
c     ic: =0, noncentrosymmetric, =1, centrosymmetric
c     np: number of element pairs to be joined by bonds
c     xa: coordinates of independent atoms
c     isft: element number for x
c     ias: if ias(i,j)=1, then j-th atom generated by i-th
c          symmetry operator is plotted
c     pmin: minimum occupation probability of plotted atonm
c     ro: rotational part of symmetry operators
c     tr: translational part of symmetry operators
c     ctr: centering translations in (n+d) superspace group
c     rad: rad(i), radius of i-th element
c     ne: number of elements
c     ie1(i),ie2(i) : i-th pair of elements to be joined by bond
c     dmin, dmax: minimum and maximum distances of bonds
c     elmx: work area
c     amgn: magnification
c     iwb=0: write bonds
c     iwc=0: write unit cell
c     iwa=0: write all atoms, =1: write only atoms joined by bonds
c     iww=1: write x,y,z coordinates of atoms
c     ips=1: perspective drawing
c     xvp:   visual point in primary system

c*****initialize*******************************
      do 60 i=1,ne
      iarc(i)=0
 60   nelmx(i)=0
      do 61 i=1,ne
      do 61 j=1,nbmax/ne
 61   iflag(i,j)=0
c*****genelation of equivalent atoms**********
c
      ilm(1)=1
      ilm(2)=1
      ilm(3)=1
      ilc(1)=lxmax-lxmin+1
      ilc(2)=lymax-lymin+1
      ilc(3)=lzmax-lzmin+1
      nl=ilc(1)*ilc(2)*ilc(3)
      icorc(1)=0
      icorc(2)=0
      icorc(3)=0
*************************
      nad=na
      iii=0
      do 70 jk=1,na
      js=isub(jk)
      if(icent.eq.1.and.mpl(jk).gt.0.51) then
          ice=1
      else
          ice=0
      end if
c     symmetry operation loop
      do 701 jt=0,nctr
      do 700 jj=1,isk(0,jk)
      do 700 ic=0,ice
          ns=isk(jj,jk)
          if(ias(ns,jk).eq.0) go to 700
          call getzx(zmtrx(1,js),ctr(1,jt),ctrd)
c           centering translation after the inversion
          do 712 id=1,6
              if(ic.eq.1) then
                  ctrd(id)=-ctrd(id)
              end if
 712      continue
          do 710 id=1,3
 710      trd(id)=tt(id,ns,js)+ctrd(id)
          do 711 id=4,6
 711      trd(id)=0
          call getrx(x(1,jk),xd,rr(1,1,ns,js),trd,1,ic)
          call gauss(isub(jk))
          call begin(csb,nw,nt,1,nl,xd,isub(jk),ifrt1,ifrt2,
     *                                coeff,ns,ic,ctrd)
          l=0
          do 116 l3=lzmin,lzmax
          do 117 l2=lymin,lymax
          do 118 l1=lxmin,lxmax
               l=l+1
               do 73 j=1,3
 73            u2(j)=0
               p2=p(jk)
               jn=0
               do 74 i=i1,i6
               nz=ja(4,i)
                   do 741 nn=1,nz
                   in=jn+nn
                   jkd=ja(1,in)
                   j=ja(2,in)
                   jw=ja(3,in)
                   if(j.lt.1.or.j.gt.6) then
                       write(6,*) 'i,nz,in,jkd,j,jw',i,nz,in,jkd,j,jw
                       call quit(' ')
                   end if
                   if(i.ge.i1.and.i.le.i2) then
                     if(jkd.eq.jk) u2(j)=u2(j)+xx(i)*ea(in)*csb(jw,l)
                   else if(i.ge.i5.and.i.le.i6) then
                     if(jkd.eq.jk) p2=p2+xx(i)*ea(in)*csb(jw,l)
                   end if
 741               continue
               jn=jn+nz
 74            continue
               do 751 j=1,3
 751           u3(j)=rr(j,1,ns,js)*u2(1)+rr(j,2,ns,js)*u2(2)+
     *                                    rr(j,3,ns,js)*u2(3)
               if(ic.eq.1) then
                   do 752 j=1,3
                        u3(j)=-u3(j)
 752               continue
               end if
               sx(1)=u3(1)+xd(1)+l1
               sx(2)=u3(2)+xd(2)+l2
               sx(3)=u3(3)+xd(3)+l3
               call settng(sx,sij,tj)
               call cpyvec(sx,sd)
               call sciss(sx,iscis,isft(jk),isub(jk))
               if(iscis.eq.1) go to 118
c              atoms within the scissoring boundarys
               if(p2.gt.pmin(jk)) then
                    ie=isft(jk)
                    if(ie.gt.ne) then
                       write(6,*) 'isft=',ie,' ne=',ne
                       call quit('isft > ne')
                    end if
                    if(ie.le.0) call quit('isft <= 0')
                    nelmx(ie)=nelmx(ie)+1
                    n=nelmx(ie)
                    if(n.ge.nbmax) then
                       write(6,*) 'n=',n,' nbmax=',nbmax
                       call quit('n >= nbmax in xt')
                    end if
                    call cpyvec(sd,xt(1,ie,n))
                    if(ne*n.gt.nbmax) then
                       write(6,*) 'ne=',ne, ' n=',n
                       call quit('ne*n > nbmax')
                    end if
                    if(ie.gt.ne) then
                       write(6,*) 'ie=',ie,' ne=',ne
                       call quit('ie > ne')
                    end if
                    ir(1,ie,n)=jk
                    if(iww.eq.1) then
                        ir(2,ie,n)=ns+nsymo*ic
                        ir(3,ie,n)=jt
                        iu(1,ie,n)=l1
                        iu(2,ie,n)=l2
                        iu(3,ie,n)=l3
                    end if
               end if
 118      continue
 117      continue
 116      continue
 700  continue
 701  continue
 70   continue
c             xt(i,ie,n)   x,y,z coordinates generated
c             ir(i,ie,n)   atom number, symm. op, ic
c             iu(i,ie,n)   additional lattice translation
      do 300 ie=1,ne
      do 310 n=1,nelmx(ie) 
      call cpyvec(xt(1,ie,n),sd)
         js=isub(ir(1,ie,n))
c        viewing transformation
           call rmx(sd,xc,ips,fact,js)
           if(fact.lt.0) go to 310
c        viewing transformation for radius
           r(ie,n)=rad(ie)*amgn*fact
c
c          save atom coordinates in the plotter system
c
           elmx(1,ie,n)=xc(1)
           elmx(2,ie,n)=xc(2)
           elmx(3,ie,n)=xc(3)


 310  continue
 300  continue

c*****sort so that elmx(3,ie,n) > elmx(3,ie,n-1)

      do 350 ie=1,ne
           if(nelmx(ie).gt.nbmax/ne) then
                 call quit('no. of atoms/elm > nbmax/ne')
           end if
           neie=nelmx(ie)
           do 360 n=1,neie
           xtemp(n)=elmx(3,ie,n)
 360       continue
c          rearrange xtemp in ascending order 
           call qsort(xtemp,itemp,nold,neie)
c          rearrange corresponding elmx
           call arrng(elmx,3,ne,ie,xtemp,nold,neie)
c          rearrange corresponding xt
           call arrng(xt,3,ne,ie,xtemp,nold,neie)
c          rearrange corresponding r
           call arrng(r,1,ne,ie,xtemp,nold,neie)
c          rearrange corresponding ir
           call arrng(ir,3,ne,ie,xtemp,nold,neie)
c          rearrange corresponding it
           call arrng(iu,3,ne,ie,xtemp,nold,neie)
 350  continue
      if(iww.eq.1) then
c           printout x, y, z coordinates
            call wrt1(ne,nelmx,xt)
      end if

c*****select atoms joined by bonds

      if(iwa.eq.0) then
           do 51 i=1,np
           do 51 j=1,nelmx(ie1(i))
           if(ie1(i).eq.ie2(i)) then
                ks=j+1
           else
                if(j.eq.1) then
                    ks=1
                    kd=1
                else
                    ks=kd
                end if
           end if
           do 52 k=ks,nelmx(ie2(i))
           jj=ir(1,ie1(i),j)
           kk=ir(1,ie2(i),k)
c           if(isub(jj).eq.isub(kk)) then
              dx=(elmx(3,ie2(i),k)-elmx(3,ie1(i),j))/amgn
              if(-dx.gt.dmax(i)) kd=k
              if(dx.gt.dmax(i)) go to 52
c              do 53 ix=1,3
c              x1(ix)=xt(ix,ie1(i),j)
c 53           x2(ix)=xt(ix,ie2(i),k)
              call cpyvec(xt(1,ie1(i),j),x1)
              call cpyvec(xt(1,ie2(i),k),x2)
              if(isub(jj).ne.1) then
                 call gttrmx(x1,isub(jj))
              end if
              if(isub(kk).ne.1) then
                 call gttrmx(x2,isub(kk))
              end if
              do 57 ix=1,3
 57           sx(ix)=x2(ix)-x1(ix)
              dx=absx(sx,1)
              if(dx.ge.dmin(i).and.dx.le.dmax(i)) then
                   iflag(ie1(i),j)=1
                   iflag(ie2(i),k)=1
              end if
c           end if
 52        continue
 51        continue

c           do 54 ie=1,ne
c           k=0
c           do 55 j=1,nelmx(ie)
cc          select atoms joined by bonds
c           if(iflag(ie,j).eq.0) go to 55
c                k=k+1
c                do 56 ix=1,3
c 56             xt(ix,ie,k)=xt(ix,ie,j)
c                r(ie,k)=r(ie,j)
c 55        continue
c           nelmx(ie)=k
c 54        continue
      end if

c*****plot atoms*********
      do 401 ie=1,ne
 401  ip(ie)=0
c        ip: number of ie-th elements plotted
c***  beginning of loop
 42   continue
      if(iend(ip,nelmx,ne).eq.1) then
           go to 43
      end if
      zmin=1.e32
c***  compare minimum z-coordinates in each element
c               and select minimum among them
      do 402 ie=1,ne
      if(ip(ie).eq.nelmx(ie)) go to 402
      ipd=ip(ie)+1
      if(elmx(3,ie,ipd).lt.zmin) then
           ielm=ie
           zmin=elmx(3,ie,ipd)
      end if
 402  continue
c     ielm: element of atom with minimum z-coordinate
      ipd=ip(ielm)+1
      do 41 ix=1,3
 41   x1(ix)=elmx(ix,ielm,ipd)
      rc=r(ielm,ipd)
      if(jmod.eq.0) then
            call pltat0(x1,rc,acol(ielm))
      else
            call pltat1(x1,rc,acol(ielm))
      end if
      ip(ielm)=ip(ielm)+1
      go to 42
c***  end of loop
 43   continue
c*****plot bonds*********
      if(iwb.eq.0) then
           nd=0
           do 31 i=1,np
           do 31 j=1,nelmx(ie1(i))
           if(ie1(i).eq.ie2(i)) then
                ks=j+1
           else
                if(j.eq.1) then
                    ks=1
                    kd=1
                else
                    ks=kd
                end if
           end if
           do 32 k=ks,nelmx(ie2(i))
           jj=ir(1,ie1(i),j)
           kk=ir(1,ie2(i),k)
c           if(isub(jj).eq.isub(kk)) then
              dx=(elmx(3,ie2(i),k)-elmx(3,ie1(i),j))/amgn
              if(-dx.gt.dmax(i)) kd=k
              if(dx.gt.dmax(i)) go to 31
c              do 33 ix=1,3
c              x1(ix)=elmx(ix,ie1(i),j)
c 33           x2(ix)=elmx(ix,ie2(i),k)
c              do 34 ix=1,3
c 34           sx(ix)=xt(ix,ie2(i),k)-xt(ix,ie1(i),j)

              call cpyvec(elmx(1,ie1(i),j),x1)
              call cpyvec(elmx(1,ie2(i),k),x2)
c              call gttrmx(x1,isub(jj))
c              call gttrmx(x2,isub(kk))
c              dx=(x2(3)-x1(3))/amgn
c              if(-dx.gt.dmax(i)) kd=k
c              if(dx.gt.dmax(i)) go to 31
              call cpyvec(xt(1,ie1(i),j),x3)
              call cpyvec(xt(1,ie2(i),k),x4)
              call gttrmx(x3,isub(jj))
              call gttrmx(x4,isub(kk))
              do 34 ix=1,3
 34           sx(ix)=x4(ix)-x3(ix)
              dx=absx(sx,1)
              if(dx.ge.dmin(i).and.dx.le.dmax(i)) then
                    if(iww.eq.1) then
                       call wrt2(nd,ie1(i),j,ie2(i),k,ne,ir,iu,dx)
                    end if
                    call bond(x1,x2,r,elmx,nelmx,ne,bwdt(i),bcol(i))
              end if
c           end if
 32        continue
 31        continue
      end if


c*****plot unit cell**************************************************
      if(iwc.eq.0) then
           do 13 js=1,nsub
           do 14 i=1,8
           do 15 j=1,3
 15        x1(j)=icell(j,i)
c
c          transformation to the plotter system

           call rmx(x1,x2,ips,fact,js)

           do 16 j=1,3
 16        xcl(j,i)=x2(j)
 14        continue

           do 10 i=1,12
           do 11 ix=1,3
           x1(ix)=xcl(ix,ipc(1,i))
 11        x2(ix)=xcl(ix,ipc(2,i))

           call bond(x1,x2,r,elmx,nelmx,ne,3,ccol)
 10        continue
 13        continue
      end if
c     na=nad
      return
      end

      function iend(ip,nelmx,ne)
      integer ip(*),nelmx(*)
      iend=0
      do 10 i=1,ne
         if(ip(i).ne.nelmx(i)) return
 10   continue
      iend=1
      return
      end

      subroutine arrng(elmx,m,ne,ie,xtemp,nold,neie)
      real elmx(m,ne,*), xtemp(*)
      integer nold(*)
           do 375 kk=1,m
               do 371 n=1,neie
               xtemp(n)=elmx(kk,ie,n)
 371           continue
               do 372 n=1,neie
               elmx(kk,ie,n)=xtemp(nold(n))
 372           continue
 375       continue
      return
      end

      subroutine settng(sx,sij,tj)
      real sx(*),tj(*),sy(3)
      integer sij(3,*)
      do 10 i=1,3
          sy(i)=0
          do 20 j=1,3
          sy(i)=sy(i)+sij(i,j)*sx(j)
 20       continue
          sy(i)=sy(i)+tj(i)
 10   continue
      do 30 i=1,3
          sx(i)=sy(i)
 30   continue
      return
      end

      subroutine pltat0(x1,r1,ncol)
      dimension x1(3)
c     integer color
      data pi/3.14159/
      call fillarea(1)
      call fillcolor(ncol)
      call circle(0.0,360.0,r1,x1,0)
      call fillarea(0)
      call fillcolor(0)
      call circle(0.0,360.0,r1,x1,0)
      return
      end

      subroutine pltat1(x1,r1,ncol)
      real x1(3),xx(25),yy(25),xa(2)
      integer color
      data pi/3.14159/, eps/0.03/
      data sqrt2/1.414213/, sqrt6/2.44949/, sqrt12/3.46410/
      call fillarea(1)
      kcol=ncol-mod(ncol,10)
      color=ncol-5+1
      if(color.lt.kcol+1) then
           color=kcol+1
      else if(color.gt.kcol+9) then
           color=kcol+9
      end if
      call setcol(color)
      call circle(0.,360.,r1,x1,0)
      r2=r1**2
      do 100 i=2,6
         t=pi-pi*i/6
         color=ncol-5+i
         if(color.lt.kcol+1) then
             color=kcol+1
         else if(color.gt.kcol+9) then
             color=kcol+9
         end if
         sint=sin(t)
         cost=cos(t)
         zd=r1*cost
         call setcol(color)
         nt=20
         m=0
         do 110 j=-nt/2,nt/2
             f=2*pi*j/nt
             xd=r1*sint*cos(f)
             yd=r1*sint*sin(f)
c            a'=(-2-22)/sqrt(12)
c            b'=(1-10)/sqrt(2)
c            c'=(112)/sqrt(6)
             x=-2*xd/sqrt12+yd/sqrt2+zd/sqrt6
             y=-2*xd/sqrt12-yd/sqrt2+zd/sqrt6
             z= 2*xd/sqrt12       +2*zd/sqrt6
             rr2=x**2+y**2
             rdif=r2-rr2
             if(z.gt.0) then
                  m=m+1
                  xx(m)=x+x1(1)
                  yy(m)=y+x1(2)
             end if
 110         continue
 120         continue
             n=m
             if(n.gt.0) then
c                 center of an ellipse
                 xx(n+1)=zd/sqrt6+x1(1)
                 yy(n+1)=zd/sqrt6+x1(2)
c                 initial point
                 xx(n+2)=xx(1)
                 yy(n+2)=yy(1)
c
                 xx(n+3)=0
                 yy(n+3)=0
                 xx(n+4)=1
                 yy(n+4)=1
                 call plylin(xx,yy,n+2,1,0,0)
c                 angle calculation
                 xa(1)=xx(1)-x1(1)
                 xa(2)=yy(1)-x1(2)
                 call atanf(xa,ae)
                 xa(1)=xx(n)-x1(1)
                 xa(2)=yy(n)-x1(2)
                 call atanf(xa,as)
                 call circle(as*360,ae*360,r1,x1,0)
                 xx(1)=xx(1)
                 yy(1)=yy(1)
                 xx(2)=xx(n)
                 yy(2)=yy(n)
                 xx(3)=xx(n+1)
                 yy(3)=yy(n+1)
                 xx(4)=0
                 yy(4)=0
                 xx(5)=1
                 yy(5)=1
                 call plylin(xx,yy,3,1,0,0)
             end if
 100  continue
      return
      end

      subroutine pltat2(elmx,r,acol,nelmx,sarc,nnarc,ne)
      include 'prjms.inc'
      real elmx(3,ne,*),r(ne,*),sarc(2,ne,*)
      integer acol(*),nelmx(*),nnarc(ne,*),iarc(20)
      real arc(2,nbmax),x1(2)
           do 502 ie=1,ne
           iarc(ie)=0
           do 503 je=1,nelmx(ie)
           narc=nnarc(ie,je)
                do 501 ia=1,narc
                iarc(ie)=iarc(ie)+1
                arc(1,ia)=sarc(1,ie,iarc(ie))
                arc(2,ia)=sarc(2,ie,iarc(ie))
                rc=r(ie,je)
                x1(1)=elmx(1,ie,je)
                x1(2)=elmx(2,ie,je)
                call circle(arc(1,ia)*360,arc(2,ia)*360,
     *                rc,x1,acol(ie))
 501            continue
 503       continue
 502       continue
      return
      end
c
      subroutine wrt1(ne,nelmx,xt)
      dimension nelmx(*),xt(3,ne,*)
      character*6 atom
      common /cltc/ atom(100)
      no=0
      write(6,'(1h ,a)') ' no atom symbol      x          y          z'
      do 10 i=1,ne
         do 20 j=1,nelmx(i)
            no=no+1
 20         write(6,'(1h ,i5,i4,3x,a,3f10.4)') no,i,atom(i),
     *           (xt(k,i,j),k=1,3)
 10      continue
      return
      end

      subroutine wrt2(nn,ie1,j,ie2,k,ne,ir,iu,d)
      dimension ir(3,ne,*),iu(3,ne,*)
      if(nn.eq.0) then
          write(6,*) ' atom pair joined by a bond'
          write(6,'(1h ,2a)') '  no ( at1 ns1 ct1     lt1    )-', 
     *        '( at2 ns2 ct2     lt2    )  bond dist.'
      end if
      nn=nn+1
      write(6,'(1h ,i5,2(a,6i4,a),f8.4)') 
     *            nn,' (',(ir(l,ie1,j),l=1,3),
     *                    (iu(l,ie1,j),l=1,3),')-',
     *                '(',(ir(l,ie2,k),l=1,3),
     *                    (iu(l,ie2,k),l=1,3),')',d
      return
      end

      subroutine cross(xb1,xb2,x1,r1,x2,r2,icase,t1,t2,iii)
      dimension x1(3),x2(3),sx1(3),sx2(3),sx3(3),sx(3),xc1(2),xc2(2)
      data t3/0./,t4/0./
c*******************************************************
c*          blind part of atom1 due to atom2     *
c*******************************************************
c     xb1: start angle of the circle of atom1
c     xb2: end angle of the circle of atom1
c     x1: position of atom1
c     x2: position of atom2
c     r1: radius of atom1
c     r2: radius of atom2
c     t1: start angle of blind part
c     t2: end angle of blind part
c     t3: another start angle of blind part if any
c     t4: another end angle of blind part if any
c     icase=0: no blind part
c     icase=1: completely blind
c     icase=2: start point shaded
c     icase=3: end point shaded
c     icase=4: intermediate part shaded
c     iii=0: t1-t2 is shaded, =1 0-t2, t3-1 are shaded
c
      icase=0
      iii=-1
      t1=0
      t2=0
      do 10 ix=1,3
 10   sx(ix)=x1(ix)-x2(ix)
      vabss2=vabs(sx,2)
      if(sx(3).gt.0.or.vabss2.gt.r1+r2) then
c          no shading case
c          icase=0, iii=-1
           return
      end if
      call gipcca(x1,r1,x2,r2,xc1,xc2,n)
      if(n.le.1) then
           if(r2.gt.r1.and.vabss2.lt.min(r1,r2)) then
c               completely shaded
                icase=1
                return
           else
c               no shading case
                return
           end if
      end if
c
      do 11 ix=1,2
      sx1(ix)=xc1(ix)-x1(ix)
      sx2(ix)=xc2(ix)-x1(ix)
 11   sx3(ix)=xc1(ix)-x2(ix)
      if(sx1(1)*sx3(2)-sx1(2)*sx3(1).le.0) then
c          xc1: start, xc2: end
           call atanf(sx1,t1)
           call atanf(sx2,t2)
      else
c          xc1: end, xc2: start
           call atanf(sx1,t2)
           call atanf(sx2,t1)
      end if
c        t1-t2 is shaded
      if(t1.le.t2) then
           iii=0
      else
c        t1-t2, t3-t4=t1 are shaded
           iii=1
           t3=t1
           t4=1
           t1=0
      end if
 13   continue
c*****blind conditions**********************************
c     no blind cases
 31   icase=0
      if(t2.lt.xb1.or.t1.gt.xb2) go to 30
c     completely blind
      if(t1.le.xb1.and.t2.ge.xb2) then
            icase=1
            return
c     start point shaded
      else if(t1.le.xb1.and.t2.gt.xb1) then
            icase=2
            return
c     end point shaded
      else if(t1.lt.xb2.and.t2.ge.xb2) then
            icase=3
            return
c     intermediate part shaded
      else if(t1.gt.xb1.and.t2.lt.xb2) then
           icase=4
           return
      end if
 30   if(iii.eq.0) return
      t1=t3
      t2=t4
      iii=0
      go to 31
      end


      function absx(x,js)
      real x(*)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      absx=0
      do 100 i=1,3
      do 100 j=1,3
           absx=absx+x(i)*gab(i,j,js)*x(j)
 100  continue
      absx=sqrt(absx)
      return
      end

      function absy(x,js)
      real x(*)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      absy=0
      do 100 i=1,3
      do 100 j=1,3
           absy=absy+x(i)*gabn(i,j,js)*x(j)
 100  continue
      absy=sqrt(absy)
      return
      end

      function absvec(x)
      real x(*)
      absvec=0.
      do 100 i=1,3
      absvec=absvec+x(i)**2
 100  continue
      absvec=sqrt(absvec)
      return
      end
           

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
           do 105 j=1,n
           if(ipivot(j).eq.1) go to 105
           do 100 k=1,n
           if(ipivot(k)-1) 80,100,740
  80       if(abs(amax).ge.abs(a(j,k))) go to 100
           irow=j
           icolum=k
           amax=a(j,k)
 100       continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
           swap=b(irow)
           b(irow)=b(icolum)
           b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
           b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
           do 450 l=1,n
 450       a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
           do 700  k=1,n
           swap=a(k,jrow)
           a(k,jrow)=a(k,jcolum)
 700       a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end

      subroutine sciss(s,iscis,ie,isub)
      dimension s(*)
      common /ctocss/ hb(3,20),d(20,20),nb
      dimension x(3)
c*****scissoring conditions*****************************************
c     if x is out of range then iscis=1 else iscis=0
c*******************************************************************
      call cpyvec(s,x)
      call xxxs(x,isub)
      do 10 i=1,nb
      dx=hb(1,i)*x(1)+hb(2,i)*x(2)+hb(3,i)*x(3)
      if(dx.gt.d(i,ie)) go to 20
 10   continue
      iscis=0
      return
 20   iscis=1
      return
      end

      subroutine bond(xb1,xb2,r,elmx,nelmx,ne,nwdt,ncol)
      dimension xb1(*),xb2(*),r(ne,*),elmx(3,ne,*),nelmx(*)
      dimension xs1(3),xs2(3),xc(3),n1(3)
      real n1
      data eps/0.0001/
c********************************************************************
c      plot a bond excluding blind parts
c********************************************************************
c
c     xb1: start coordinates of a bond in plotter system
c     xb2: end coordinates of a bond in plotter system
c     r(i): radius of i-th atom
c     elmx(i) element nomber of i-th atom
c     nelmx: number of atoms
c     nwdt: bond width
c     ncol: bond color
c*****search atoms on bond in projection plane
c     nn: number of atoms shding bond
 30   continue
      xxmin=amin1(xb1(1),xb2(1))
      xymin=amin1(xb1(2),xb2(2))
      xzmin=amin1(xb1(3),xb2(3))
      xxmax=amax1(xb1(1),xb2(1))
      xymax=amax1(xb1(2),xb2(2))
      nn=0
      icase=0
      do 42 ie=1,ne
      n=nelmx(ie)
      do 40 jd=1,n
      j=n+1-jd
      do 41 ix=1,3
 41   xc(ix)=elmx(ix,ie,j)
      if(xc(1).lt.xxmin-r(ie,n)) go to 40
      if(xc(2).lt.xymin-r(ie,n)) go to 40
      if(xc(3).lt.xzmin-r(ie,n)) go to 40
      if(xc(1).gt.xxmax+r(ie,n)) go to 40
      if(xc(2).gt.xymax+r(ie,n)) go to 40
           call shade(xb1,xb2,xc,r(ie,j),ics,n1,t1,t2)
           if(ics.eq.1) return
           if(ics.eq.0) go to 40
           nn=nn+1
           if(nn.eq.1) go to 44
           if(nn.gt.1.and.t1.lt.xmin) go to 44
           go to 40
 44        xmin=t1
           icase=ics
           do 43 ix=1,3
           xs1(ix)=xb1(ix)+t1*n1(ix)
 43        xs2(ix)=xb1(ix)+t2*n1(ix)
 40   continue
 42   continue
c*****plot a bond*************************************************
      if(icase.eq.2) then
           if(nn.gt.1) go to 34
c          start point shaded
           call newpen(nwdt)
           call setcol(ncol)
           call plot(xs2(1),xs2(2),3)
           call plot(xb2(1),xb2(2),2)
           return
      else if(icase.eq.3) then
c          end point shaded
           call newpen(nwdt)
           call setcol(ncol)
           call plot(xb1(1),xb1(2),3)
           call plot(xs1(1),xs1(2),2)
           return
      else if(icase.eq.4) then
c          intermediate part shaded
           call newpen(nwdt)
           call setcol(ncol)
           call plot(xb1(1),xb1(2),3)
           call plot(xs1(1),xs1(2),2)
           if(nn.gt.1) go to 34
           call newpen(nwdt)
           call setcol(ncol)
           call plot(xs2(1),xs2(2),3)
           call plot(xb2(1),xb2(2),2)
           return
      else if(icase.eq.0) then
c          no blind case
           call newpen(nwdt)
           call setcol(ncol)
           call plot(xb1(1),xb1(2),3)
           call plot(xb2(1),xb2(2),2)
           return
      end if
 34   continue
      do 50 ix=1,3
 50   xb1(ix)=xs2(ix)+eps*n1(ix)
      go to 30
      end

      subroutine shade(x1,x2,xc,r,icase,n1,t1,t2)
      dimension x1(3),x2(3),xc(3)
      dimension n1(3),n2(3),y1(3),y2(3),y3(3),y4(3),y5(3)
      real l1,l2,m1,n1,n2,n1y2,n1y3,n2y2
      data eps/0.0001/
c*******************************************************
c                 blind parts of a bond
c*******************************************************
c     x1: start point vector (x,y,z in the plotter system)
c     x2: end point vector (x,y,z in the plotter system)
c     xc: circle center (x,y,z in the plotter system)
c     r : radius of circle in the plotter system
c
c
c     y1=x2-x1
c     y2=xc-x1
c     y3=xc-x2
c     vabs(x,n): absolute value of n-dimensional vector x
c     vinp(x,y,n): inner product of n-dimensional vectors, x,y
      do 10 ix=1,3
      y1(ix)=x2(ix)-x1(ix)
      y2(ix)=xc(ix)-x1(ix)
 10   y3(ix)=xc(ix)-x2(ix)
c     n1:unit vector for y1 in projection plane
      absy1=vabs(y1,2)
      if(absy1.gt.eps) then
         do 121 ix=1,2
 121     n1(ix)=y1(ix)/absy1
      else
         do 122 ix=1,2
 122     n1(ix)=0
      end if
c     unit vector for y1 in plotter system
      absy2=vabs(y1,3)
      do 14 ix=1,3
 14   n2(ix)=y1(ix)/absy2
c     n1.y2 and n1.y3 on plojection plane
      n1y2=vinp(n1,y2,2)
      n1y3=vinp(n1,y3,2)
c     n2.y2 in plotter system
      n2y2=vinp(n2,y2,3)
c     normal from atom to bond
      do 13 ix=1,3
 13   y4(ix)=n2y2*n2(ix)-y2(ix)
      do 15 ix=1,2
 15   y5(ix)=n1y2*n1(ix)-y2(ix)
c*****conditions for shade**********************************
      absy43=vabs(y4,3)**2
      absy52=vabs(y5,2)**2
      r2=r**2
c*****no blind cases****************************************
      icase=0
c     the bond passes at the side of the circle
      if(r2.le.absy52) return
c     the bond passes on the circle
      if(y4(3).gt.eps.and.absy43.gt.r2) return
      l1=sqrt(r2-absy52)
      if(absy43.lt.r2) m1=sqrt(r2-absy43)
c     the bond does not reach the circle
      if(-l1.ge.n1y2.or.n1y3.ge.l1) return
c*****four blind cases**************************************
c     x1i,x1o start and end points of shade in plotter system
      l2=-l1
      if(absy43.gt.r2) go to 20
      if((n2y2-m1)*n2(3).gt.y2(3)-eps) l2=-m1*vabs(n2,2)
      if((n2y2+m1)*n2(3).gt.y2(3)-eps) l1=m1*vabs(n2,2)
 20   t1=n1y2+l2
      t2=n1y2+l1
c     case 1: completely blind
      if(t1.lt.0.0.and.t2.gt.absy1) icase=1
      if(icase.eq.1) return
c     case 2: start point shaded
      if(t1.lt.0.0.and.t2.gt.0.0) icase=2
c     case 3: end point shaded
      if(t1.lt.absy1.and.t2.gt.absy1) icase=3
c     case 4: intermediate part shaded
      if(t1.gt.0.0.and.t2.lt.absy1) icase=4
      return
      end

      subroutine getarc(x1,r1,i1,n1,arc,narc,r,elmx,nelmx,ne)
      dimension x1(*),x2(3),r(ne,*),elmx(3,ne,*),nelmx(*),arc(2,*)
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(20),bwdt(20),bcol(20),ccol,dcol,jmod,ldev

      data eps/0.0001/
c******************************************************************
c     calculate blind parts of an atom at x1
c******************************************************************
c     x1: atom position
c     r1: radius of the atom
c     i1,n1 specify the kind and lacation of the atom
c        i1: i1-th element
c        n1: n1-th atom of i1-th element
c     arc: start and end angles of arc (a part of the atom)
c     narc: number of arcs in the atom
c     r(i,j):   atom radius of j-th atom in i-th element
c     elmx(i,j,k) i-th coordinate of k-th atom in j-th element
c     nelmx(i): number of atoms in i-th element
c     ne: number of elements
      xb1=0
      xb2=1
      narc=0
c      xb1, xb2: initial and final angle of a part of circle
 30   nn=0
      icase=0
      do 42 ie=1,ne
      n=nelmx(ie)
      do 40 jd=1,n
           j=n+1-jd
           do 41 ix=1,3
 41        x2(ix)=elmx(ix,ie,j)
           r2=r(ie,j)
           if(ie.ne.i1.or.j.ne.n1) then
c               calculate shaded part of atom (x2,r2)
                call cross(xb1,xb2,x1,r1,x2,r2,ics,t1,t2,iii)
                if(ics.eq.1) then
c                    complitely shaded
                     return
                else if(ics.eq.0) then
c                    no shading
                     go to 40
                end if
                if(iii.eq.0) nn=nn+1
                if(iii.eq.1) nn=nn+2
c               nn: number of shaded parts in atom (x2,r2)
                if(nn.eq.1+iii.or.(nn.gt.1.and.t1.lt.xmin)) then
                     xmin=t1
                     icase=ics
                     xs1=t1
                     xs2=t2
c                    start and end angles of blind part
                end if
           end if
 40   continue
 42   continue
c******************put arc****************************
      if(icase.eq.2) then
           if(nn.gt.1) go to 34
c          start point shaded
           call putarc(xs2,xb2,arc,narc)
           return
      else if(icase.eq.3) then
c          end point shaded
           call putarc(xb1,xs1,arc,narc)
           return
      else if(icase.eq.4) then
c          intermediate part shaded
           call putarc(xb1,xs1,arc,narc)
           if(nn.gt.1) go to 34
           call putarc(xs2,xb2,arc,narc)
           return
      else if(icase.eq.0) then
c          nonshading case
           call putarc(xb1,xb2,arc,narc)
           return
      end if
 34   continue
c     take new initial angle for calculation of shade by other atom
      do 50 ix=1,3
 50   xb1=xs2+eps
      go to 30
      end

      subroutine putarc(x1,x2,arc,narc)
      real arc(2,*)
      narc=narc+1
      arc(1,narc)=x1
      arc(2,narc)=x2
      return
      end

      subroutine atanf(x,t)
      dimension x(2)
c******************************************************
c          angle calculation
c******************************************************
c     x: 2-dimensional vector (x,y in plotter system)
c     t: angle in rad/6.28318   (0<=t<=1)
      if(x(1).eq.0) go to 10
      td=atan(x(2)/x(1))/6.28318
      if(x(1).gt.0.and.x(2).ge.0) t=td
      if(x(1).lt.0.and.x(2).ge.0) t=td+0.5
      if(x(1).lt.0.and.x(2).le.0) t=td+0.5
      if(x(1).gt.0.and.x(2).le.0) t=td+1.0
      return
 10   if(x(2).gt.0) t=0.25
      if(x(2).lt.0) t=0.75
      return
      end

      subroutine gipcca(x1,r1,x2,r2,xc1,xc2,n)
      dimension x1(3),x2(3),xc1(2),xc2(2),xc(2),yc(2)
c*****************************************************************
c           cross points in two circles
c*****************************************************************
c     x1: center of circle1  (x,y,z in plotter system)
c     r1: radius of circle1
c     x2: center of circle2  (x,y,z in plotter system)
c     r2: radius of circle2
c     xc1: cross point 1
c     xc2: cross point 2
c     n:   number of cross points
c         gipcc1: subroutine in grace 4
      call gipcc1(x1(1),x1(2),r1,x2(1),x2(2),r2,xc,yc,n,ill)
      xc1(1)=xc(1)
      xc1(2)=yc(1)
      xc2(1)=xc(2)
      xc2(2)=yc(2)
      return
      end

      subroutine rmx(x,xd,ips,fact,isub)
      real x(*),xd(*),s(3)

      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn

      call cpyvec(x,s)
c     transform into the orthogonal system
      call xxxs(s,isub)
c     orthogonal transformation 
      call mxv(on,s)
c     take origin at the fixed point 
      do 320 kk=1,3
 320  s(kk)=s(kk)-fxyz(kk)
c     viewing transformation and restore the origin
           if(ips.eq.0) fact=1
           if(ips.eq.1) fact=xvp(3)/(xvp(3)-s(3))
      do 330 kk=1,2
 330  xd(kk)=s(kk)*fact*amgn
      xd(3)=s(3)*amgn
      return
      end
      
      subroutine mxv(rm,s)
      real rm(3,*),s(*),xd(3)
      do 100 i=1,3
      xd(i)=0
      do 110 j=1,3
      xd(i)=xd(i)+rm(i,j)*s(j)
 110  continue
 100  continue
      call cpyvec(xd,s)
      return
      end

      subroutine rotz(rm,angl)
      real rm(3,*),angl
      data pi2/6.28318/
      cosa=cos(pi2*angl)
      sina=sin(pi2*angl)
      rm(1,1)=cosa
      rm(1,2)=sina
      rm(1,3)=0
      rm(2,1)=-sina
      rm(2,2)=cosa
      rm(2,3)=0
      rm(3,1)=0
      rm(3,2)=0
      rm(3,3)=1
      return
      end

      subroutine ormtrx(h,x,on)
      real h(*),x(*),on(3,*)
      real n1(3),n2(3),n3(3),n3x
c*****unit vectors in the projection plane (n1,n2)*******
c     normalization of n3
      absh=vabs(h,3)
      do 10 i=1,3
 10   n3(i)=-h(i)/absh
c     projection of y-axis onto the projection plane
      n3x=vinp(n3,x,3)
      do 11 i=1,3
 11   n2(i)=x(i)-n3x*n3(i)
c     normalization of n2
      absn1=vabs(n2,3)
      do 12 i=1,3
 12   n2(i)=n2(i)/absn1
c     calculation of n1
      n1(1)=n2(2)*n3(3)-n2(3)*n3(2)
      n1(2)=n2(3)*n3(1)-n2(1)*n3(3)
      n1(3)=n2(1)*n3(2)-n2(2)*n3(1)
c***   orthogonal matrix on
      on(1,1)=n1(1)
      on(1,2)=n1(2)
      on(1,3)=n1(3)
      on(2,1)=n2(1)
      on(2,2)=n2(2)
      on(2,3)=n2(3)
      on(3,1)=n3(1)
      on(3,2)=n3(2)
      on(3,3)=n3(3)
c*** test write ***
      write(6,'(1h ,a)') 'on matrix'
      write(6,'(1h ,3f12.6)') ((on(i,j),j=1,3),i=1,3)
      return
      end
      
      subroutine yaxis(z,y)
      real z(*),y(*)
      real u(3),v(3),w(3)
      data u/1.,0.,0./, v/0.,1.,0./ w/0.,0.,1./
      data eps/0.0001/
      d1=vinp(z,u,3)
      d2=vinp(z,v,3)
      d3=vinp(z,w,3)
      if(abs(min(d1,d2,d3)-d1).lt.eps) call cpyvec(u,y)
      if(abs(min(d1,d2,d3)-d2).lt.eps) call cpyvec(v,y)
      if(abs(min(d1,d2,d3)-d3).lt.eps) call cpyvec(w,y)
      return
      end

c      subroutine trnsp(sm)
c      real smd(3,3),sm(3,3)
c      do 100 i=1,3
c      do 100 j=1,3
c           smd(i,j)=sm(j,i)
c 100  continue
c      do 110 i=1,3
c      do 110 j=1,3
c           sm(i,j)=smd(i,j)
c 110  continue
c      return
c      end

      subroutine mcpy(from,to)
      real from(3,3),to(3,3)
      do 100 i=1,3
      do 100 j=1,3
      to(i,j)=from(i,j)
 100  continue
      return
      end

      subroutine mtmpl(a,b,c)
      real a(3,3),b(3,3),c(3,3)
      do 100 i=1,3
      do 100 j=1,3
           c(i,j)=0.
           do 200 k=1,3
                c(i,j)=c(i,j)+a(i,k)*b(k,j)
 200       continue
 100  continue
      return
      end

      subroutine rotaxs(or,ori,angl,rm)
      real or(3,*),ori(3,*),rm(3,*)
      real rd(3,3)
c     rm: rotation matrix around z axis
      call rotz(rm,angl)
      call mtmpl(rm,or,rd)
      call mtmpl(ori,rd,rm)
c     rm: rotation matrix around a given axis
      return
      end

      subroutine qsort(x,st,ip,nx)
c     quick sort (ascending order of x)
c     nx: the number of data x
c     ip: the initial order
c     st: a work array
      real x(nx)
      integer r,s,st(nx,0:1),ip(nx)
      do 10 i=1,nx
 10   ip(i)=i
      s=1
      st(1,0)=1
      st(1,1)=nx
    1 l=st(s,0)
      r=st(s,1)
      s=s-1
    2 i=l
      j=r
      xt=x((l+r)/2)
    3 if(i.lt.nx) then
         if(x(i).lt.xt) then
            i=i+1
            go to 3
         endif
      endif
    4 if(j.gt.1) then
         if(xt.lt.x(j)) then
            j=j-1
            go to 4
         endif
      endif
      if(i.le.j) then
        temp=x(j)
        x(j)=x(i)
        x(i)=temp
        itemp=ip(j)
        ip(j)=ip(i)
        ip(i)=itemp
        if(i.le.nx.and.j.ge.1) then
           i=i+1
           j=j-1
           go to 3
        end if
      endif
      if(j-l.le.r-i) go to 5
      if(i.lt.r) then
         s=s+1
         st(s,0)=i
         st(s,1)=r
      endif
      r=j
      go to 6
    5 if(l.lt.j) then
         s=s+1
         st(s,0)=l
         st(s,1)=j
      endif
      l=i
    6 if(l.lt.r) go to 2
      if(s.ne.0) go to 1
      return
      end

      subroutine bond2(xb1,xb2,r,elmx,nelmx,ne,bwdt,bcol)
      dimension xb1(*),xb2(*),r(ne,*),elmx(3,ne,*),nelmx(*)
      dimension xs1(3),xs2(3),xc(3),n1(3)
      real n1
      integer bcol,bwdt
      data eps/0.0001/
c********************************************************************
c      plot a bond excluding blind parts
c********************************************************************
c
c     xb1: start coordinates of a bond in plotter system
c     xb2: end coordinates of a bond in plotter system
c     r(i,j): radius of j-th atom in i-th element
c     elmx(i,j,k) i-th coordinate of k-th atom in j-th element
c     nelmx(i): number of atoms in i-th element
c     ne: number of elements
c*****search atoms on bond in projection plane
c     nn: number of atoms shding bond
 30   continue
      xxmin=amin1(xb1(1),xb2(1))
      xymin=amin1(xb1(2),xb2(2))
      xzmin=amin1(xb1(3),xb2(3))
      xxmax=amax1(xb1(1),xb2(1))
      xymax=amax1(xb1(2),xb2(2))
      nn=0
      icase=0
      do 42 ie=1,ne
      n=nelmx(ie)
      do 40 jd=1,n
      j=n+1-jd
      do 41 ix=1,3
 41   xc(ix)=elmx(ix,ie,j)
      if(xc(1).lt.xxmin-r(ie,n)) go to 40
      if(xc(2).lt.xymin-r(ie,n)) go to 40
      if(xc(3).lt.xzmin-r(ie,n)) go to 40
      if(xc(1).gt.xxmax+r(ie,n)) go to 40
      if(xc(2).gt.xymax+r(ie,n)) go to 40
           call shade(xb1,xb2,xc,r(ie,j),ics,n1,t1,t2)
           if(ics.eq.1) return
           if(ics.eq.0) go to 40
           nn=nn+1
           if(nn.eq.1) go to 44
           if(nn.gt.1.and.t1.lt.xmin) go to 44
           go to 40
 44        xmin=t1
           icase=ics
           do 43 ix=1,3
           xs1(ix)=xb1(ix)+t1*n1(ix)
 43        xs2(ix)=xb1(ix)+t2*n1(ix)
 40   continue
 42   continue
c*****plot a bond*************************************************
      if(icase.eq.2) then
           if(nn.gt.1) go to 34
c          start point shaded
           call newpen(bwdt)
           call plot(xs2(1),xs2(2),3)
           call plot(xb2(1),xb2(2),2)
           return
      else if(icase.eq.3) then
c          end point shaded
           call newpen(bwdt)
           call plot(xb1(1),xb1(2),3)
           call plot(xs1(1),xs1(2),2)
           return
      else if(icase.eq.4) then
c          intermediate part shaded
           call newpen(bwdt)
           call plot(xb1(1),xb1(2),3)
           call plot(xs1(1),xs1(2),2)
           if(nn.gt.1) go to 34
           call newpen(bwdt)
           call plot(xs2(1),xs2(2),3)
           call plot(xb2(1),xb2(2),2)
           return
      else if(icase.eq.0) then
c          no blind case
           call newpen(bwdt)
           call plot(xb1(1),xb1(2),3)
           call plot(xb2(1),xb2(2),2)
           return
      end if
 34   continue
      do 50 ix=1,3
 50   xb1(ix)=xs2(ix)+eps*n1(ix)
      go to 30
      end

      subroutine prmtbl(x,df,isub,ips,na,nw,nx,nzc,ja,ea,xx,bx,px,
     *                it,nl,iw)
      dimension x(*),df(*),isub(*),ips(*),ja(4,*),ea(*),xx(6,*),
     *          bx(it,*),px(*)
      common /cdim/ idm,nde
      character*6 atom
      common /cltc/ atom(100)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension comp1(3),comp2(0:12),comp3(1),comp4(7),comp5(3),
     *          comp6(0:12),zx(20)
      integer wx(20),wy(20),ifrt(20)
      integer dspmdl,tmpmdl,sctmdl
      common /ceat/ eat(6,3),ebt(6,3)
      common /citfs/ itfs(100)
      character*4 comp1,comp2,comp3,comp4,comp5,comp6,aa,wc(20)
      data comp1 /'u','v','w'/,
     *     comp2 /'Beq','B1','B2','B3','B4','B5','B6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp3 /'p'/,
     *     comp4 /'B','B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp5 /'x','y','z'/,
     *     comp6 /'Beq','U1','U2','U3','U4','U5','U6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/
c****************************************************************
c    write atomic parameter table
c    iw=1: parameter table, iw=2: standard dev. table
c    iw=3: atomic parameters for a superstructure
c****************************************************************
      pi8=8*(3.141592)**2

      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      ncl=6
      kde=(nw-1)/ncl+1
      if(iw.eq.1.or.iw.eq.2) then
          do 12 kd=1,kde
              if(kd.eq.kde) ne=mod(nw-1,ncl)+1
              if(kd.ne.kde) ne=ncl
              do 13 k=1,ne
              ifrt(k)=k+ncl*(kd-1)
 13           continue
              if(kd.eq.1) write(6,202) (ifrt(k),k=1,ne)
              if(kd.ne.1) write(6,204) (ifrt(k),k=1,ne)
 12       continue
      end if
      write(6,201)
      do 10 i=1,na
      jk=isub(i)
      do 22 iy=1,3
      if(dspmdl.eq.0.and.iy.eq.1) go to 22
      if(tmpmdl.eq.0.and.iy.eq.2) go to 22
      if(sctmdl.eq.0.and.iy.eq.3) go to 22
      if(iy.eq.1) then   ! x,y,z
          is=i1
          ie=i2
          js=1
          je=3
          fact=100000
      else if(iy.eq.2) then  ! B or Bi, Ui
          is=i3
          ie=i4
          if(itempf.eq.0) then   ! isotropic
              js=1
              je=1
              fact=1000
          else if(itempf.gt.0) then ! anisotropic
             js=0               ! for Beq
             je=it
             fact=100000
          else if(itempf.lt.0) then
             js=0               ! for Beq
             je=it
             if(itfs(i).eq.0) then
                fact=100000
             else
                fact=100000
             end if
          end if
       else if(iy.eq.3) then  ! p
          is=i5
          ie=i6
          js=1
          je=1
          fact=1000
      end if
      do 11 j=js,je
      if(iw.eq.1.or.iw.eq.2) then
          do 111 kd=1,kde
          if(kd.ne.kde) ne=ncl
          if(kd.eq.kde) ne=mod(nw-1,ncl)+1
          do 210 k=1,ne
          if(j.ne.0) then    ! x,y,z, Bi/Ui ,p
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 31 l=2,is
 31               in=in+ja(4,l-1)
              end if
              do 220 ix=is,ie
              nz=ja(4,ix)
              do 21 n=1,nz
              in=in+1
              if(ja(1,in).eq.i.and.ja(2,in).eq.j.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                  ad=x(ix)*ea(in)
                  bd=df(ix)*ea(in)
                  if(iw.eq.1) then
c                    parameters and their differences
                       wx(k)=wx(k)+ad*fact
                       wy(k)=wy(k)+bd*fact
                       if(ips(ix).eq.1) then
 20                       write(wc(k),'(i4)') wy(k)
                       end if
                  else if(iw.eq.2) then
c                    parameters and their std.
                       wx(k)=wx(k)+ad*fact
                       zx(k)=zx(k)+bd**2
                       wy(k)=sqrt(zx(k))*fact
                       if(ips(ix).eq.1) then
                           write(wc(k),'(i4)') wy(k)
                       end if
                  end if
              end if
 21           continue
 220          continue
          else if(j.eq.0) then  ! Beq
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 32 l=2,is
 32               in=in+ja(4,l-1)
              end if
              do 230 ix=is,ie
              nz=ja(4,ix)
c             calculation of Beq
              do 23 n=1,nz
              in=in+1
              if(abs(itempf).gt.0) then ! calculate Beq
                  if(ja(1,in).eq.i.and.ja(2,in).le.6.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                     if(iw.eq.1) then
c                    parameters and their differences
                        if(itfs(i).eq.0) then
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                           wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact/100
                        else
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact
                           wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact
                        end if
                     else if(iw.eq.2) then
c                     parameters and their std.
                        if(itfs(i).eq.0) then
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                           zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        else
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact
                           zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        end if
                     end if
                  end if
              end if
              if(ips(ix).eq.1) then
                 if(itfs(i).eq.1) then
                    wy(k)=sqrt(zx(k))*fact/100
                    write(wc(k),'(i4)') wy(k)/100
                 else
                    wy(k)=sqrt(zx(k))*fact
                    write(wc(k),'(i4)') wy(k)
                 end if
              end if
 23           continue
 230          continue
          end if
 210      continue
          if(dspmdl.eq.1.and.iy.eq.1) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),comp1(j),
     *                     (wx(k),wc(k),k=1,ne)
          else if(tmpmdl.eq.1.and.iy.eq.2) then
             if(itempf.eq.1.or.(itempf.eq.-1.and.j.gt.0)) then  ! Bij
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp2(j),(wx(k),wc(k),k=1,ne)
             else if(itempf.eq.2.or.(itempf.eq.-2.and.j.gt.0))  then  ! Uij
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp6(j),(wx(k),wc(k),k=1,ne)
             else if(itempf.lt.0.and.j.eq.0) then    ! Beq
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp6(j),(wx(k)/100,wc(k),k=1,ne)
             else if(itempf.eq.0) then    ! B
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp4(j),(wx(k),wc(k),k=1,ne)
             end if
          else if(sctmdl.ne.0.and.iy.eq.3) then
             if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
             if(kd.eq.1) write(6,200) atom(i),
     *            comp3(j),(wx(k),wc(k),k=1,ne)
          end if
 111      continue
      end if
 11   continue
 22   continue
      write(6,201)
 10   continue
      if(itwin.ne.0) then
           ntwin=abs(itwin)
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(j,i)=0.
 802       continue
 801       continue
        if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+x(i)*ea(in)
 80        continue
           write(6,'('' twin domain volume ratio: '',8f12.6)')
     *       (volr(itw),itw=1,ntwin)
        write(6,201)
        end if
c       if(i10.gt.i8) then
c          phase shift
c           do 81 i=i9,i10
c           nz=ja(4,i)
c           do 81 n=1,nz
c           in=in+1
c           itw=ja(1,in)
c           j=ja(2,in)
c           dt(j,itw)=dt(j,itw)+x(i)*ea(in)
c 81        continue
c           write(6,'('' additional shift for twinoperators:'',6f12.6)')
c     *       ((dt(j,itw),j=1,6),itw=1,ntwin)
c           write(6,201)
c       end if
      end if
      write(6,'('' scale factors: '',6f12.6)') (x(i),i=i11,i12)
      if(isext.ne.0) then
         write(6,'('' extinction parameters: '',2f12.6)')
     *        (x(i),i=i13,i14)
      end if
      write(6,201)
 40   continue
      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      return
 200  format(1h ,a,1x,a4,6(i6,'(',a,')'))
 203  format(1h ,11x,    6(i6,'(',a,')'))
 201  format(1h )
 202  format(1h ,'fourier trm',6(i6,6x))
 204  format(1h ,'           ',6(i6,6x))
      end

      subroutine gauss(isub)
c     implicit real*8 (a-h,o-z)
c     real*4  pxj,hj,y
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
c      common /atomp2/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      common /cdim/ idm,nde
      common /clrang/ lxmin,lxmax,lymin,lymax,lzmin,lzmax
      do 12 l=1,nde
           k=0
           do 13 k3=lzmin,lzmax
           do 13 k2=lymin,lymax
           do 13 k1=lxmin,lxmax
           k=k+1
c          pxj(k,l)=y(1,l,1)*k1+y(2,l,1)*k2+y(3,l,1)*k3
           pxj(k,l)=y(1,l,isub)*k1+y(2,l,isub)*k2+y(3,l,isub)*k3
           pxj(k,l)=mod(pxj(k,l),1.)
           if(pxj(k,l).lt.0) pxj(k,l)=pxj(k,l)+1
 13        continue
 12   continue
      return
      end

      subroutine begin(csb,nw,nt,na,nl,x,isub,ifrt1,ifrt2,coeff,
     *                ns,icnt,trd)
      dimension csb(nw,na,*),x(6,*),isub(*),ifrt1(nw,2,*),
     *                              ifrt2(nw,3,*),coeff(nw,*),trd(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /cdim/ idm,nde
c     common /kwave/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      dimension arg(6),agd(6),rs(6,6,3),bb(6),ipv(6),ind(6,2),piv(6)
      dimension nm(6)
      character sgn1,sgn2,chr1,chr2
      character*2 cs1,cs2
      character*4 ifrt1
      data sgn1/'+'/,sgn2/'-'/,cs1/'cC'/,cs2/'sS'/
c*******************************************************************
c      calculation of fourier terms for each independent atom
c*******************************************************************
      do 21 j=1,nw
      do 21 jk=1,na
      do 21 m=1,nl
 21   csb(j,jk,m)=0.0
      do 241 nd=1,nsub
         do 24 i=1,idm
         do 24 j=1,idm
 24      rs(i,j,nd)=rr(i,j,ns,nd)
         call matinv(rs(1,1,nd),6,idm,bb,0,det,ipv,ind,piv)
 241  continue
c
      do 10 i=1,nw
      do 12 j=1,nt
      chr1=ifrt1(i,1,j)(1:1)
      if(chr1.eq.sgn1) then
            sgn=1
      else if(chr1.eq.sgn2) then
            sgn=-1
      else
            go to 13
      end if
      if(coeff(i,j).eq.0.0) coeff(i,j)=1.0
      do 11 jk=1,na
           js=isub(jk)
           do 22 k=1,6
 22        arg(k)=0.0
           do 20 nd=1,idm
           arg(nd)=x(nd,jk)
           if(nd.ge.4) then
                ni=nd-3
                arg(nd)=arg(nd)+
     *          y(1,ni,js)*x(1,jk)+y(2,ni,js)*x(2,jk)+y(3,ni,js)*x(3,jk)
           end if
 20        continue
           m=0
c     incommensurate loop
c           do 51 m3=1,ilm(3)
c           do 51 m2=1,ilm(2)
c           do 51 m1=1,ilm(1)
c     commensurate loop
c          do 51 n1=1,ilc(1)*ilc(2)*ilc(3)
           do 51 n3=1,ilc(3)
           do 51 n2=1,ilc(2)
           do 51 n1=1,ilc(1)
           nm(1)=m1
           nm(2)=m2
           nm(3)=m3 
           m=m+1
c           if(icorc(1).eq.0) nm(1)=n1
c           if(icorc(2).eq.0) nm(2)=n1
c           if(icorc(3).eq.0) nm(3)=n1
           do 23 nd=1,nde
           agd(nd)=0
                do 231 k=1,3
 231            agd(nd)=agd(nd)+
     *          rs(nd+3,k,js)*(arg(k)-tt(k,ns,js)-trd(k))
                do 232 k=4,idm
 232            agd(nd)=agd(nd)+rs(nd+3,k,js)*
     *          (arg(k)+pxj(m,k-3)-tt(k,ns,js)-trd(k))
c    *          (arg(k)+pxj(nm(k-3),k-3)-tt(k,ns,js)-trd(k))
           if(icnt.eq.1) agd(nd)=-agd(nd)
 23        continue
           a=0
           do 233 nd=1,nde
 233       a=a+agd(nd)*ifrt2(i,nd,j)
           chr2=ifrt1(i,2,j)(1:1)
           if(index(cs1,chr2).gt.0) then
                cs=cos(a*pai2)*sgn
           else if(index(cs2,chr2).gt.0) then
                cs=sin(a*pai2)*sgn
           else
                cs=0.0
           end if
 51        csb(i,jk,m)=csb(i,jk,m)+cs*coeff(i,j)
 11   continue
 12   continue
 13   je=j-1
 10   continue
      return
      end

      subroutine quit(c)
      character*(*) c
      write(6,'(a)') c
      stop
      end


      subroutine gettrm(zmtrx,nsub)
      integer zmtrx(6,*)
      common /kwave/ y(3,3,3),vc(3)
      common /ctrm/ trm(3,3,3)
      dimension b(3),ipvt(3),indx(3,2),pvt(3)
      do ns=1,nsub
         do i=1,3
            do j=1,3
               k=zmtrx(i,ns)
               if(k.ge.4) then
                  trm(i,j,ns)=y(j,k-3,1)
               else if(j.eq.k) then
                  trm(i,j,ns)=1
               else
                  trm(i,j,ns)=0
               end if
            end do
         end do
         call matinv(trm(1,1,ns),3,3,b,0,det,ipvt,indx,pvt)
         write(6,*) 'transformation matrix'
         do i=1,3
            write(6,'(3f12.6)') (trm(i,j,ns),j=1,3)
         end do
      end do
      return
      end

      subroutine gttrmx(xx,isub)
      dimension xx(*)
      dimension xd(3)
      common /ctrm/ trm(3,3,3)
      call cpyvec(xx,xd)
      do i=1,3
         xx(i)=0
         do j=1,3
            xx(i)=xx(i)+trm(i,j,isub)*xd(j)
         end do
      end do
      return
      end

      subroutine vcpy(v1,v2,n)
      real v1(*),v2(*)
      do 100 i=1,n
      v2(i)=v1(i)
 100  continue
      return
      end

      subroutine cpyvec(v1,v2)
      real v1(3),v2(3)
      do 100 i=1,3
      v2(i)=v1(i)
 100  continue
      return
      end

      subroutine btobij(na,b,isub)
      dimension b(*),isub(*),bij(6)
      common /ceat/ eat(6,3),ebt(6,3)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension j1(6),j2(6)
      data j1/1,2,3,2,3,1/, j2/1,2,3,3,1,2/
      data pi/3.141592/
c     eat is used in rdintl(),rdsymw(),egvctr()
      do 100 n=1,nsub
          do 200 j=1,6
          k=j1(j)
          l=j2(j)
          gkk=gabn(k,k,n)
          gll=gabn(l,l,n)
c         eat(j,n)=gabn(k,l,n)/4
          if(itempf.eq.1.or.itempf.eq.-1) then
            eat(j,n)=gabn(k,l,n)/4     ! b to bi
            ebt(j,n)=4/3*gab(k,l,n)    ! bi to b
          else if(itempf.eq.2.or.itempf.eq.-2) then
            eat(j,n)=gabn(k,l,n)/(8*pi**2)/sqrt(gkk*gll)/4  ! b to ui
            ebt(j,n)=4/3*gab(k,l,n)*(8*pi**2)*sqrt(gkk*gll) ! ui to b
          end if
 200      continue
 100  continue
      if(itempf.eq.1.or.itempf.eq.-1) then
         write(6,*) ' equivalent b11,b22,b33,b23,b31,b12'
      else if(itempf.eq.2.or.itempf.eq.-2) then
         write(6,*) ' equivalent u11,u22,u33,u23,u31,u12'
      end if

      do 10 i=1,na
          js=isub(i)
          do 11 j=1,6
          bij(j)=eat(j,js)*b(i)
 11       continue
          write(6,'(1h ,a,i3,6f9.5)') 'atom',i,(bij(j),j=1,6)
 10   continue
      return 
      end
