c
c
c     refinement of modulated structures by the least squares method
c
c                           (REMOS 85.0)
c
c             copyright (c) oct. 1985  by Akiji Yamamoto
c
c                       input data instruction
c
c     (01) iwflag
c          iwflag(1): 0 output default lists
c             default iwflag  see below
c             iwflag(2)=1, iwflag(3)=1, iwflag(4)=4, iwflag(5)=2,
c             iwflag(6)=3
c                   : 1 output selected list according to the
c                       following
c          iwflag(2): 1 output title
c          iwflag(3): 1 output other input data
c          iwflag(4): 1 output fourier amplitudes in each cycle
c                   : 2 output their difference in each cycle
c                   : 3 output both in each cycle
c                   : 4 output fourier amplitudes in first and
c                       last cycles
c          iwflag(5): 1 output independent parameters in each cycle
c                   : 2 output their difference in each cycle
c                   : 3 output both in each cycle
c          iwflag(6): 1 output standard dev. of independent param.
c                   : 2 output standard dev. of fourier amplitudes
c                   : 3 output both
c
c     (02)    input fo data file name   (a) (see (34))
c     (03)    independent parameter file name (a)
c     (04)    fo data output file name (a)
c     (05)    output fc data file name (a)
c
c     (1) title 
c
c     (2) a,b,c,cosa,coab,coac
c             a,b,c in angstrome
c     (3) na , nsub,  zmtrx
c         na: number of independent atoms in an asymmetric unit
c             of the aberage (fundamental) structure (1<=na<=100)
c         nsub: number of subsystems  
c               (for usual modulated structure nsub=1)
c               (for composite crystals, 2 <= nsub <=3)
c         zmtrx(1-6): permutation for the second to nsub-th subsystems
c         for example 1 3 4 2 5 6   2 3 5 1 4 6 means that 
c             a1*, a3*, a4* and a2*, a3*, a5* span the reciprocal lattices
c             for the second and third substructures
c             (for the first substructure 1 2 3 4 5 6 is assumed)
c
c     (4) 'basic structure'
c            no,symbol,sft,x1-x6,b,p,isub   (*)
c         no: atom number
c         symbol: symbol of the atomic site
c         stf: scattering-factor-table number
c         x1-x6: atomic coordinates
c         (for composite crystals, give coordinates for the substructure)
c         b: isotropic temperature factor
c         p: occupation probability
c         isub: subsystem  (1-3 for first to third subsystem)
c
c          =========== repeat (4) na times ===========
c
c     (5) ndm,nsymo,icent,ige,nctr
c         ndm: dimension of modulation     (1<=ndm<=3)
c         nsymo: number of symmetry operators in modulated structure
c                 (1<=nsymo<=48)
c         icent=0: noncentrosymmetric, =1: centrosymmetric
c           if centrosymmetric take the origin at center of symmetry
c           and give symmetry operators in the factor group, g/i
c           ige=0: give all symmetry opeators, ige=1: give generators,
c           then all elements are created in the program
c         nctr: number of centering translations  (0<=nctr<=48)
c               nctr=0 means primitive lattice
c
c     (6)  a*,b*,c* components of the wave vector icorc, ilm (*)
c         if incommensurate icorc=1, commensurate icorc=0
c         ilm  number of divisions of gauss integrals in structure
c         factor formula in incommensurate cases     3<=ilm<=100
c          ******caution:  satellite with order greater than****
c          *******ilm/5 is not calculated.  This means that ****
c          *******if second order satellite intensity must be***
c          *******necessary ilm >= 10 is necessary *************
c           =========== repeat (6) ndm times ============
c
c           if all the wave vectors are incommensurate
c                          skip (7)
c **************data for the commensurate structure*********************
c *       if anyone of wave vectors is commensurate,                   *
c *   (7)  ilc   :give period along a,b,c axes
c **********************************************************************
c           if(nctr=0) skip (8)
c     (8) 'centering translation'
c           in the format of I.T.
c           1/2,1/2,0,1/2  etc.
c           =========repeat (8) nctr times ========
c     (9) 'symmetry operatore'
c           in the format of I.T.
c            for example x,y,z,t,u,v
c         if ige=1 then give the order of the symmetry operator for ior
c           ======== repeat (9) nsymo times ==========
c         ****the first operator must be the identity operator****
c         ****the symmetry operator is used to classify the
c                   satellite reflections    see (36)******
c
c     (10) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,itst,nxmax
c         ix: no. of independent parm. for displacement
c         ib: no. of independent parm. for temperature factor
c         if: no. of independent parm. for scattering factor
c         nds: no. of data sets ( no. of scale factprs )  (1<=nds<=20)
c         nzc: upper limit of the number of coefficients which relate
c          constrained atomic parameters and independent parameters
c         nw: no. of fourier terms
c         nt: upper limit of the number of sin and cos functions
c             included in a fourier term
c         ipol=1, differenciation is made in the poler coordinate
c            then give each complex amplitude of modulation waves
c            in order of re and im parts.
c         ipnf1>0,the penalty function is used for the
c            occupation probability (see (35))
c         ipnf1=1 limits upper and lower sides while
c         ipnf1=2 limits lower side of occupation probability
c         ipnf2=1,penalty function is used for the interatomic distance
c                         (see (34))
c         itvr: no. of parameters for domain size
c         itst:  no. of parameters for out of step
c         nxmax: upper limit of no. of variable parameter in each block
c                                                   (see (32))
c
c     (11) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
c          dspmdl=1 displasive modulation exists otherwise =0
c          tmpmdl=1 temp.fact. modulation exists otherwise =0 then b=0
c          sctmdl=1 density modulation exists otherwise =0 then p=1
c          sctmdl=-1 means substitutional modulation
c            then give the occupation probability of the first atom
c            the occupation probability of the second atom is given
c            by 1-p  (see 15)
c          itempf=0 isotropic temperature factor for all atoms
c          itempf=1 anisotropic temperatire factor Bij for all atoms
c          itempf=-1 some atoms anisotropic (Bij) and others isotropic
c          itempf=2 anisotropic temperatire factor Uij for all atoms
c          itempf=-2 some atoms anisotropic (Uij) and others isotropic
c               Beq=(4/3)(B11*a*a+...+2*B12*a*b*+...)
c               Beq=(4/3)(U11+U22+U33+2*U12+2*U23+2*U31)*8*pi*pi
c          itwin nomber of twin domains  (0,1 single crystal)
c          iphfl=1 phase fluctuations between microscopic domains
c          iphfl=0 no such phase fluctuations
c          isext=1 or -1 secondary extinction correction for x-ray or neutron
c                   correlation function in the manual is used
c          isext=2 or -2 secondary extinction correction for x-ray or neutron
c                   correlation function in Kawamura and Kato (Acta Cryst.
c                        A39 (1983) 305 is used
c
c                       if itempf<0 skip (12)
c ***********data to specify anisotropic temperature factor*************
c *    specify atoms with anisotropic temp.fact.                       *
c *    (12) (itfs(i),i=1,na)  (80i1)                                   *
c *    itfs(i)=0:temp.factor of i-th atom is isotropic,=1: anisotropic *
c **********************************************************************
c
c                     if itwin=0 skip (13)
c ************data for the case of twined crystals**********************
c *    (13) twin operator  in the format of I.T.
c *         ========== repeat (13) abs(itwin) times  =========         *
c **********************************************************************
c
c     (14) ne,iand,inpd
c          ne: number of atomic-scattering-factor tables
c          iand: give 1 when the anomalous dispersion correction is
c                made, otherwise, give 0.
c          inpd: give 0 when atomic scattering table is given
c                give 1 when coefficients of 4-exponental-function
c                approximation of the atomic scattering factoris are
c                given
c
c     (15) 'scattering factor' table with interval of 0.05
c          (asct(i),i=1,35) (12f6.3) or the coeffecients
c          (a(i),b(i),i=1,4),c  (*)
c
c                         if iand=0 skip (16)
c**********************************************************************
c*    (16) real and imaginary parts of anom. disp. cor. (*)           *
c**********************************************************************
c                       if sctmdl>=0 skip (17)-(18)
c**********************************************************************
c*    (17) scattering factor for the second species            *
c*         in the same site                            (12f6.3)       *
c*           the format is the same as in (15)                        *
c*                                                                    *
c*    (18) real and imaginary parts of the anomarous dispersion       *
c*             correction for the second species       (2f8.5)        *
c**********************************************************************
c
c      ============== repeat (15)-(18)) ne times =================
c
c                     if ipnf2=0 skip (19)-(20)
c***********data for the second penalty function, pf2*******************
c*    (19) nb
c           nb: number of bond distances to be constrained
c*    (20) atom1,atom2,nsym,icnt,(tdr(i),i=1,6) dmin,dmax,icont        *
c*                                 (4i3,8f8.6,i3)                      *
c*         atom1: atom number of the first atom in a pair              *
c*         atom2: atom number of the second atom(see below)            *
c*         nsym: symmetry operator number which generate from atom2    *
c*               the second atom in a pair                             *
c*         icnt: if the second atom in a pair is generated by the      *
c*               combination of the avobe operator and the inversion   *
c*               then icnt=1, otherwise icnt=0                         *
c*         trd(i) a,b,c components of an additional translation vector *
c*         dmin: minimum interatomic distance allowed                  *
c*         dmax: maximum interatomic distance allowed                  *
c*          when aberage bond distances are constrained,               *
c*           repeat (20) by the number of bond distances to be averaged*
c*           then last dmin and dmax are regarded as the limit of      *
c*           average bond distances and 1 must be given for icont      *
c*           excluding the last line of each group.  the program counts*
c*           the number of pairs by icont                              *
c*                      repeat (20) nb times                           *
c***********************************************************************
c
c                    if isext=0 skip (21)-(25)
c ***********data for absorption and extinction corrections*************
c *       the bisecting position (omega=0) is assumed                  *
c *        (busing et al. 1967, acta cryst. 22, 475.)                  *
c *   (21) nbf,mp,mq,mr,icm
c *        nbf: number of equations designating boundary conditions    *
c *           nbf.eq.1  ellipsoidal crystal                            *
c *           nbf.gt.1  polyhedral crystal                             *
c *       mp,mq,mr: number of divisions along x,y,z axes in integral   *
c *       icm:  (see 24)                                               *
c *             mp*mq*mr<=1000 ******related common variables          *
c *              common /extcr2/ ex,ey,ez,wxyz                         *
c *   (22)  aa,bb,cc,ff
c *      boundary cond. (x/aa)**2+(y/bb)**2+(z/cc**2=ff**2             *
c *              or aa*x+bb*y+cc*z=ff                                  * 
c *       (x,y,z in cm and ff must be positive)                        *
c *                  repeat (22) by nbf times                          *
c *                                                                    *
c *   (23) wv,abc0,bth,amag
c *       wv: wave length in 10**-8 cm                                 *
c *       abc0: linear absorption coefficient in cm**-1                *
c *       bth: bragg angle for monochrometer in degree                 *
c *          (if monochrometer is not used  bth=0)                     *
c *       amag: magnification of calculated structure factors          *
c *                                                                    *
c *   (24) cm                                                          *
c *       cm:     cell orientation matrix  (ub or u matrix)            *
c *               ((cm(i,j),j=1,3),i=1,3) 
c *          if(icm.eq.0)   cm : ub matrix                             *
c *          (hx/hy/hz)=cm*(h/k/l)                                     *
c *           where (hx/hy/hz),(h/k/l) are column matrices             *
c *           hx,hy,hz:  rectangular coordinates in instrument system  *
c *           (phi-axis system)  (in 10**8 cm**-1)                     *
c *          if(icm.ne.0)  cm : u matrix                               *
c *          (hx/hy/hz)=cm*(hx'/hy'/hz')                               *
c *           hx',hy',hz': rectangular coordinates fixed in a crystal  *
c *               (in 10**8 cm**-1)                                    *
c *           where hz' axis is parallel to z-axis                     *
c *                 hy' axis is in y-z plane and normal to hz' axis    *
c *                 hx' axis is normal to hz' and hy' axes             *
c *                                                                    *
c *   (25) om                                                          *
c *       om: the transformation matrix from instrument system to      *
c *              ((om(i,j),j=1,3),i=1,3)
c *           the system describing the boundary conditions            *
c *                                                                    *
c **********************************************************************
c
c     (26) 'fourier term'
c          sig,cs,n1,n2,n3,coef,icont          (4(2a1,3i2,f10.6,1x,a1))
c          give the fourier terms
c          sig: + or -
c          cs: c for cosine and s for sine function
c          n1,n2,n3: the factors for x4,x4,x6
c                  +c 1-2 3 means +cos(x4-2x5+3x6)
c          coef: the factor for the above term
c          icont: give any character except for a blank if the
c              fourier term is followed by the other sine or cosine
c              functions
c     (27) 'initial parameter'
c                and ps  ((12x,6(f9.4,a1)))
c          if dspmdl, tmpmdl and/or sctmdl are zero, the corresponding
c          parameter is not necessary
c
c
c     (28) jx,jb,jp   numbers of independent parameters which are
c          related with constrained amplitudes of the displacement,
c          temperature factor and occupation probability.
c
c          if jx,jb,jp are all zero skip (29)
c***********************************************************************
c*    (29)  j,a,k,ea,cont         (4(3i3,f10.6,a1))                    *
c*          j: atom number                                             *
c*          a: component of vector or tensor (1,2,3 for x,y,z components
c*             of displacement, 1,2,3,4,5,6 for b11,b22,b33,b23,b31,b32*
c*             of inisotropic temperature factor, and 1 for isotropic  *
c*             temperature factor and occupation probability           *
c*          k: fourier term                                            *
c*          ea(j,a,k): coefficient                                     *
c*             the constrained amplitude specified is given by         *
c*             ea(j,a,k)*x where x is the i-th independent valiable.   *
c*             the number i is counted from the blank at the columns   *
c*             of cont.  the blank at the columns of cont means the end*
c*             of constrained variables related to the i-th independent*
c*             variable.  therefore if additional terms are followed   *
c*             then give any character to cont.                        *
c***********************************************************************
c
c                      if itwin=0 skip (30)
c***********************************************************************
c*     (30)    j,ea,cont   (4(i3,6x,f10.6,a1)                          *
c*          j: twin domain number  (1<=j<=6)                           *
c*          ea: volume ratio of twin domains                           *
c***********************************************************************
c
c
c     (31) initial values for constrained parameters and
c          twin vol.r, phase flc. scales ext.cor  (8(f9.4,x1))
c
c     (32) iextc
c          iextc: number of blocks
c              extc>1 block diagonal least squars method
c
c     (33) iwf, fct  (if f table necessary, iwf=1 otherwise iwf=0
c             fct: magnification of f in the f table
c
c     (34) maxc,istdv,icont,ifunc,wght
c          maxc: maximum cycles of the least squars refinement (maxc>=0)
c          istdv: =1 standard deviations are calculated
c                 =0 no standard deviations are calculated
c          icont: =1 parameters saved in disc are used
c                 =0 parameters specified in data cards are used
c                         time
c          ifunc: =1 sin cos exp functions are used
c                 =0 sin cos exp tables are used to save the computing
c          wght: =0 given weight is used when fobs>fmin
c                   otherwise wg0 given in (37)
c                =1 unit weignt is used when fobs>fmin
c                   otherwise wg0
c                =2 100/(fobs)**2  when fobs>fmin
c                   otherwise 100/(fmin)**2
c                =3 fobs/10 when fobs>fmin
c                   otherwise fmin/10
c
c     (35) eps,dmpf,aydm,alp,grad1,expn1,grad2,expn2
c          eps: if r factor difference.lt.mrdf then stop
c          dmpf: damping factor (standard value is about 0.2)
c          aydm: cutoff radius of reflections used in a**-1
c          alp: refinement minimizes modified weighted r-factor with
c               weight factor exp(-alp*(y/2)**2)*w, where y is the
c               reflection vector in the reciprocal space and w is the
c               weight factor specified by wght
c               alp=0: normal weight factor
c          grad1 and expn1: the penalty function,pf1, is defined by
c                      pf1=grad1*(-p)**expn1 for p<0
c                      pf1=grad1*(p-1)**expn1 for p>1
c                      pf1=0 otherwise
c                  standard values grad=1, expn=1
c                 (grad and expn must be positive)
c          grad2 and expn2: the penalty function,pf2, is defined by
c                      pf2=grad2*(dmin-d)**expn for d<dmin
c                      pf2=grad2*(d-dmax)**expn for d>dmax
c                      pf2=0 otherwise
c
c     (36) reflection selection variables ng
c          ng: number of reflection groups
c              =0 all reflections are selected in the refinement
c                 groups to be used in the refinement
c              reflections transformed from the indices specified
c              above by symmetry operators are used in the refinement
c              if(ng>0)   give h3+i (repeat ng times)
c
c     (37) fmin, wg0 , hm 
c          fmin,wg0: see (35)
c          hm(1)-hm(6) mean the upper limits of 'miller' indices,
c          default values: hm(1)-hm(3) 24, hm(4)-hm(6) 10
c
c     (38) inp,iorf, format for h1,h2,.. fobs (or iobs) weight(2i2,19a4)
c          inp : 5 standard input 3: other file
c          iorf: 0 intensity 1: structure factor
c          format for h1,h2,.. fobs (or iobs) and weight
c
c                        if inp=3  skip (39)
c***********************************************************************
c*    (39) h1,h2.. fobs (or iobs), wght                                *
c*         miller indices fobs (or iobs) weight according to the format*
c*         specified above                                             *
c*                repeat (39) up to the last reflection                *
c*            ****h1=999 mean the end of each data sets****            *
c***********************************************************************
c
c     (40) parameter selection flags                        (80i1)
c          if i-th parameter is refined, give 1 at i-th column
c          otherwise give 0
c   ================  (33)-(40) repeat extc times=================
c
c                 remos90 main program
      common /cdim/ idm,nde
      common /cwflag/ iwflag(6)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
      integer dspmdl,tmpmdl,sctmdl
c     common /cnsti/ ix,ib,if,itvr,itst,nds,na8
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *          ,ix13,ix14,ix15,ix16,ix17,ix18,ix19,ix20,ix21,ix22,
     *           ix23,ix24,ix25,ix26,ix27,ix28
      common /citfs/ itfs(100)
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
c      parameter (mmax=400000)
      parameter (mmax=800000)
      dimension ax(mmax),tt0(6)
      integer defiwf(6)
      character*80 flnm1, flnm2, flnm3, flnm4
      character*4 watom
      data watom/'atom'/,tt0/6*0.0/
      data defiwf/0,1,1,4,2,3/
      data zmtrx /1,2,3,4,5,6,1,2,3,4,5,6,1,2,3,4,5,6/
c
c    memory design  (the large array, ax, are devided into 25 parts
c    and each part is used as a different array in several subroutines)
c  ax(na1):isft, ax(na2):mpl, ax(na3):x, ax(na4):isk,ax(na5):irs,
c  ax(na6);b,ax(na7):p, ax(na8): isub, ax(ix1):x1
c  ax(ix2):x2, ax(ix3):x3, ax(ix4):x4, ax(ix5):x5, ax(ix6):x6
c  ax(ix7):ea, ax(ix8):xjl, ax(ix9):bjl, ax(ix10):fjl, ax(ix11):csb
c  ax(ix12):m, ax(ix13):l, ax(ix14):ips, ax(ix15):ja, ax(ix16):iw
c  ax(ix17):cdr, ax(ix18):cdi, ax(ix19):xx, ax(ix20):mx, ax(ix21):ifrt1
c  ax(ix22):ifrt2, ax(ix23):coeff, ax(ix24):csb1, ax(ix25):csb2
c  ax(ix26):hl,ax(ix27):dl
c
c
c dimension of ax
      call setinp(5)
      call setout(6)
      call setskp(0)
c calculation of sin cosin table
      call sctabl
c calculation of exp table
      call sexpt
c (0) read output control flags
c      read(5,'(6i1)') (iwflag(i),i=1,6)
      call freadi('iwflag=',6,iwflag,1)
      if(iwflag(1).eq.0) then
           do 10 i=1,6
 10        iwflag(i)=defiwf(i)
      end if
      write(6,'(1h ,a,6i3)') 'output control flags  ', iwflag
      read(5,'(a)') flnm1
      read(5,'(a)') flnm2
      read(5,'(a)') flnm3
      read(5,'(a)') flnm4
      lfn1=istrln(flnm1)
      lfn2=istrln(flnm2)
      lfn3=istrln(flnm3)
      lfn4=istrln(flnm4)
      write(6,'(1h ,a)') flnm1(1:lfn1)
      write(6,'(1h ,a)') flnm2(1:lfn2)
      write(6,'(1h ,a)') flnm3(1:lfn3)
      write(6,'(1h ,a)') flnm4(1:lfn4)
      open(unit=3,file=flnm1)
      open(unit=4,file=flnm2)
      open(unit=91,file=flnm3,access='direct',recl=1200)
      open(unit=92,file=flnm4,access='direct',recl=800)
c (1),(2) read title and lattice constants
      call rdlc
c (3) read number of atoms in an asymmetric unit
c      read(5,100) na
      call freadi('na=',1,na,1)
      call freadi('nsub=',1,nsub,0)
      idm=nde+3
      if(nsub.le.0.or.nsub.gt.3) call quit('*** nsub invalid***')
      if(nsub.ge.2) then
          call freadi('zmtrx=',6,zmtrx(1,2),0)
      end if
      if(nsub.eq.3) then
          call freadi('zmtrx=',6,zmtrx(1,3),0)
      end if
      if(iwflag(3).eq.1) then
           write(6,*) 'na=',na,' nsub=',nsub,
     *        ('zmtrx=',(zmtrx(i,n),i=1,6),n=2,nsub)
      end if
      na1=1
      na2=na+na1
      na3=na+na2
      na4=6*na+na3
      na5=49*na+na4
      na6=49*na+na5
      na7=na+na6
      na8=na+na7
      na9=na+na8
c (4) read atomic positions
c     call rdap(na,isft,x,b,p,isub)
      call rdap(na,ax(na1),ax(na3),ax(na6),ax(na7),ax(na8))
c (5)-(10) read symmetry operators
c     call rdsymo(na,isk)
      call rdsymo(na,ax(na4))
      call getgij(zmtrx,nsub)
c     call btobij(na,b,isub)
c     call btobij(na,ax(na6),ax(na8))
c     call sitesy(na,mpl,x,isk,irs,isub)
      call sitesy(na,ax(na2),ax(na3),ax(na4),ax(na5),ax(na8))
c (11) read control variables
c      read(5,100) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,itst
c     *       ,nxmax
       call freadi('ix=',1,ix,1)
       call freadi('ib=',1,ib,0)
       call freadi('if=',1,if,0)
       call freadi('nds=',1,nds,0)
       call freadi('nzc=',1,nzc,0)
       call freadi('nw=',1,nw,0)
       call freadi('nt=',1,nt,0)
       call freadi('ipol=',1,ipol,0)
       call freadi('ipnf1=',1,ipnf1,0)
       call freadi('ipnf2=',1,ipnf2,0)
       call freadi('itvr=',1,itvr,0)
       call freadi('itst=',1,itst,0)
       call freadi('nxmax=',1,nxmax,0)
      if(nxmax.eq.0) nxmax=250
      if(iwflag(3).eq.1) then
           write(6,207) ix,ib,if,nds,nzc,nw,nt,ipol,ipnf1,ipnf2,itvr,
     *        itst,nxmax
      end if
c (12) read control variables
c      read(5,102) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
      call freadi('dspmdl=',1,dspmdl,1)
      call freadi('tmpmdl=',1,tmpmdl,0)
      call freadi('sctmdl=',1,sctmdl,0)
      call freadi('itempf=',1,itempf,0)
      call freadi('itwin=',1,itwin,0)
      call freadi('iphfl=',1,iphfl,0)
      call freadi('isext=',1,isext,0)
      if(iwflag(3).eq.1) then
           write(6,206) dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,isext
      end if
c (13)
      if(itempf.lt.0) read(5,103) (itfs(i),i=1,na)
 103  format(80i1)
      if(iwflag(3).eq.1) then
           if(itempf.lt.0) write(6,201) (watom,i,itfs(i),i=1,na)
      end if
c     call btobij(na,b,isub)
      call btobij(na,ax(na6),ax(na8))
      if(itwin.eq.0) volr(1)=1.0
c (14) read symmetry operators for twin
      if(itwin.ne.0) call rdtsym(itwin)
c (15)-(19) read atomic scattering factors
      call rdasf(sctmdl)
c (20)-(21) read data for the second penalty function
      if(ipnf2.eq.1) call rdpnf2
c (22)-(26) read data for extinction correction
      if(isext.ne.0) call rdextc(isext)

c calculations of constants
      call cnstnt(mmax,iax)
      if(iax.gt.0) go to 20
c calculate intervals and weights in gauss integrals
      call gauss2
c (27) read fourier terms
      call rdfour(nw,nt,ax(ix21),ax(ix22),ax(ix23))
c calculate fourier terms for each independent atom
      call begin(ax(ix11),nw,nt,na,nl,ax(na3),ax(na8),ax(ix21),
     *                 ax(ix22),ax(ix23),1,0,tt0)
c (28) read initial parameters x,b,p (na*ic*nw)
c (29)-(33) read constraint conditions
      nc=4+it
      call rdintl(ax(ix19),ax(ix20),ax(ix15),ax(ix7),
     *                      ax(ix1),ax(na8),na,nc,nu)
c (34)-(42) read parameters for least squares calculations
      call fls(ax(ix15),ax(ix7),ax(ix8),ax(ix9),ax(ix10),
     *        ax(ix1),ax(ix2),ax(ix3),ax(ix14),ax(ix11),ax(ix12),
     *        ax(na1),ax(na8),ax(na2),ax(na3),ax(na6),ax(na7),
     *        ax(ix16),ax(ix4),
     *        ax(ix5),ax(ix6),ax(ix17),ax(ix18),ax(na4),ax(na5),
     *        ax(ix24),ax(ix25),ax(ix26),ax(ix27),
     *        ax(ix21),ax(ix22),ax(ix23),nu)
      close(unit=3)
      close(unit=4)
      close(unit=91)
      close(unit=92)
      stop
 20   write(6,200) iax
      close(unit=91)
      close(unit=92)
      stop
 100  format(14i3)
 102  format(7i3)
 200  format(1h ,'lack of dimension',10x,'ax =',i6)
 201  format(1h ,'selection of temperature factors, 0: isotropic, 1: an
     *       isotropic'/(1h ,10(a4,i2,':',i1,2x)))
 206  format(1h ,'dspmdl=',i3,3x,'tmpmdl=',i3,3x,'sctmdl=',i3,3x,
     *      'itempf=',i3,3x,'itwin=',i3,3x,'iphfl=',i3,3x,'isext=',i3)
 207  format(1h ,'ix=',i3,2x,'ib=',i3,2x,'if=',i3,2x,'nds=',i3,2x,
     *      'nzc=',i3,2x,'nw=',i3,2x,'nt=',i3,2x,'ipol=',i3,2x,'ipnf1=',
     *    i3,2x,'ipnf2=',i3,2x,'itvr=',i3,2x,'itst=',i3,2x,'nxmax=',i3)
      end


      subroutine sctabl
      common /csct/ sct(721)
      pai2=6.28318
      do 10 i=1,721
      x=pai2*float(i-1)/720.0
      sct(i)=sin(x)
 10   continue
      return
      end

      subroutine sexpt
      common /cexpt/ expt(500)
      do 10 i=1,200
      x=-float(i-1)/400.0
      ii=i
 10   expt(ii)=exp(x)
      do 20 i=1,200
      x=-float(i-1)/200.0-0.5
      ii=i+200
 20   expt(ii)=exp(x)
      do 30 i=1,100
      x=-float(i-1)/100.0-1.5
      ii=i+400
 30   expt(ii)=exp(x)
      return
      end

      subroutine cnstnt(mmax,iax)
c     calculation of constants
c     common /cnsti/ ix,ib,if,itvr,itst,nds,na8
      common /cnsti/ ix,ib,if,itvr,itst,nds,na8,na9
      common /cnsto/ ix1,ix2,ix3,ix4,ix5,ix6,ix7,ix8,ix9,ix10,ix11,ix12
     *       ,ix13,ix14,ix15,ix16,ix17,ix18,ix19,ix20,ix21,ix22,
     *        ix23,ix24,ix25,ix26,ix27,ix28
c      common /bgn/ ilm(3),icorc(3),ilc(3)
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /cdim/ idm,nde
      integer dspmdl,tmpmdl,sctmdl
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /asft/ ne,ascf(35,20),df1(20),df2(20),iand
c*********************************************************
c    calculation of constants for memory design
c*********************************************************
      pai2=6.28318
      nl=1
      do 10 i=1,nde
 10   nl=nl*ilm(i)
      do 11 i=1,3
 11   nl=nl*ilc(i)
      nx=ix+ib+if+itvr+itst+nds
      if(abs(isext).ne.0) nx=nx+2
c     if(itempf.ge.1) it=6
c     if(itempf.lt.1) it=1
      if(itempf.ne.0) it=6
      if(itempf.eq.0) it=1
      if(iphfl.eq.1) it=it+nde*(nde+1)/2
c     ix1=na8
      ix1=na9
      ix2=nx+ix1
      ix3=nx+ix2
      ix4=nx+ix3
      ix5=nx+ix4
      ntwin=itwin
      if(ntwin.eq.0) ntwin=1
      ix6=nx*ntwin+ix5
      ix7=nx*ntwin+ix6
      ix8=nzc+ix7
      ix9=3*na*nl+ix8
      ix10=it*na*nl+ix9
      ix11=na*nl+ix10
      ix12=nw*na*nl+ix11
      nxd=min0(nx*(nx+1)/2,nxmax*(nxmax+1)/2)
      ix13=nxd+ix12
      ix14=ix13
      ix15=nx+ix14
      ix16=4*nzc+ix15
      ix17=nx+ix16
      ix18=nw*na*(6+it)+ix17
      if(iand.eq.1) ix18=ix18+nw*na*2
      ix19=nw*na*(6+it)+ix18
      if(iand.eq.1) ix19=ix19+nw*na*2
      ix20=na*(it+4)*nw+ix19
      ix21=na*(it+4)*nw+ix20
      ix22=nw*2*nt+ix21
      ix23=nw*3*nt+ix22
      ix24=nw*nt+ix23
      ix25=nw*nl+ix24
      ix26=nw*nl+ix25
      ix27=nx*nl+ix26
      ix28=nl+ix27
      iax=ix28-mmax-1
      return
      end

      subroutine gauss2
      implicit real*8 (a-h,o-z)
      real*4  pxj,hj
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      real*4 y,vc
      common /kwave/ y(3,3,3),vc(3)
c     common /kwave/ y(3,3)
      common /cdim/ idm,nde
      dimension p(3)
c     calculation of interval and weight of gauss integral
      icom=0
      do 20 l=1,3
      if(icorc(l).eq.1) then
           me=ilm(l)
      else
           me=ilc(1)*ilc(2)*ilc(3)
      end if
      do 20 m=1,me
      pxj(m,l)=0.0
 20   hj(m,l)=1.0
c
      do 12 l=1,nde
      if(icorc(l).eq.1) then
c          incommansurate case
           n=ilm(l)
           eps=1.0d-10
           do 10 k=1,ilm(l)
           xm=float(n+1-2*k)/float(2*n+1)
           x=dsin(xm*3.1415926536d0)
 30        p(1)=1.0
           p(2)=x
           do 21 i=2,n
           p(3)=x*p(2)+float(i-1)/float(i)*(x*p(2)-p(1))
           p(1)=p(2)
 21        p(2)=p(3)
           d=(1.0d0-x**2)*p(2)/(float(n)*(p(1)-x*p(2)))
           if(dabs(d).lt.eps) go to 40
           x=x-d
           go to 30
 40        w=2.0d0*(1.0d0-x**2)/(float(n)*p(1))**2
           pxj(k,l)=-x/2.0d0
           hj(k,l)=w/2.0d0
 10        continue
      else
c          commensurate case
           k=0
           icom=icom+1
           do 13 k3=1,ilc(3)
           do 13 k2=1,ilc(2)
           do 13 k1=1,ilc(1)
           k=k+1
           pxj(k,l)=y(1,l,1)*(k1-1)+y(2,l,1)*(k2-1)+y(3,l,1)*(k3-1)
c          pxj(k,l)=y(1,l)*(k1-1)+y(2,l)*(k2-1)+y(3,l)*(k3-1)
           pxj(k,l)=mod(pxj(k,l),1.)
           if(pxj(k,l).lt.0) pxj(k,l)=pxj(k,l)+1
           if(icom.eq.1) then
                  hj(k,l)=1.0/(ilc(1)*ilc(2)*ilc(3))
           else
                  hj(k,l)=1.0
           end if
 13        continue
      end if
 12   continue
      return
      end


      subroutine begin(csb,nw,nt,na,nl,x,isub,ifrt1,ifrt2,coeff,
     *                ns,icnt,trd)
      dimension csb(nw,na,*),x(6,*),isub(*),ifrt1(nw,2,*),
     *                              ifrt2(nw,3,*),coeff(nw,*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /cdim/ idm,nde
c     common /kwave/ y(3,3)
      common /kwave/ y(3,3,3),vc(3)
      integer zmtrx
      common /czmtrx/ zmtrx(6,3), nsub
      integer rr
c     common /sym/ rr(6,6,48),tt(6,48),nsymo,icent
      common /sym/ rr(6,6,48,3),tt(6,48,3),nsymo,icent
      dimension arg(6),agd(6),rs(6,6,3),bb(6),ipv(6),ind(6,2),piv(6)
      dimension trd(6),nm(6)
      character sgn1,sgn2,chr1,chr2
      character*2 cs1,cs2
      character*4 ifrt1
      data sgn1/'+'/,sgn2/'-'/,cs1/'cC'/,cs2/'sS'/
c*******************************************************************
c      calculation of fourier terms for each independent atom
c*******************************************************************
      do 21 j=1,nw
      do 21 jk=1,na
      do 21 m=1,nl
 21   csb(j,jk,m)=0.0
      do 241 nd=1,nsub
         do 24 i=1,idm
         do 24 j=1,idm
 24      rs(i,j,nd)=rr(i,j,ns,nd)
         call matinv(rs(1,1,nd),6,idm,bb,0,det,ipv,ind,piv)
 241  continue
c
      do 10 i=1,nw
      do 12 j=1,nt
      chr1=ifrt1(i,1,j)(1:1)
      if(chr1.eq.sgn1) then
            sgn=1
      else if(chr1.eq.sgn2) then
            sgn=-1
      else
            go to 13
      end if
      if(coeff(i,j).eq.0.0) coeff(i,j)=1.0
      do 11 jk=1,na
           js=isub(jk)
           do 22 k=1,6
 22        arg(k)=0.0
           do 20 nd=1,idm
           arg(nd)=x(nd,jk)
           if(nd.ge.4) then
                ni=nd-3
                arg(nd)=arg(nd)+
     *          y(1,ni,js)*x(1,jk)+y(2,ni,js)*x(2,jk)+y(3,ni,js)*x(3,jk)
           end if
 20        continue
           m=0
c     incommensuratr loop
           do 51 m3=1,ilm(3)
           do 51 m2=1,ilm(2)
           do 51 m1=1,ilm(1)
c     commensurate loop
           do 51 n1=1,ilc(1)*ilc(2)*ilc(3)
           nm(1)=m1
           nm(2)=m2
           nm(3)=m3
           m=m+1
           if(icorc(1).eq.0) nm(1)=n1
           if(icorc(2).eq.0) nm(2)=n1
           if(icorc(3).eq.0) nm(3)=n1
           do 23 nd=1,nde
           agd(nd)=0
                do 231 k=1,3
 231            agd(nd)=agd(nd)+
     *          rs(nd+3,k,js)*(arg(k)-tt(k,ns,js)-trd(k))
                do 232 k=4,idm
 232            agd(nd)=agd(nd)+rs(nd+3,k,js)*
     *          (arg(k)+pxj(nm(k-3),k-3)-tt(k,ns,js)-trd(k))
           if(icnt.eq.1) agd(nd)=-agd(nd)
 23        continue
           a=0
           do 233 nd=1,nde
 233       a=a+agd(nd)*ifrt2(i,nd,j)
           chr2=ifrt1(i,2,j)(1:1)
           if(index(cs1,chr2).gt.0) then
                cs=cos(a*pai2)*sgn
           else if(index(cs2,chr2).gt.0) then
                cs=sin(a*pai2)*sgn
           else
                cs=0.0
           end if
 51        csb(i,jk,m)=csb(i,jk,m)+cs*coeff(i,j)
 11   continue
 12   continue
 13   je=j-1
 10   continue
      return
      end

      subroutine matinv(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
      do 105 j=1,n
      if(ipivot(j).eq.1) go to 105
      do 100 k=1,n
      if(ipivot(k)-1) 80,100,740
  80  if(abs(amax).ge.abs(a(j,k))) go to 100
      irow=j
      icolum=k
      amax=a(j,k)
 100  continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
      swap=b(irow)
      b(irow)=b(icolum)
      b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
      b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
      do 450 l=1,n
 450  a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
      do 700  k=1,n
      swap=a(k,jrow)
      a(k,jrow)=a(k,jcolum)
 700  a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end

      subroutine fls(ja,ea,xjl,bjl,fjl,x,y,z,ips,csb,
     *           m,isft,isub,mpl,xx,bx,px,iw,delt,de,df,cdr,cdi,isk,irs,
     *           csb1,csb2,hl,dl,ifrt1,ifrt2,coeff,nu)
      dimension ea(*),ja(*),xjl(*),bjl(*),fjl(*),ips(*),csb(*),isft(*)
      dimension isub(*)
      dimension mpl(*),xx(*),bx(*),px(*),iw(*),isk(*),irs(*)
      dimension csb1(*),csb2(*)
      dimension x(*),y(*),z(*),delt(*),de(*),df(*),cdr(*),cdi(*)
      dimension ifrt1(*),ifrt2(*),coeff(*),hl(*),dl(*)
c      dimension ij(3),ijd(3)
      common /cwflag/ iwflag(6)
      common /fhkl/ hkln(100),fobs(100),fcal(100),wght(100),im(20),is(2)
      common /filen/ flfobs,flfcal
      common /ctlint/ nx,nzc,it,nw,na,nl,isext,ipol,ipnf1,ipnf2,nxmax,
     *         nt
      common /caydm/ aydm,alp,ifunc
      common /cpnf/ grad1,expn1,grad2,expn2,np
      complex fcal
      real m(*),mpl
      real*8 r,ro,rd,rw
      integer q
      character*4 iw,ifrt1
      character*26 flfcal,flfobs

c
c     full matrix least squars method
c
c     read the number of blocks (block diagonal least squars method)
c      read(5,101) iextc
      call freadi('iextc=',1,iextc,1)
      flfobs='yamamot.work1.data'
      flfcal='yamamot.work2.data'
c**********************************************************************
c     initialization
c**********************************************************************
      pf1=0.0
      pf2=0.0
      ro=10.0d0
      pf1o=10.0
      pf2o=10.0
      totalo=10.0
      alc=0.1
      ncycle=0
c***********************************************************************
c     beginning of block loop
c***********************************************************************
      do 12 iz=1,iextc
c      read(5,105) iwf,fct
      call freadi('iwf=',1,iwf,1)
      call freadr('fct=',1,fct,0)
      if(iwflag(3).eq.1) then
           write(6,217) iwf,fct
      end if
      ie=1
c      read(5,102) ic,istdv,icont,ifunc,iwght
      call freadi('maxc=',1,ic,1)
      call freadi('istdv=',1,istdv,0)
      call freadi('icont=',1,icont,0)
      call freadi('ifunc=',1,ifunc,0)
      call freadi('iwght=',1,iwght,0)
c      read(5,103) eps,dmpf,aydm,alp,grad1,expn1,grad2,expn2
      call freadr('eps=',1,eps,1)
      call freadr('dmpf=',1,dmpf,0)
      call freadr('aydm=',1,aydm,0)
      call freadr('alph=',1,alp,0)
      call freadr('grad1=',1,grad1,0)
      call freadr('expn1=',1,expn1,0)
      call freadr('grad2=',1,grad2,0)
      call freadr('expn2=',1,expn2,0)
      dmp=dmpf
      ic1=ic+1
      if(aydm.eq.0.0) aydm=5.0
      if(iwflag(3).eq.1) then
            write(6,206) ic,istdv,icont,ifunc,iwght,eps,dmpf,aydm,alp
     *             ,grad1,expn1,grad2,expn2
      end if
      call rdiobs(iwght)
      read(5,104) (ips(k),k=1,nu)
c     count the number of variable parameters (ij)
      ij=0
      do 73 j=1,nu
      if(ips(j).eq.0) go to 73
      ij=ij+1
 73   continue
c     check whether ij exceeds nxmax or not
      if(ij.gt.nxmax) then
c ****** input error
            write(6,213) iz,ij
            call quit(' ')
c ******
      end if
      do 121 j=1,nu
      iw(j)=' '
 121  if(ips(j).eq.0) iw(j)='*'
c*********************************************************************
c     beginning of least squars loop
c*********************************************************************
      do 50 ni=1,ic1
      ncycle=ncycle+1
      nn=ni-1
      je=ij
      do 31 j=1,je
 31   delt(j)=0.0
      jk=0
      do 32 j=1,je
      do 32 k=1,j
      jk=jk+1
 32   m(jk)=0.0
      if(ncycle.eq.1) then
          if(icont.eq.1) then
              rewind 4
              read(4,212) (x(j),j=1,nu)
              do 321 j=1,nu
 321          df(j)=0
          else
              do 322 j=1,nu
 322          df(j)=0
          end if
      end if
      write(6,209) nn
      if(iwflag(4).eq.4) then
c****   write initial and final fourier amplitudes
           if(ni.eq.1.or.ni.eq.ic1) then
               write(6,216) '(u,v,w,Bi,Ui:10**5, Beq,B,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
           call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,
     *                it,nl,1)
                write(6,202)
           end if
      else
           if(iwflag(4).eq.1.or.iwflag(4).eq.3) then
c*****   output fourier amplitudes in each cycle
               write(6,218) '(u,v,w,Bi,Ui:10**5, Beq,B,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
           call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,
     *                it,nl,1)
                write(6,202)
           end if
      end if
      if(iwflag(5).eq.1.or.iwflag(5).eq.3) then
c*****   output independent parameters in each cycle
           write(6,211)
           call wx(x,nu,iw)
      end if
      if(iwflag(5).eq.2.or.iwflag(5).eq.3) then
c****    output their difference in each cycle
          if(ni.ne.1) then
               write(6,214)
               call wx(df,nu,iw)
          end if
      end if
      rewind 4
      write(4,212) (x(j),j=1,nu)
c     calculate xjl,bjl,fjl
      call egvctr(x,ja,ea,nu,nzc,xjl,bjl,fjl,csb,it,nw,na,nl,
     *          xx,bx,px,isub)
c     calculate penalty function
      if(ipnf1.gt.0) call pnf1(pf1,delt,df,fjl,ja,ea,csb,
     *       m,ie,ips,x,ij,nw,na,nu)
      if(ipnf2.eq.1) call pnf2(pf2,delt,hl,ja,ea,csb1,csb2,
     *       m,ie,ips,x,ij,xx,isub,ifrt1,ifrt2,coeff,dl,nw,nu)
c     calculate structure factors
      call stfc(x,m,delt,de,df,r,rd,rw,ips,ie,ja,ea,xjl,bjl,fjl,
     *      csb,isft,isub,mpl,ij,z,isk,irs,cdr,cdi,it,nw,na,nu)
      total=sqrt(rw**2+pf1**2+pf2**2)
 51   write(6,201) nn,r,rd,rw,pf1,pf2,total
      do 401 j=1,nu
 401  y(j)=x(j)
c     stop conditions
      istop=0
      if(abs(total-totalo).lt.eps.or.nn.eq.ic
     *       .or.ij.eq.0) istop=1
      ro=rw
      pf1o=pf1
      pf2o=pf2
      totalo=total
c     calculations of new parameters
      q=0
      if(istop.eq.1.and.istdv.eq.1) q=1
      if(istop.eq.1.and.istdv.eq.1) dmp=0.0
      if(ij.eq.0) go to 60
c     solve the normal equation
      call chlsk(m,delt,de,je,q,ising,dmp,df)
      if(ising.eq.1) go to 81
      do 403 j=1,nu
 403  x(j)=y(j)
      if(ipol.eq.1) call txr(x)
      k=0
      do 40 j=1,nu
      if(ips(j).eq.0) go to 40
      k=k+1
      x(j)=x(j)+de(k)
 40   continue
      if(ipol.eq.1) call trx(x)
c     calculate differences
      do 41 j=1,nu
 41   df(j)=x(j)-y(j)
      if(istop.eq.1) go to 60
 50   continue
c*********************************************************************
c     end of least squars loop
c*********************************************************************
 60   continue
      if(istop.eq.0.or.istdv.eq.0.or.ij.eq.0) go to 81
c     calculate standard deviations
      do 71 j=1,nu
 71   z(j)=0.0
      if(nn.ne.ic.or.ij.eq.0) go to 12
      k=0
      kk=0
      nnnn=is(2)
      if(ipnf1.eq.1) nnnn=nnnn+na*nl
      if(ipnf2.eq.1) nnnn=nnnn+np*nl
      do 70 j=1,nu
      if(ips(j).eq.0) go to 70
      k=k+1
      kk=kk+k
      z(j)=dsqrt((rw**2+pf1**2+pf2**2)*m(kk)/(nnnn-je))
 70   continue
c***** output standard dev. of independent parameters
      if(iwflag(6).eq.1.or.iwflag(6).eq.3) then
           write(6,203)
           call wx(z,nu,iw)
      end if
 81   continue
c ***** beginning point of the next cycle
           if(iwflag(4).ge.1.and.iwflag(4).le.4.or.
     *        iwflag(5).ge.1.and.iwflag(5).le.3) then
                   write(6,210)
           end if
           if(iwflag(4).eq.1.or.iwflag(4).eq.3) then
c*****     fourier amplitudes of the next cycle
               write(6,218) '(u,v,w,Bi,Ui:10**5, Beq,B,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
           call prmtbl(x,df,isub,ips,na,nw,nu,nzc,ja,ea,xjl,bjl,fjl,
     *                it,nl,1)
                write(6,202)
           end if
      if(iwflag(5).eq.1.or.iwflag(5).eq.3) then
           write(6,211)
           call wx(x,nu,iw)
      end if
      if(iwflag(5).eq.2.or.iwflag(5).eq.3) then
           write(6,214)
           call wx(df,nu,iw)
      end if
c *******
      rewind 4
      write(4,212) (x(j),j=1,nu)
c ******  output standard dev. of fourier amplitudes
      if(istop.eq.0.or.istdv.eq.0.or.ij.eq.0) go to 123
      if(iwflag(6).eq.2.or.iwflag(6).eq.3) then
               write(6,208) '(u,v,w,Bi,Ui:10**5, Beq,B,p:10**3)'
     *                ,' (----) denotes a fixed parameter'
            call prmtbl(y,z,isub,ips,na,nw,nu,nzc,ja,ea,xx,bx,px,
     *                it,nl,2)
      end if
c *****   output structure factors
 123  write(6,202)
 12   call wtfhkl(fct,iwf,y)
c**********************************************************************
c     end of block loop
c**********************************************************************
      return
 101  format(i3)
 102  format(6i3)
 103  format(8f10.6)
 104  format(80i1)
 105  format(i3,f12.6)
 201  format(1h ,6hcycle ,i3,2x,2hr=,f7.4,2x,3hrd=,f7.4,2x,3hrw=,f7.4,
     *    2x,'pf1=',f7.4,2x,'pf2=',f7.4,2x,
     *    'sqrt(rw**2+pf1**2+pf2**2)=',f9.6)
 202  format(1h1)
 203  format(1h ,18hstandard deviation)
 206  format(1h , 'maximum cycles', 3x,i3,5x,
     *      'istdv=',i3,3x,'icont=',i3,3x,'ifunc=',i3,3x,
     *      'wght=',i3/1h ,'eps=',2x,f9.6,2x,
     *      'dmpf=',2x,f7.4,2x,'aydm=',2x,f7.4,2x,
     *      'alp=',f7.4,2x,'grad1=',f7.4,2x,'expn1=',f7.4,2x,
     *      'grad2=',f7.4,2x,'expn2=',f7.4)
 207  format(1h ,'final fourier amplitudes  (10**4)')
 208  format(1h ,'standard dev. of fourier amplitudes ',2a)
 209  format(1h ,'cycle',i3)
 210  format(1h ,'next cycle')
 211  format(1h ,'independent parametes (fixed parameters asterisked)')
 212  format(8e14.6)
 213  format(1h ,'number of variable parameters exceeded nxmax'/1h ,
     *                    'iextc=',i2,3x,i5,1x,'parameters')
 214  format(1h ,'difference')
 215  format(1h ,'damping factor .gt.10       dmp=',f10.4)
 216  format(1h ,'initial/final fourier amplitudes  ',2a)
 217  format(1h ,'iwf=',i3,2x,'fct=',f12.6)
 218  format(1h ,'fourier amplitudes ',2a)
 219  format(1h ,'differences of fourier amplitudes (10**4)')
      end

      subroutine chlsk(m,b,x,n,mi,isng,dmp,sqrtm)
c     solve the normal equation mx=b  where m is n*n real positive
c                  matrix
c     choleskis decomposition of matrix m to l*lt where l is lower
c     triangular matrix and lt is its transpose matrix
c     m is replaced by l
c     if mi=0,1   x is calculated
c     if mi=1,2   m is replaced by its inversion
      real m(1),b(1),x(1),sqrtm(1)
c     normalization
      ii=0
      ij=0
      do 10 i=1,n
      ii=ii+i
      sqrtm(i)=sqrt(m(ii))
      if(mi.ne.2) x(i)=b(i)/sqrtm(i)
      do 10 j=1,i
      ij=ij+1
      m(ij)=m(ij)/(sqrtm(i)*sqrtm(j))
 10   if(i.eq.j) m(ij)=m(ij)+dmp
c     choleskis decomposition
      isng=0
      i0=0
      do 11 i=1,n
      i0=i0+i-1
      j0=i0-i+1
      do 11 j=i,n
      j0=j0+j-1
      am=0.0
      do 12 k=1,i
      jk=j0+k
      ik=i0+k
      if(k.ne.i) am=am-m(jk)*m(ik)
 12   if(k.eq.i) am=am+m(jk)
      if(j.eq.i.and.am.le.0.0) go to 60
      if(j.eq.i) m(jk)=sqrt(am)
 11   if(j.ne.i) m(jk)=am/m(ik)

c     solution of normal equation
      if(mi.eq.2) go to 25
      ij=0
      do 20 i=1,n
      am=x(i)
      do 20 j=1,i
      ij=ij+1
      if(j.ne.i) am=am-m(ij)*x(j)
 20   if(j.eq.i) x(i)=am/m(ij)
      nn=n*(n+1)/2
      do 22 j=1,n
      i=n+1-j
      ki=nn+i
      am=x(i)
      do 22 kd=i,n
      k=n+i-kd
      ki=ki-k
      if(k.ne.i) am=am-m(ki)*x(k)
 22   if(k.eq.i) x(i)=am/m(ki)
      do 24 i=1,n
 24   x(i)=x(i)/sqrtm(i)
      if(mi.eq.0) return
c     matrix inversion of matrix l
 25   i0=0
      do 30 i=1,n
      i0=i0+i-1
      j0=i0-i+1
      do 31 j=i,n
      am=0.0
      if(j.eq.i) am=1.0
      j0=j0+j-1
      ki=i0+1
      do 31 k=i,j
      jk=j0+k
      ki=ki+k-1
      if(k.ne.j) am=am-m(jk)*m(ki)
 31   if(k.eq.j) m(ki)=am/m(jk)
 30   continue
c     matrix inversion of matrix m
      ij=0
      i0=0
      do 40 i=1,n
      i0=i0+i-1
      do 40 j=1,i
      am=0.0
      k0=i0-i+1
      do 41 k=i,n
      k0=k0+k-1
      ki=k0+i
      kj=k0+j
 41   am=am+m(ki)*m(kj)
      ij=ij+1
 40   m(ij)=am/(sqrtm(i)*sqrtm(j))
      return
 60   continue
      isng=1
      write(6,200)
 200  format(1h1,33hmatrix is singular or nonpositive)
      return
      end

      subroutine txr(x)
      dimension x(1)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
c      data eps/1.0e-50/
      data eps/1.0e-32/
      do 10 kr=1,i6,2
      ks=kr+1
      a=x(kr)
      b=x(ks)
      x(kr)=sqrt(a**2+b**2)
      if(abs(a).lt.eps.or.abs(b).lt.eps) go to 20
      x(ks)=atan2(-b,a)
      go to 10
 20   continue
      if(abs(a).lt.eps.and.abs(b).gt.eps) x(ks)=sign(pai2/4.0,-b)
      if(abs(b).lt.eps.and.a.gt.eps) x(ks)=0.0
      if(abs(b).lt.eps.and.-a.gt.eps) x(ks)=pai2/2.0
      if(abs(a).lt.eps.and.abs(b).lt.eps) x(ks)=0.0
 10   continue
      return
      end

      subroutine trx(x)
      dimension x(1)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      do 10 kr=1,i6,2
      ks=kr+1
      a=x(kr)
      b=x(ks)
      x(kr)=a*cos(b)
      x(ks)=-a*sin(b)
 10   continue
      return
      end

      subroutine prmtbl(x,df,isub,ips,na,nw,nx,nzc,ja,ea,xx,bx,px,
     *                it,nl,iw)
      dimension x(*),df(*),isub(*),ips(*),ja(4,*),ea(*),xx(6,*),
     *          bx(it,*),px(*)
      common /cdim/ idm,nde
      character*6 atom
      common /cltc/ atom(100)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3,3),gabn(3,3,3)
      dimension comp1(3),comp2(0:12),comp3(1),comp4(7),comp5(3),
     *          comp6(0:12),zx(20)
      integer wx(20),wy(20),ifrt(20)
      integer dspmdl,tmpmdl,sctmdl
      common /ceat/ eat(6,3),ebt(6,3)
      common /citfs/ itfs(100)
      character*4 comp1,comp2,comp3,comp4,comp5,comp6,aa,wc(20)
      data comp1 /'u','v','w'/,
     *     comp2 /'Beq','B1','B2','B3','B4','B5','B6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp3 /'p'/,
     *     comp4 /'B','B1''','B2''','B3''','B4''','B5''','B6'''/,
     *     comp5 /'x','y','z'/,
     *     comp6 /'Beq','U1','U2','U3','U4','U5','U6',
     *            'B1''','B2''','B3''','B4''','B5''','B6'''/
c****************************************************************
c    write atomic parameter table
c    iw=1: parameter table, iw=2: standard dev. table
c    iw=3: atomic parameters for a superstructure
c****************************************************************
      pi8=8*(3.141592)**2

      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      ncl=6
      kde=(nw-1)/ncl+1
      if(iw.eq.1.or.iw.eq.2) then
          do 12 kd=1,kde
              if(kd.eq.kde) ne=mod(nw-1,ncl)+1
              if(kd.ne.kde) ne=ncl
              do 13 k=1,ne
              ifrt(k)=k+ncl*(kd-1)
 13           continue
              if(kd.eq.1) write(6,202) (ifrt(k),k=1,ne)
              if(kd.ne.1) write(6,204) (ifrt(k),k=1,ne)
 12       continue
      end if
      write(6,201)
      do 10 i=1,na
      jk=isub(i)
      do 22 iy=1,3
      if(dspmdl.eq.0.and.iy.eq.1) go to 22
      if(tmpmdl.eq.0.and.iy.eq.2) go to 22
      if(sctmdl.eq.0.and.iy.eq.3) go to 22
      if(iy.eq.1) then   ! x,y,z
          is=i1
          ie=i2
          js=1
          je=3
          fact=100000
      else if(iy.eq.2) then  ! B or Bi, Ui
          is=i3
          ie=i4
          if(itempf.eq.0) then   ! isotropic
              js=1
              je=1
              fact=1000
          else if(itempf.gt.0) then ! anisotropic
             js=0               ! for Beq
             je=it
             fact=100000
          else if(itempf.lt.0) then
             js=0               ! for Beq
             je=it
             if(itfs(i).eq.0) then
                fact=100000
             else
                fact=100000
             end if
          end if
       else if(iy.eq.3) then  ! p
          is=i5
          ie=i6
          js=1
          je=1
          fact=1000
      end if
      do 11 j=js,je
      if(iw.eq.1.or.iw.eq.2) then
          do 111 kd=1,kde
          if(kd.ne.kde) ne=ncl
          if(kd.eq.kde) ne=mod(nw-1,ncl)+1
          do 210 k=1,ne
          if(j.ne.0) then    ! x,y,z, Bi/Ui ,p
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 31 l=2,is
 31               in=in+ja(4,l-1)
              end if
              do 220 ix=is,ie
              nz=ja(4,ix)
              do 21 n=1,nz
              in=in+1
              if(ja(1,in).eq.i.and.ja(2,in).eq.j.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                  ad=x(ix)*ea(in)
                  bd=df(ix)*ea(in)
                  if(iw.eq.1) then
c                    parameters and their differences
                       wx(k)=wx(k)+ad*fact
                       wy(k)=wy(k)+bd*fact
                       if(ips(ix).eq.1) then
 20                       write(wc(k),'(i4)') wy(k)
                       end if
                  else if(iw.eq.2) then
c                    parameters and their std.
                       wx(k)=wx(k)+ad*fact
                       zx(k)=zx(k)+bd**2
                       wy(k)=sqrt(zx(k))*fact
                       if(ips(ix).eq.1) then
                           write(wc(k),'(i4)') wy(k)
                       end if
                  end if
              end if
 21           continue
 220          continue
          else if(j.eq.0) then  ! Beq
              wx(k)=0.0
              wy(k)=0.0
              write(wc(k),'(a)') '----'
              zx(k)=0.0
              in=0
              if(is.ne.1) then
                  do 32 l=2,is
 32               in=in+ja(4,l-1)
              end if
              do 230 ix=is,ie
              nz=ja(4,ix)
c             calculation of Beq
              do 23 n=1,nz
              in=in+1
              if(abs(itempf).gt.0) then ! calculate Beq
                  if(ja(1,in).eq.i.and.ja(2,in).le.6.and.
     *                  ja(3,in).eq.k+(kd-1)*ncl) then
                     if(iw.eq.1) then
c                    parameters and their differences
                        if(itfs(i).eq.0) then
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                           wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact/100
                        else
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact
                           wy(k)=wy(k)+df(ix)*ebt(ja(2,in),jk)*fact
                        end if
                     else if(iw.eq.2) then
c                     parameters and their std.
                        if(itfs(i).eq.0) then
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact/100
                           zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        else
                           wx(k)=wx(k)+x(ix)*ebt(ja(2,in),jk)*fact
                           zx(k)=wy(k)+(df(ix)*ebt(ja(2,in),jk))**2
                        end if
                     end if
                  end if
              end if
              if(ips(ix).eq.1) then
                 if(itfs(i).eq.1) then
                    wy(k)=sqrt(zx(k))*fact/100
                    write(wc(k),'(i4)') wy(k)/100
                 else
                    wy(k)=sqrt(zx(k))*fact
                    write(wc(k),'(i4)') wy(k)
                 end if
              end if
 23           continue
 230          continue
          end if
 210      continue
          if(dspmdl.eq.1.and.iy.eq.1) then
              if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
              if(kd.eq.1) write(6,200) atom(i),comp1(j),
     *                     (wx(k),wc(k),k=1,ne)
          else if(tmpmdl.eq.1.and.iy.eq.2) then
             if(itempf.eq.1.or.(itempf.eq.-1.and.j.gt.0)) then  ! Bij
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp2(j),(wx(k),wc(k),k=1,ne)
             else if(itempf.eq.2.or.(itempf.eq.-2.and.j.gt.0))  then  ! Uij
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp6(j),(wx(k),wc(k),k=1,ne)
             else if(itempf.lt.0.and.j.eq.0) then    ! Beq
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp6(j),(wx(k)/100,wc(k),k=1,ne)
             else if(itempf.eq.0) then    ! B
                if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
                if(kd.eq.1) write(6,200) atom(i),
     *               comp4(j),(wx(k),wc(k),k=1,ne)
             end if
          else if(sctmdl.ne.0.and.iy.eq.3) then
             if(kd.ne.1) write(6,203) (wx(k),wc(k),k=1,ne)
             if(kd.eq.1) write(6,200) atom(i),
     *            comp3(j),(wx(k),wc(k),k=1,ne)
          end if
 111      continue
      end if
 11   continue
 22   continue
      write(6,201)
 10   continue
      if(itwin.ne.0) then
           ntwin=abs(itwin)
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(j,i)=0.
 802       continue
 801       continue
        if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+x(i)*ea(in)
 80        continue
           write(6,'('' twin domain volume ratio: '',8f12.6)')
     *       (volr(itw),itw=1,ntwin)
        write(6,201)
        end if
c       if(i10.gt.i8) then
c          phase shift
c           do 81 i=i9,i10
c           nz=ja(4,i)
c           do 81 n=1,nz
c           in=in+1
c           itw=ja(1,in)
c           j=ja(2,in)
c           dt(j,itw)=dt(j,itw)+x(i)*ea(in)
c 81        continue
c           write(6,'('' additional shift for twinoperators:'',6f12.6)')
c     *       ((dt(j,itw),j=1,6),itw=1,ntwin)
c           write(6,201)
c       end if
      end if
      write(6,'('' scale factors: '',6f12.6)') (x(i),i=i11,i12)
      if(isext.ne.0) then
         write(6,'('' extinction parameters: '',2f12.6)')
     *        (x(i),i=i13,i14)
      end if
      write(6,201)
 40   continue
      if(nde.eq.2) then
          aa=comp2(9)
          comp2(9)=comp2(12)
          comp2(12)=aa
          aa=comp4(4)
          comp4(4)=comp4(7)
          comp4(7)=aa
          aa=comp6(9)
          comp6(9)=comp6(12)
          comp6(12)=aa
      end if
      return
 200  format(1h ,a,1x,a4,6(i6,'(',a,')'))
 203  format(1h ,11x,    6(i6,'(',a,')'))
 201  format(1h )
 202  format(1h ,'fourier trm',6(i6,6x))
 204  format(1h ,'           ',6(i6,6x))
      end

      subroutine wx(x,nx,iw)
      dimension x(*),k(14),iw(*)
      common /const/ pai2,j(14)
      character*4 no,iw
      data no/'#'/
      ie=j(14)
      do 10 i=1,14
 10   k(i)=j(i)
      do 20 i=1,14,2
      if(k(i).le.k(i+1)) go to 20
      k(i)=0
      k(i+1)=0
 20   continue
c     write(6,204) (k(i),i=1,14)
      write(6,204) (k(i),i=1,8),(k(i),i=11,14)
      write(6,205) (no,i,x(i),iw(i),i=1,ie)
      write(6,203)
 203  format(1h )
 204  format(1h ,'dspl. (',i3,'-',i3,')',1x,'temp. (',i3,'-',i3,')',
     *    1x,'occup. (',i3,'-',i3,')',1x,'domain (',i3,'-',i3,')',
c    *    1x,'out of step (',i3,'-',i3,')',1x,'scale (',i3,'-',i3,')',
     *    1x,'scale (',i3,'-',i3,')',
     *    1x,'extinc. (',i3,'-',i3,')')
 205  format((1h ,8(a1,i3,1x,f8.5,a1,1x)))
      return
      end

      subroutine egvctr(r,ja,ea,nx,nzc,xjl,bjl,fjl,csb,it,
     *                   nw,na,nl,x,b,p,isub)
      dimension ea(*),ja(4,*),xjl(3,na,*),bjl(it,na,*),
     *   fjl(1,na,*),r(*),csb(nw,na,*),x(6,*),b(*),p(*),isub(*)
      common /const/ pai2,i1,i2,i3,i4,i5,i6,i7,i8,i9,i10,i11,i12,i13,i14
      common /bgn/ ilm(3),icorc(3),ilc(3),pxj(500,3),hj(500,3)
      common /jobctl/ dspmdl,tmpmdl,sctmdl,itempf,itwin,iphfl,volr(48)
      common /cctwn/ dt(6,48)
      common /cdim/ idm,nde
      integer dspmdl,tmpmdl,sctmdl
      common /ceat/ eat(6,3),ebt(6,3)
c
c     calculation of atomic position, temperature factor, and scattering
c     in modulated structure
c
      m=0
      do 70 ml=1,ilm(1)*ilm(2)*ilm(3)
      do 70 n1=1,ilc(1)*ilc(2)*ilc(3)
           m=m+1
           do 71 jk=1,na
           js=isub(jk)
           do 72 j=1,3
 72        xjl(j,jk,m)=x(j,jk)
           if(itempf.eq.0) then
               do 731 j=1,it
               if(j.eq.1) then
                   bjl(j,jk,m)=b(jk)
               else
                   bjl(j,jk,m)=0
               end if                
 731           continue
           else
               do 732 j=1,it
               if(j.le.6) then
                   bjl(j,jk,m)=b(jk)*eat(j,js)
               else
                   bjl(j,jk,m)=0
               end if
 732           continue
           end if
           fjl(1,jk,m)=p(jk)
 71        continue
           in=0
           do 74 i=i1,i6
           nz=ja(4,i)
           do 74 n=1,nz
           in=in+1
           jk=ja(1,in)
           if(jk.eq.0) go to 74
           j=ja(2,in)
           k=ja(3,in)
           if(i.gt.i2) go to 75
           xjl(j,jk,m)=xjl(j,jk,m)+r(i)*ea(in)*csb(k,jk,m)
           go to 74
 75        if(i.gt.i4) go to 76
           bjl(j,jk,m)=bjl(j,jk,m)+r(i)*ea(in)*csb(k,jk,m)
           go to 74
 76        if(sctmdl.eq.0) go to 74
           fjl(1,jk,m)=fjl(1,jk,m)+r(i)*ea(in)*csb(k,jk,m)
 74        continue
           if(sctmdl.ne.0) go to 70
           do 78 jk=1,na
 78        fjl(1,jk,m)=1.0
 70   continue
      if(itwin.eq.0) then
           volr(1)=1.0
      else
           ntwin=itwin
           do 801 i=1,ntwin
           volr(i)=0.
           do 802 j=1,6
           dt(i,j)=0.
 802       continue
 801       continue
      end if
      if(i8.gt.i6) then
c          twin volume
           do 80 i=i7,i8
                nz=ja(4,i)
           do 80 n=1,nz
                in=in+1
                itw=ja(1,in)
                volr(itw)=volr(itw)+r(i)*ea(in)
 80        continue
      end if
 82   continue
c      if(i10.gt.i8) then
cc          phase shift
c           do 81 i=i9,i10
c           nz=ja(4,i)
c           do 81 n=1,nz
c           in=in+1
c           itw=ja(1,in)
c           j=ja(2,in)
c           dt(itw,j)=dt(itw,j)+r(i)*ea(in)
c 81        continue
c      end if
 83   continue
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      stop
      end
